// This file is licensed under the terms of the CC-LGPL.
// 
// La version original fue hecha con el modelador Moray
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 16 agosto 2011
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY 
//
// ADVERTENCIA: El objeto es incompatible con POVRay 3.1.
//
// La macro ADPC_AvionDouglas()
// crea un avion comercial estilo Douglas
// En su version sin llantas descansa sobre el plano XY
// la cabeza hacia x+.
// La parte delantera de las alas principales
// sobre el origen.
// LargoPrincipal       = 40750*L
// AnchoTotal           = 37170*L
// AltoTotal            = 12740*L (con llantas)
// AltoTotal            = 10970*L (sin llantas)
// AnchoTronco          = 4780*L
// AltoTronco           = 4200*L
// AnchoAlasTraseras    = 15530*L
// AltoLlantas          = 1770*L
// Frente               = sobresale 15930*L en x+
// 
// El objeto se genera via la siguiente macro
// #macro ADPC_AvionDouglas
//              ( AnguloI1, AnguloI2, AnguloI3, AnguloI4, 
//                AnguloD1, AnguloD2, AnguloD3, AnguloD4 )
//          Nota: Angulos positivos hacia arriba.  Izquierda y derecha
//              respecto del piloto del avion. Numerados
//              de dentro hacia el exterior.
//      AnguloI1                : Giro del aleron interior izquierdo
//      AnguloI2                : Giro del segundo aleron izquierdo
//      AnguloI3                : Giro del tercer aleron izquierdo
//      AnguloI4                : Giro del cuarto aleron izquierdo
//      AnguloD1                : Giro del aleron interior derecho  
//      AnguloD2                : Giro del segundo aleron derecho   
//      AnguloD3                : Giro del tercer aleron derecho   
//      AnguloD4                : Giro del cuarto aleron derecho  
//
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)
// #declare ADPC_BanderaRueda   = on;
//      Valor off no dibuja las llantas, ni las puertecillas.
// 
// Para colocarlo simplemente
// #include "ADPC.inc"
// object { ADPC_AvionDouglas( 0,0,0,0,0,0,0,0 ) }
//
// O si se utiliza el modificador
// #include "ADPC.inc"
// #declare ADPC_BanderaRueda   = off;
// object { ADPC_AvionDouglas( 0,0,0,0,0,0,0,0 ) }
//
// AvionDouglasPersonalComputer   
   
//  Persistence of Vision Raytracer V3.5
//  World definition file.
//
//  Contains 1 lights, 2 materials and 116 primitives.
//
//  This file was generated for POV-Ray V3.5 by
//  Moray V3.5 For Windows Copyright (c) 1993-2003 Lutz + Kretzschmar
//

//  Date : 08/08/2011    (08.08.2011)
//

/*
  The text between these two comments is in MorayPOV.INC and is
  automatically included in all POV files that Moray exports.
*/
#include "ADPC.inc"

#include "colors.inc"

#declare OjoAbsoluto            = 256;
#declare VecesCentroAbsoluto    = 10;     
#declare L                      = 0.001;
camera {
        location  <   0,  0, -( VecesCentroAbsoluto+1 )*OjoAbsoluto >*L
        direction z
        sky       y
        angle     38.74
//        look_at  <   0,  0, -VecesCentroAbsoluto*OjoAbsoluto >*L
}         
light_source    {
         < 500  , 500   , -3000 >*L
         White
}
light_source    {
         < -500  , 500   , -3000 >*L
         White
}
background      {
         Gray50
}    
     
#declare ADPC_BanderaRueda              = off;
#local   FactorAcercamiento             = 1/38;

object          {
  ADPC_AvionDouglas( 10, 0, 10, -10, -10, 5, 0, -10 )
  rotate        -90*x
  translate     -7000*L*x
  translate     -( VecesCentroAbsoluto+1 )
         *( FactorAcercamiento-1 )/( FactorAcercamiento )*OjoAbsoluto*L*z
}