// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 12 setiembre 2011
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY 
//
// ATPS Almohadon Tela Para Sillon
// El archivo dibuja almohadones sencillos,
// cuya textura puede modificarse por redefinicion de variables.
// #macro ATPS_Almohadon( Modalidad )        
//      ATPS_ModoCuadrado       : almohadon de forma cuadrada. 
//      ATPS_ModoCircular       : almohadon de forma circular.      
//      ATPS_ModoCorazon        : almohadon de forma corazon.
//      ATPS_ModoCilindro       : almohadon de forma cilindro.
//
// Los almohadones cuadrado, cilindrico y corazon
// pueden encerrarse en un cuadrado de dimensiones :   
// < 440, 440, 125 >*L 
// En el modo cilindro:
// < 410, 190, 190 >*L
//
// Las siguientes variables no deberian modificarse
// ATPS_TexturaAlmohadon
//      Define una textura para el almohadon.
// ATPS_TexturaCilindro
//      Define una textura para el cilindro.
// ATPS_TexturaBorde
//      Define una textura para el borde.
// ATPS_TexturaBoton
//      Define una textura para el boton.
//
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)
// #declare ATPS_POV3_1                 = off;
//      Valor on activa modo de compatibilidad con POVRay 3.1.
//      En algunas versiones se activara automaticamente.
//      En esta version no tiene ningun efecto.
// #declare ATPS_DefaultTexturaAlmohadon        = texture { ... }      
//      Permite modificar la textura basica de los almohadones.
// #declare ATPS_DefaultTexturaCilindro         = texture { ... }      
//      Permite modificar la textura basica del cilidro.
// #declare ATPS_DefaultTexturaBorde            = texture { ... }      
//      Permite modificar la textura basica del borde.
// #declare ATPS_DefaultTexturaBoton            = texture { ... }      
//      Permite modificar la textura basica del boton.
//
// Para colocarlo simplemente
// #include "ATPS.inc"
// object { ATPS_Almohadon( ATPS_ModoCuadrado ) }
//
// Otro ejemplo con modificador
// #include "ATPS.inc"
// #include "textures.inc"
// #declare ATPS_DefaultTexturaAlmohadon        = texture       {
//   PinkAlabaster
// }
// #declare ATPS_DefaultTexturaCilindro         = texture       {
//   average
//   texture_map        {
//     [ 0.5 ATPS_TexturaCilindro ] 
//     [ 0.5 Rust                 ]
//   }
// }
// object       { ATPS_Almohadon( ATPS_ModoCilindro ) }
//

#include "textures.inc"
#include "colors.inc"
#include "ATPS_AUX.inc"

#declare ATPS_L                 = 0.001;

#if ( version < 3.2 )
  #ifndef( ATPS_POV3_1 )
    #declare ATPS_POV3_1        = on;
  #end
#else
  #ifndef( ATPS_POV3_1 )
    #declare ATPS_POV3_1        = off;
  #end
#end

#declare ATPS_TexturaAlmohadon = texture       {
  pigment       {
    quilted     
    control0    0.1
    control1    0.9
    scale       0.1  
    turbulence  0.1
    pigment_map         {
      [ 0.0 Brown ]
      [ 1.0 Pink  ]
    }
  }
  normal        {
    quilted
    control0    0.1
    control1    0.9
    scale       0.1
    turbulence  0.1
  }
}

#declare ATPS_TexturaCilindro  = texture       {
  pigment       {
    quilted     
    control0    0.1
    control1    0.9
    scale       0.1  
    turbulence  0.1
    pigment_map         {
      [ 0.0 Brown ]
      [ 1.0 Pink  ]
    }
  }
  normal        {
    quilted
    control0    0.1
    control1    0.9
    scale       0.1
    turbulence  0.1
  }
}

#declare ATPS_TexturaBorde     = texture       {
  pigment       {
    wrinkles
    scale       0.02
    pigment_map         {
      [ 0.0 Red   ]
      [ 0.1 Brown ]
    }
  }
  normal        {
    average
    turbulence  2.0
    normal_map  {
      [ 0.5 gradient x sine_wave scale   0.05 ]
      [ 0.5 gradient y sine_wave scale   0.05 ]
    }
  }
}

#declare ATPS_TexturaBoton     = texture       {
  pigment       {
    agate
    scale       0.1
    pigment_map         {
      [ 0.0 Brown ]
      [ 1.0 Firebrick   ]
    }
  }
  normal        {
    agate
    scale       0.1
  }
}

#ifndef ( ATPS_DefaultTexturaAlmohadon )
  #declare ATPS_DefaultTexturaAlmohadon        = texture       {
    ATPS_TexturaAlmohadon
  }
#end

#ifndef ( ATPS_DefaultTexturaCilindro )
  #declare ATPS_DefaultTexturaCilindro         = texture       {
    ATPS_TexturaCilindro
  }
#end

#ifndef ( ATPS_DefaultTexturaBorde )
  #declare ATPS_DefaultTexturaBorde            = texture       {
    ATPS_TexturaBorde
  }
#end

#ifndef ( ATPS_DefaultTexturaBoton )
  #declare ATPS_DefaultTexturaBoton            = texture       {
    ATPS_TexturaBoton
  }
#end

#declare ATPS_TotalPuntosMatrizBase1  = 10;
#declare ATPS_MatrizBase1             = 
                        array[ ATPS_TotalPuntosMatrizBase1 ]
        {
          < 0.00, 0.00, 0.00 >,
          < 0.50, 0.00, 0.02 >,
          < 1.00, 0.00,-0.01 >,
          < 1.00, 0.50,-0.02 >,
          < 1.00, 1.00, 0.01 >,
          < 0.50, 1.00, 0.01 >,
          < 0.00, 1.00, 0.00 >,
          < 0.00, 0.50,-0.01 >,
          < 0.00, 0.00, 0.00 >,
          < 0.50, 0.00, 0.02 >
        }
#declare ATPS_PuntoAlto1             = < 0.5,0.5,0.10>;

#declare ATPS_TotalPuntosMatrizBase2  = 10;
#declare ATPS_MatrizBase2             = 
                        array[ ATPS_TotalPuntosMatrizBase2 ]
        {
          < 0.15, 0.15, 0.00 >,
          < 0.50, 0.00, 0.02 >,
          < 0.85, 0.15,-0.01 >,
          < 1.00, 0.50,-0.02 >,
          < 0.85, 0.85, 0.01 >,
          < 0.50, 1.00, 0.01 >,
          < 0.15, 0.85, 0.00 >,
          < 0.00, 0.50,-0.01 >,
          < 0.15, 0.15, 0.00 >,
          < 0.50, 0.00, 0.02 >
        }
#declare ATPS_PuntoAlto2             = < 0.5,0.5,0.10>;

#declare ATPS_TotalPuntosMatrizBase3  = 10;
#declare ATPS_MatrizBase3             = 
                        array[ ATPS_TotalPuntosMatrizBase3 ]
        {
          < 0.15, 0.15, 0.00 >,
          < 0.50, 0.00, 0.02 >,
          < 0.90, 0.20,-0.01 >,
          < 1.00, 1.00,-0.02 >,
          < 0.85, 1.00, 0.01 >,
          < 0.50, 0.70, 0.01 >,
          < 0.15, 1.00, 0.00 >,
          < 0.00, 1.00,-0.01 >,
          < 0.10, 0.20, 0.00 >,
          < 0.50, 0.00, 0.02 >
        }
#declare ATPS_PuntoAlto3             = < 0.5,0.5,0.10>;  

#macro ATPS_Principal
        ( MatrizBase, PuntoAlto, Largo, Grueso, TexturaAlmohadon )
  merge         {
    #local C                    = 0;
    #local TotalCiclos          = dimension_size( MatrizBase, 1 )-2;
    #while ( C < TotalCiclos )
      object            {
        ATPS_TrianguloEsfericoTriplePunto(
          MatrizBase[ C+1 ]*Largo,
          PuntoAlto*Largo,
          MatrizBase[ C+2 ]*Largo,
          1.0*Largo, Grueso, true
        )
      }
      #local C                  = C+1;
    #end
    texture            {
      TexturaAlmohadon
    }
  }
#end

#macro ATPS_SoporteAlmohadon
        ( MatrizBase, PuntoAlto, FactorCorreccion, Largo,
                AnchoSoporte, GruesoSoporte, TexturaSoporte )
  union         {
    #local C                    = 0;
    #local TotalCiclos          = dimension_size( MatrizBase, 1 )-2;
    #local PuntoPivote          = <0,0,0>;
    #while ( C < TotalCiclos )
        #local PuntoMedio       = ( MatrizBase[ C ]+MatrizBase[ C+1 ] )/2;
        #local PuntoMedio       = <0.5,0.5,0>+
                        FactorCorreccion*( PuntoMedio-<0.5,0.5,0> );
        object          {
          ATPS_AnilloTriplePunto
                ( MatrizBase[ C ]*Largo, PuntoMedio*Largo,
                  MatrizBase[ C+1 ]*Largo,
                  AnchoSoporte, GruesoSoporte, true )
        }
      #local C                  = C+1;
    #end
    texture             {
      TexturaSoporte
    }
  }
#end

#declare ATPS_ModoCuadrado      = 1;
#declare ATPS_ModoCircular      = 2;
#declare ATPS_ModoCorazon       = 3;
#declare ATPS_ModoCilindro      = 4;

#macro ATPS_AlmohadonTelaParaSillon( Modalidad,
  LargoAlmohadon, GruesoAlmohadon,
  TexturaAlmohadon, TexturaCilindro, TexturaBorde, TexturaBoton )
  union         {
    #switch ( Modalidad )
      #case ( ATPS_ModoCuadrado )
    #local MyPrincipal  = object        {
      ATPS_Principal( ATPS_MatrizBase1, ATPS_PuntoAlto1, LargoAlmohadon,
                        GruesoAlmohadon, TexturaAlmohadon )
    }
    #local ATPS_PuntoAlto    = ATPS_PuntoAlto1;
      #break
      #case ( ATPS_ModoCircular )
    #local MyPrincipal  = object        {
      ATPS_Principal( ATPS_MatrizBase2, ATPS_PuntoAlto2, LargoAlmohadon,
                        GruesoAlmohadon, TexturaAlmohadon )
    }
    #local ATPS_PuntoAlto    = ATPS_PuntoAlto2;
      #break
      #case ( ATPS_ModoCorazon )
    #local MyPrincipal  = object        {
      ATPS_Principal( ATPS_MatrizBase3, ATPS_PuntoAlto3, LargoAlmohadon,
                        GruesoAlmohadon, TexturaAlmohadon )
    }
    #local ATPS_PuntoAlto    = ATPS_PuntoAlto3;
      #break
      #case ( ATPS_ModoCilindro )
    #local MyPrincipal  = object        {
      ATPS_Principal( ATPS_MatrizBase2, ATPS_PuntoAlto2, LargoAlmohadon,
                        GruesoAlmohadon, TexturaAlmohadon )
      translate LargoAlmohadon*z
    }
    #local ATPS_PuntoAlto    = ATPS_PuntoAlto2;
      #break
    #end
    object      {
      MyPrincipal
    }
    object      {
      MyPrincipal
      scale     <1,1,-1>
    }    
    #switch ( Modalidad )
      #case ( ATPS_ModoCuadrado )
    object      {
      ATPS_SoporteAlmohadon( ATPS_MatrizBase1, ATPS_PuntoAlto1, 1.05,
        LargoAlmohadon, 2*GruesoAlmohadon, 0.5*GruesoAlmohadon, TexturaBorde )
    }
      #break
      #case ( ATPS_ModoCircular )
    object      {
      ATPS_SoporteAlmohadon( ATPS_MatrizBase2, ATPS_PuntoAlto2, 1.05,
        LargoAlmohadon, 2*GruesoAlmohadon, 0.5*GruesoAlmohadon, TexturaBorde )
    }
      #break
      #case ( ATPS_ModoCorazon )
    object      {
      ATPS_SoporteAlmohadon( ATPS_MatrizBase3, ATPS_PuntoAlto3, 1.05,
        LargoAlmohadon, 2*GruesoAlmohadon, 0.5*GruesoAlmohadon, TexturaBorde )
    }
      #break
      #case ( ATPS_ModoCilindro )
    cylinder    {
      1.05*LargoAlmohadon*z,
      -1.05*LargoAlmohadon*z,
      1.05*LargoAlmohadon/2
      translate 1.0*LargoAlmohadon/2*y+1.0*LargoAlmohadon/2*x
      texture   {
        TexturaCilindro
      }
    }  
      #break
    #end
    cylinder    {
      ATPS_PuntoAlto*LargoAlmohadon*<1,1,1.3>,
      ATPS_PuntoAlto*LargoAlmohadon*<1,1,1.6>,
      0.075*LargoAlmohadon  
      #if ( Modalidad = ATPS_ModoCilindro )
        translate LargoAlmohadon*z
      #end
      texture   {
        TexturaBoton
      }
    }
    cylinder    {
      ATPS_PuntoAlto*LargoAlmohadon*<1,1,1.3>,
      ATPS_PuntoAlto*LargoAlmohadon*<1,1,1.6>,
      0.075*LargoAlmohadon
      #if ( Modalidad = ATPS_ModoCilindro )
        translate LargoAlmohadon*z
      #end
      scale     <1,1,-1>
      texture   {
        TexturaBoton
      }
    }     
    translate   -LargoAlmohadon/2*( x+y )
    #if ( Modalidad = ATPS_ModoCilindro )
      rotate    90*y
      scale     1/2
    #end
  }
#end

#macro ATPS_Almohadon( Modalidad )
  #local L                      = ATPS_L;
  #local LargoAlmohadon         = 357*L;
  #local GruesoAlmohadon        = 30*L;
  object        {
    ATPS_AlmohadonTelaParaSillon
        ( Modalidad, LargoAlmohadon, GruesoAlmohadon,
          ATPS_DefaultTexturaAlmohadon, 
          ATPS_DefaultTexturaCilindro,
          ATPS_DefaultTexturaBorde,
          ATPS_DefaultTexturaBoton )
  }
#end
