// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 12 setiembre 2011
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY 
//
// ATPS Almohadon Tela Para Sillon
// El archivo dibuja almohadones sencillos,
// cuya textura puede modificarse por redefinicion de variables.
// #macro ATPS_Almohadon( Modalidad )        
//      ATPS_ModoCuadrado       : almohadon de forma cuadrada. 
//      ATPS_ModoCircular       : almohadon de forma circular.      
//      ATPS_ModoCorazon        : almohadon de forma corazon.
//      ATPS_ModoCilindro       : almohadon de forma cilindro.
//
// Los almohadones cuadrado, cilindrico y corazon
// pueden encerrarse en un cuadrado de dimensiones :   
// < 440, 440, 125 >*L 
// En el modo cilindro:
// < 410, 190, 190 >*L
//
// Las siguientes variables no deberian modificarse
// ATPS_TexturaAlmohadon
//      Define una textura para el almohadon.
// ATPS_TexturaCilindro
//      Define una textura para el cilindro.
// ATPS_TexturaBorde
//      Define una textura para el borde.
// ATPS_TexturaBoton
//      Define una textura para el boton.
//
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)
// #declare ATPS_POV3_1                 = off;
//      Valor on activa modo de compatibilidad con POVRay 3.1.
//      En algunas versiones se activara automaticamente.
//      En esta version no tiene ningun efecto.
// #declare ATPS_DefaultTexturaAlmohadon        = texture { ... }      
//      Permite modificar la textura basica de los almohadones.
// #declare ATPS_DefaultTexturaCilindro         = texture { ... }      
//      Permite modificar la textura basica del cilidro.
// #declare ATPS_DefaultTexturaBorde            = texture { ... }      
//      Permite modificar la textura basica del borde.
// #declare ATPS_DefaultTexturaBoton            = texture { ... }      
//      Permite modificar la textura basica del boton.
//
// Para colocarlo simplemente
// #include "ATPS.inc"
// object { ATPS_Almohadon( ATPS_ModoCuadrado ) }
//
// Otro ejemplo con modificador
// #include "ATPS.inc"
// #include "textures.inc"
// #declare ATPS_DefaultTexturaAlmohadon        = texture       {
//   PinkAlabaster
// }
// #declare ATPS_DefaultTexturaCilindro         = texture       {
//   average
//   texture_map        {
//     [ 0.5 ATPS_TexturaCilindro ] 
//     [ 0.5 Rust                 ]
//   }
// }
// object       { ATPS_Almohadon( ATPS_ModoCilindro ) }
//

#include "colors.inc"

#local   OjoAbsoluto            = 256;
#local   VecesCentroAbsoluto    = 10;     
#local   L                      = 0.001;
camera {
        location  <   0,  0, -( VecesCentroAbsoluto+1 )*OjoAbsoluto >*L
        direction z
        sky       y
        angle     38.74
//        look_at  <   0,  0, -VecesCentroAbsoluto*OjoAbsoluto >*L
}         
light_source    {
         < 500  , 500   , -3000 >*L
         Gray80
}
light_source    {
         <-500  , 500   , -3000 >*L
         Gray80
}
background      {
         Gray50
}

#include "ATPS.inc"

object          {
  ATPS_Almohadon( ATPS_ModoCuadrado )
  translate     -400*L*x+300*L*y 
}


object          {
  ATPS_Almohadon( ATPS_ModoCircular )   
  translate     +400*L*x+300*L*y
}

object          {
  ATPS_Almohadon( ATPS_ModoCorazon  )
  translate     -400*L*x-300*L*y
}

object          {
  ATPS_Almohadon( ATPS_ModoCilindro )
  translate     +400*L*x-300*L*y
}
