// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 28 noviembre 2011
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY 
//
// CDTJ ColganteDecorativoToallasJabon
// El archivo dibuja un Set para colgar toallas y otros artefactos
// de limpieza personal
// La siguiente es la lista de macros basicas con las dimensiones
// Todos los objetos se dibujan inicialmente sobre el plano XZ,
//      El frente hacia Z-, gravedad hacia Y-.
// #macro CDTJ_CirculoToallaBasico( Angulo )
//      Angulo                  : Angulo en eje X para rotar el aro
//                                hacia el frente del colgante
// Caracteristicas
//      DiametroBase            = 55*L
//      Profundidad en Z        = 55*L
//      Radio Aro               = 55*L
//
// Puede dibujarse tambien con la siguiente macro
// #macro CDTJ_CirculoToalla( BaseRadio, BaseAlto, RadioAro, AnguloGiro,
//                  TexturaMetal, TexturaBlanca, TexturaPlastica )
//      BaseRadio               : Valor referencia para el radio
//                                de la base. Default es 22.5*L.
//      BaseAlto                : Valor referencia para la
//                                expansion Z de la base.
//                                Default es 21*L.
//      RadioAro                : Valor referencia para el radio
//                                del aro.  Default es 55*L.
//      AnguloGiro              : Giro del aro en grados hacia el frente.
//      TexturaMetal            : Textura a aplicar a zonas metalizadas.
//                                Default es GMGE_DefaultTexturaMetal.
//      TexturaBlanca           : Textura a aplicar a la base.
//                                Default es GMGE_DefaultTexturaBlanca.
//      TexturaPlastica         : Textura a aplicar a la zona de friccion
//                                del aro.
//                                Default es GMGE_DefaultTexturaPlastica.
//
// #macro CDTJ_SoporteToallaBasico()
// Caracteristicas
//      DiametroBase            = 55*L
//      Profundidad en Z        = 55*L
//      Largo Total             = 485*L
//
// Puede dibujarse tambien con la siguiente macro
// #macro CDTJ_SoporteToalla( BaseRadio, BaseAlto, LargoSoporte,
//                  TexturaMetal, TexturaBlanca, TexturaAuxiliar )
//      BaseRadio               : Valor referencia para el radio
//                                de la base. Default es 22.5*L.
//      BaseAlto                : Valor referencia para la
//                                expansion Z de la base.
//                                Default es 21*L.
//      LargoSoporte            : Valor del largo del colgante.
//                                Default es 430*L.
//      TexturaMetal            : Textura a aplicar a zonas metalizadas.
//                                Default es GMGE_DefaultTexturaMetal.
//      TexturaBlanca           : Textura a aplicar a la base.
//                                Default es GMGE_DefaultTexturaBlanca.
//      TexturaAuxiliar         : Textura a aplicar a la barra.
//                                Default es GMGE_DefaultTexturaMetal.
//
// #macro CDTJ_SoporteRopaBasico()
// Caracteristicas
//      DiametroBase            = 55*L
//      Profundidad total en Z  = 55*L
// Desciende 42*L en Y- desde el centro de la base.
//
// Puede dibujarse tambien con la siguiente macro
// #macro CDTJ_SoporteRopa( BaseRadio, BaseAlto, ProfundidadRopa,
//                  TexturaMetal, TexturaBlanca, TexturaAuxiliar )
//      BaseRadio               : Valor referencia para el radio
//                                de la base. Default es 22.5*L.
//      BaseAlto                : Valor referencia para la
//                                expansion Z de la base.
//                                Default es 21*L.
//      ProfundidadRopa         : Valor referencia para el colgante.
//                                Default es 50*L.
//      TexturaMetal            : Textura a aplicar a zonas metalizadas.
//                                Default es GMGE_DefaultTexturaMetal.
//      TexturaBlanca           : Textura a aplicar a la base.
//                                Default es GMGE_DefaultTexturaBlanca.
//      TexturaAuxiliar         : Textura a aplicar al colgante.
//                                Default es GMGE_DefaultTexturaMetal.
//
// #macro CDTJ_SoporteCepilloBasico()
// Caracteristicas
//      DiametroBase            = 55*L
//      Profundidad en Z        = 95*L
//      Ancho soporte cepillos  = 70*L
// Con aberturas para cuatro cepillos dentales corrientes.
//
// Puede dibujarse tambien con la siguiente macro
// #macro CDTJ_SoporteCepillo( BaseRadio, BaseAlto, DimensionSoporte,
//                  TexturaMetal, TexturaBlanca, TexturaAuxiliar )
//      BaseRadio               : Valor referencia para el radio
//                                de la base. Default es 22.5*L.
//      BaseAlto                : Valor referencia para la
//                                expansion Z de la base.
//                                Default es 21*L.
//      DimensionSoporte        : Valor refencia para el soporte
//                                de cepillos dentales.
//                                Default es 71*L
//      TexturaMetal            : Textura a aplicar a zonas metalizadas.
//                                Default es GMGE_DefaultTexturaMetal.
//      TexturaBlanca           : Textura a aplicar a la base.
//                                Default es GMGE_DefaultTexturaBlanca.
//      TexturaAuxiliar         : Textura a aplicar en la base de cepillos.
//                                Default es GMGE_DefaultTexturaMetal.
//
// #macro CDTJ_HBasico()
// Caracteristicas
//      DiametroBase            = 55*L
//      Profundidad total Z     = 100*L
//      Ancho total             = 105*L
// Descenso 65*L en Y- a partir del centro.
//
// Puede dibujarse tambien con la siguiente macro
// #macro CDTJ_H( BaseRadio, BaseAlto, DimensionH, GruesoH, AnguloVarilla,
//                  AnguloCubrir,
//                  TexturaMetal, TexturaBlanca, TexturaAuxiliar )
//      BaseRadio               : Valor referencia para el radio
//                                de la base. Default es 22.5*L.
//      BaseAlto                : Valor referencia para la
//                                expansion Z de la base.
//                                Default es 21*L.
//      DimensionH              : Referencia para el ancho.
//                                Default es 100*L.
//      GruesoH                 : Referencia para el grueso.
//                                Default es 60*L.    
//      AnguloVarilla           : Angulo de giro de la varilla 
//                                a partir de posicion base.
//                                Default es 0.
//      AnguloCubrir            : Angulo de giro de los protectores 
//                                metalicos a partir de posicion base.
//                                Default es 0.
//      TexturaMetal            : Textura a aplicar a zonas metalizadas.
//                                Default es GMGE_DefaultTexturaMetal.
//      TexturaBlanca           : Textura a aplicar a la base.
//                                Default es GMGE_DefaultTexturaBlanca.
//      TexturaAuxiliar         : Textura a aplicar a la placa protectora.
//                                Default es GMGE_DefaultTexturaMetal.
//
// #macro CDTJ_JaboneraBasico( VasoVisible )
//      VasoVisible             : on dibuja el vaso
//                                off no lo dibuja
// Caracteristicas
//      Diametro Base           = 55*L
//      Profundidad Total Z     = 95*L
//      Radio Soporte Vaso      = 44*L
//      Alto Vaso               = 67*L
//
// Puede dibujarse tambien con la siguiente macro
// #macro CDTJ_Jabonera( VasoVisible, BaseRadio, BaseAlto, RadioSoporte,
//                  AltoVaso, TexturaMetal, TexturaBlanca, TexturaVaso )
//      VasoVisible             : on dibuja el vaso
//                                off no lo dibuja
//      BaseRadio               : Valor referencia para el radio
//                                de la base. Default es 22.5*L.
//      BaseAlto                : Valor referencia para la
//                                expansion Z de la base.
//                                Default es 21*L.
//      RadioSoporte            : Valor referencia para el radio del vaso.
//                                Default es 21*L.
//      AltoVaso                : Valor del alto del vaso.
//                                Default es 67*L.
//      TexturaMetal            : Textura a aplicar a zonas metalizadas.
//                                Default es GMGE_DefaultTexturaMetal.
//      TexturaBlanca           : Textura a aplicar a la base.
//                                Default es GMGE_DefaultTexturaBlanca.
//      TexturaVaso             : Textura a aplicar al vaso.
//                                Default es GMGE_DefaultTexturaVaso.
//
// Estas son variables predefinidas que no deberian modificarse
// Si quiere modificarlas, recurra a los modificadores
// #declare CDTJ_TexturaMetal           = texture { ... }
//      Textura principal a aplicar a los soportes.
//      Se utilizara en la mayoria de las texturas auxiliares.
// #declare CDTJ_TexturaBlanca          = texture { ... }
//      Textura a aplicar a los soportes.
// #declare CDTJ_TexturaPlastica        = texture { ... }
//      Textura adicional para la zona de friccion entre
//      el aro para toallas y su soporte.
// #declare CDTJ_TexturaVaso            = texture { ... }
//      Textura a aplicar al vaso.
//
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario
// #declare CDTJ_POV3_1                 = off;
//      Valor on activa modo de compatibilidad con POVRay 3.1.
//      En algunas versiones se activara automaticamente.
//      En esta version no cumple ninguna funcion.
// #declare CDTJ_DefaultTexturaMetal    = texture { ... }
//      Textura default principal a aplicar a los soportes.
//      Se utilizara en la mayoria de las texturas auxiliares.
// #declare CDTJ_DefaultTexturaBlanca   = texture { ... }
//      Textura default a aplicar a los soportes.
// #declare CDTJ_DefaultTexturaPlastica = texture { ... }
//      Textura default adicional para la zona de friccion entre
//      el aro para toallas y su soporte.
// #declare CDTJ_DefaultTexturaVaso     = texture { ... }
//      Textura default a aplicar al vaso.
//
// Para colocarlo simplemente
// #include "CDTJ.inc"
// object { CDTJ_JaboneraBasico( on ) }
//
// Otro ejemplo con modificador
// #include "CDTJ.inc"
// #declare CDTJ_DefaultTexturaBlanca           = texture       {
//   PinkAlabaster
// }
// #declare CDTJ_DefaultTexturaMetal            = texture       {
//   average
//   texture_map        {
//     [ 0.5 CDTJ_TexturaMetal          ]
//     [ 0.5 Rust                       ]
//   }
// }
//
// object               {
//   CDTJ_SoporteToallaBasico()
// }
//

#include "colors.inc"
#include "metals.inc"
#include "stones.inc" 
#include "glass.inc"                 

#declare CDTJ_L                 = 0.001;

#if ( version < 3.2 )
  #ifndef( CDTJ_POV3_1 )
    #declare CDTJ_POV3_1        = on;
  #end
#else
  #ifndef( CDTJ_POV3_1 )
    #declare CDTJ_POV3_1        = off;
  #end
#end

#declare CDTJ_TexturaMetal      = texture       { 
  T_Chrome_4B   
  normal                {
    bumps
    scale       0.1
  }
}

#declare CDTJ_TexturaBlanca     = texture       {   
  T_Stone40
}

#ifndef ( CDTJ_DefaultTexturaMetal )
  #declare CDTJ_DefaultTexturaMetal             = texture       {
    CDTJ_TexturaMetal
  }
#end

#ifndef ( CDTJ_DefaultTexturaBlanca )
  #declare CDTJ_DefaultTexturaBlanca            = texture       {
    CDTJ_TexturaBlanca
  }
#end
 
#declare CDTJ_TexturaPlastica                   = texture       {
  pigment               {
    White
  }
}

#ifndef ( CDTJ_DefaultTexturaPlastica )
  #declare CDTJ_DefaultTexturaPlastica          = texture       {
    CDTJ_TexturaPlastica
  }
#end

#declare CDTJ_TexturaVaso                       = texture       {
  pigment               {
    MediumTurquoise     transmit      0.50
  }
  normal                {
    radial
    frequency   10
    sine_wave
    rotate      90*x
  }
  normal                {
    bumps
    scale               10*CDTJ_L
  }
}

#ifndef ( CDTJ_DefaultTexturaVaso )
  #declare CDTJ_DefaultTexturaVaso              = texture       {
    CDTJ_TexturaVaso
  }
#end

#macro CDTJ_BaseComun( BaseRadio, BaseAlto, TexturaMetal, TexturaBlanca )
  union                 {
    difference          {
      torus             {
        BaseRadio, BaseAlto/4
      }
      plane             {
        y               , 0
      }
      texture           {
        TexturaMetal
      }
    }
    sor                 {
      6,
      <0,0>,
      <1,0.25>,
      <1,0.5>,
      <0.55,0.75>,
      <0.35,1>,
      <0.35,1.1>
      scale             <BaseRadio,BaseAlto,BaseRadio>
      texture           {
        TexturaBlanca
      }
    }
  }
#end

#macro CDTJ_CirculoToalla( BaseRadio, BaseAlto, RadioAro, AnguloGiro,
                  TexturaMetal, TexturaBlanca, TexturaPlastica )
  union                 {
    CDTJ_BaseComun( BaseRadio, BaseAlto,
        TexturaMetal, TexturaBlanca )
    union               {
      sphere              {
        2.2*BaseAlto*y    , 0.46*BaseAlto
      }
      sor                 {
        8,
        <0.40,0.9>,
        <0.40,1>,
        <0.40,1.1>,
        <0.30,1.2>,
        <0.20,1.5>,
        <0.30,1.8>,
        <0.30,2.0>,
        <0.30,2.2>
        scale             <BaseRadio,BaseAlto,BaseRadio>
      }
      torus             {
        RadioAro, 0.225*BaseAlto
        translate       -RadioAro*z
        rotate          AnguloGiro*x
        translate       +2.2*BaseAlto*y
      }
      texture           {
        TexturaMetal
      }
    }
    cylinder            {
      -0.44*BaseAlto*x, 0.44*BaseAlto*x,
      0.275*BaseAlto
      translate         2.2*BaseAlto*y
      texture           {
        TexturaPlastica
      }
    }
    rotate        -90*x
  }
#end

#macro CDTJ_SoporteToalla( BaseRadio, BaseAlto, LargoSoporte,
                  TexturaMetal, TexturaBlanca, TexturaAuxiliar )
  #local SoporteLateral =
    union                 {
      CDTJ_BaseComun( BaseRadio, BaseAlto,
          TexturaMetal, TexturaBlanca )
      union               {
        sphere              {
          2.2*BaseAlto*y    , 0.46*BaseAlto
        }
        sor                 {
          8,
          <0.40,0.9>,
          <0.40,1>,
          <0.40,1.1>,
          <0.30,1.2>,
          <0.20,1.5>,
          <0.30,1.8>,
          <0.30,2.0>,
          <0.30,2.2>
          scale             <BaseRadio,BaseAlto,BaseRadio>
        }
        texture                   {
          TexturaMetal
        }
      }
    }
  union         {
    object      {
      SoporteLateral
      translate         -LargoSoporte/2*x
    }
    object      {
      SoporteLateral
      translate         +LargoSoporte/2*x
    }
    cylinder    {
      -LargoSoporte/2*x, +LargoSoporte/2*x,
      BaseAlto/4
      translate         2.2*BaseAlto*y
      texture   {
        TexturaAuxiliar
      }
    }
    rotate        -90*x
  }
#end

#macro CDTJ_SoporteRopa( BaseRadio, BaseAlto, ProfundidadRopa,
                  TexturaMetal, TexturaBlanca, TexturaAuxiliar )
  union                 {
    CDTJ_BaseComun( BaseRadio, BaseAlto,
        TexturaMetal, TexturaBlanca )
    union               {
      sphere              {
        1.5*BaseAlto*y    , 0.46*BaseAlto
      }
      cylinder          {
        1.5*BaseAlto*y  , 0.6*BaseAlto*y        ,
        0.28*BaseRadio
      }
      torus             {
        0.075*BaseAlto  , 0.075*BaseAlto
        translate       1.5*BaseAlto*y-0.4*BaseAlto*z
      }
      texture           {
        TexturaMetal
      }
    }
    union               {
      #local Esferitas  = <0.43,1,-0.52>*ProfundidadRopa;
      sphere            {
        Esferitas                       , 0.21*BaseAlto
      }
      sphere            {
        Esferitas*<-1,1,1>              , 0.21*BaseAlto
      }
      cylinder          {
        0               , Esferitas*<0,0,1>     ,
        0.075*BaseAlto
        translate       1.5*BaseAlto*y
      }
      #local Dist       =
                vlength( Esferitas-1.5*BaseAlto*y+0.52*ProfundidadRopa*z );
      difference        {
        torus             {
          Dist/2          , 0.075*BaseAlto
        }
        plane           {
          -z , 0
        }
        translate       Dist/2*x
        rotate          (90-degrees(asin(0.43*ProfundidadRopa/Dist)))*z
        translate       1.5*BaseAlto*y
        translate       -0.52*ProfundidadRopa*z
      }
      difference        {
        torus             {
          Dist/2          , 0.075*BaseAlto
        }
        plane           {
          -z , 0
        }
        translate       -Dist/2*x
        rotate          -(90-degrees(asin(0.43*ProfundidadRopa/Dist)))*z
        translate       1.5*BaseAlto*y
        translate       -0.52*ProfundidadRopa*z
      }
      texture           {
        TexturaAuxiliar
      }
    }
    rotate        -90*x
  }
#end

#macro CDTJ_SoporteCepillo( BaseRadio, BaseAlto, DimensionSoporte,
                  TexturaMetal, TexturaBlanca, TexturaAuxiliar )
  union                 {
    CDTJ_BaseComun( BaseRadio, BaseAlto,
        TexturaMetal, TexturaBlanca )
    union               {
      sor                 {
        9,
        <0.40,0.9>,
        <0.40,1>,
        <0.40,1.1>,
        <0.30,1.2>,
        <0.20,1.5>,
        <0.15,1.8>,
        <0.12,2.0>,
        <0.05,2.2>,
        <0.05,2.4>
        scale             <BaseRadio,BaseAlto,BaseRadio>
      }
      texture           {
        TexturaMetal
      }
    }
    difference          {
      superellipsoid    {
        <0.8,.1>
        scale    <DimensionSoporte/2,0.73*DimensionSoporte/2,0.08*BaseAlto>
      }
      #local C          = 0;
      #while ( C < 4 )
        superellipsoid    {
          <0.8,.1>
          scale    <DimensionSoporte/2,0.73*DimensionSoporte/2,0.08*BaseAlto>
          scale   <0.2,0.17,2.0>
          rotate          90*z
          translate       -4/10*DimensionSoporte*x
          rotate          20*z
          #switch (C)
            #case (2)
              rotate    140*z
            #break
            #case (1)
              rotate    -40*z
            #break
            #case (3)
              rotate    180*z
            #break
          #end
        }
        #local C        = C+1;
      #end
      cylinder          {
        -BaseAlto*z     , BaseAlto*z    ,
        0.31*DimensionSoporte
      }
      texture           {
        TexturaAuxiliar
      }
      translate         0.73*DimensionSoporte/2*y+2*BaseAlto*y
    }
    rotate        -90*x
  }
#end

#macro CDTJ_H( BaseRadio, BaseAlto, DimensionH, GruesoH, 
                  AnguloVarilla, AnguloCubrir,
                  TexturaMetal, TexturaBlanca, TexturaAuxiliar )
  union                 {
    CDTJ_BaseComun( BaseRadio, BaseAlto,
        TexturaMetal, TexturaBlanca )
    union               {
      sphere              {
        2.2*BaseAlto*y    , 0.46*BaseAlto
      }
      sor                 {
        8,
        <0.40,0.9>,
        <0.40,1>,
        <0.40,1.1>,
        <0.30,1.2>,
        <0.20,1.5>,
        <0.30,1.8>,
        <0.30,2.0>,
        <0.30,2.2>
        scale             <BaseRadio,BaseAlto,BaseRadio>
      }
      #local RadioDecorativo    = 0.1*DimensionH;
      union             {
        cylinder        {
          -( DimensionH/2-RadioDecorativo )*x,
          +( DimensionH/2-RadioDecorativo )*x,
          BaseAlto/9
        }
        difference      {
          torus         {
            RadioDecorativo     , BaseAlto/9
          }
          plane         {
            x,0
          }
          plane         {
            z,0
          }
          translate     -RadioDecorativo*z
          translate     ( DimensionH/2-RadioDecorativo )*x
        }
        difference      {
          torus         {
            RadioDecorativo     , BaseAlto/9
          }
          plane         {
            x,0
          }
          plane         {
            -z,0
          }
          translate     ( DimensionH/2-RadioDecorativo )*x
          translate     -( GruesoH-RadioDecorativo )*z
        }
        difference      {
          torus         {
            RadioDecorativo     , BaseAlto/9
          }
          plane         {
            -x,0
          }
          plane         {
            -z,0
          }
          translate     -( DimensionH/2-RadioDecorativo )*x
          translate     -( GruesoH-RadioDecorativo )*z
        }
        sphere          {
          0             , BaseAlto/6
          translate     -DimensionH/2*x
          translate     -( GruesoH-RadioDecorativo )*z
        }
        cylinder        {
          -( DimensionH/2-RadioDecorativo )*x,
          +( DimensionH/2-RadioDecorativo )*x,
          BaseAlto/9
          translate     -GruesoH*z
        }
        cylinder        {
          -RadioDecorativo*z,
          -( GruesoH-RadioDecorativo )*z,
          BaseAlto/9
          translate     +DimensionH/2*x
        }
        rotate          15*x
        rotate          AnguloVarilla*x
        translate       2.2*BaseAlto*y
      }
      texture             {
        TexturaMetal
      }
    }
    union               {
      difference        {
        prism           {
          BaseAlto/9,
          BaseAlto/8,
          7,
          < 0.8 , 0   >,
          < 1   , -0.2>,
          < 1   , -1  >,
          < -1  , -1  >,
          < -1  , -0.2>,
          < -0.8, 0   >,
          < 0.8 , 0   >
          scale         <0.83,1,1>*<DimensionH/2,1,GruesoH>
        }
        cylinder        {
          0             ,
          BaseAlto*y    ,
          0.6*BaseAlto
        }
      }
      difference        {
        cylinder        {
          -0.83*DimensionH/2*x          ,
          0.83*DimensionH/2*x           ,
          0.4*GruesoH*sqrt( 2 )
        }
        cylinder        {
          -DimensionH*x       , DimensionH*x        ,
          0.4*GruesoH*sqrt( 2 )-( 1/8-1/9 )*BaseAlto
        }
        plane           {
          -z    , 0
        }
        plane           {
          z     , 0
          rotate        -45*x
        }
        translate       -0.4*GruesoH*sqrt( 2 )*y
        translate       1/8*BaseAlto*y
        translate       -GruesoH*z
      }
      rotate            45*x    
      rotate            AnguloCubrir*x
      translate         2.2*BaseAlto*y
      texture           {
        TexturaAuxiliar
      }
    }
    rotate        -90*x
  }
#end

#macro CDTJ_Jabonera( VasoVisible, BaseRadio, BaseAlto, RadioSoporte,
                  AltoVaso, TexturaMetal, TexturaBlanca, TexturaVaso )
  union                 {
    CDTJ_BaseComun( BaseRadio, BaseAlto,
        TexturaMetal, TexturaBlanca )
    union               {
      sor                 {
        9,
        <0.40,0.9>,
        <0.40,1>,
        <0.40,1.1>,
        <0.30,1.2>,
        <0.20,1.5>,
        <0.15,1.8>,
        <0.12,2.0>,
        <0.05,2.1>,
        <0.05,2.2>
        scale             <BaseRadio,BaseAlto,BaseRadio>
      }
      #local RadioArito         = 0.12*BaseAlto;
      difference        {
        torus           {
          RadioSoporte  , RadioArito
        }
        cylinder        {
          -BaseAlto*y   , BaseAlto*y    ,
          RadioSoporte
        }
        rotate          90*x
        translate       ( 2*BaseAlto+RadioSoporte+RadioArito )*y
        
      }
      texture           {
        TexturaMetal
      }
    }
    #if ( VasoVisible )
      lathe               {
        10,
        <0,0>,
        <0.95,0>,
        <1,0.3>,
        <1.1,0.4>,
        <1.1,1>,
        <0.95,1>,
        <0.95,0.4>,
        <0.9,0.3>,
        <0.87,0.1>,
        <0,0.1>
        rotate            90*x
        scale             < RadioSoporte, RadioSoporte, AltoVaso >
        rotate            1
        texture         {
          TexturaVaso
        }
        translate         ( 2*BaseAlto+RadioSoporte+RadioArito )*y
        translate         -0.3*AltoVaso*z
      }
    #end
    rotate        -90*x
  }
#end

#macro CDTJ_CirculoToallaBasico( Angulo )
  #local L                      = CDTJ_L;
  #local BaseRadio              = 22.5*L;
  #local BaseAlto               = 21*L;
  #local RadioTorusToalla       = 55*L;
  CDTJ_CirculoToalla( BaseRadio, BaseAlto, RadioTorusToalla, Angulo,
        CDTJ_DefaultTexturaMetal, CDTJ_DefaultTexturaBlanca,
        CDTJ_DefaultTexturaPlastica )
#end

#macro CDTJ_SoporteToallaBasico()
  #local L                      = CDTJ_L;
  #local BaseRadio              = 22.5*L;
  #local BaseAlto               = 21*L;
  #local LargoSoporte           = 430*L;
  CDTJ_SoporteToalla( BaseRadio, BaseAlto, LargoSoporte,
        CDTJ_DefaultTexturaMetal, CDTJ_DefaultTexturaBlanca,
        CDTJ_DefaultTexturaMetal )
#end

#macro CDTJ_SoporteRopaBasico()
  #local L                      = CDTJ_L;
  #local BaseRadio              = 22.5*L;
  #local BaseAlto               = 21*L;
  #local ProfundidadRopa        = 50*L;
  CDTJ_SoporteRopa( BaseRadio, BaseAlto, ProfundidadRopa,
        CDTJ_DefaultTexturaMetal, CDTJ_DefaultTexturaBlanca,
        CDTJ_DefaultTexturaMetal )
#end

#macro CDTJ_SoporteCepilloBasico()
  #local L                      = CDTJ_L;
  #local BaseRadio              = 22.5*L;
  #local BaseAlto               = 21*L;
  #local DimensionSoporte       = 71*L;
  CDTJ_SoporteCepillo( BaseRadio, BaseAlto, DimensionSoporte,
        CDTJ_DefaultTexturaMetal, CDTJ_DefaultTexturaBlanca,
        CDTJ_DefaultTexturaMetal )
#end

#macro CDTJ_HBasico()
  #local L                      = CDTJ_L;
  #local BaseRadio              = 22.5*L;
  #local BaseAlto               = 21*L;
  #local DimensionH             = 100*L;
  #local GruesoH                = 60*L;
  CDTJ_H( BaseRadio, BaseAlto, DimensionH, GruesoH, 0, 0,
        CDTJ_DefaultTexturaMetal, CDTJ_DefaultTexturaBlanca,
        CDTJ_DefaultTexturaMetal )
#end

#macro CDTJ_JaboneraBasico( VasoVisible )
  #local L                      = CDTJ_L;
  #local BaseRadio              = 22.5*L;
  #local BaseAlto               = 21*L;
  #local RadioSoporte           = 21*L;
  #local AltoVaso               = 67*L;
  CDTJ_Jabonera( VasoVisible, BaseRadio, BaseAlto, RadioSoporte, AltoVaso,
        CDTJ_DefaultTexturaMetal, CDTJ_DefaultTexturaBlanca,
        CDTJ_DefaultTexturaVaso )
#end

