// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 24 octubre 2011
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY 
//
// GSCA GuitarraSeisCuerdasAfinada
// El archivo dibuja una guitarra en posicion default con la macro
// #macro GSCA_Guitarra()
// Las caracteristicas serian
//      Largo base en X         : 320*L
//      Largo total en X        : 650*L 
//      Ancho base en Y         : 240*L
//      Profundidad base en Z   : 58*L (sin cuerda y soporte)
// La guitarra descansa sobre el plano XY, y sobresale hacia Z-.
// La union entre la base y el brazo se proyecta al origen de coordenadas.
//
// #macro GSCA_GuitarraSeisCuerdasAfinada( LargoBase, AnchoBase, 
//                GruesoBase, LargoBrazo, FactorBrazo,
//                Madera1, Madera2, Madera3, DecoradoBorde, DecoradoLinea,
//                TexturaPlaca, TexturaMetal,
//                TexturaPlastico, Cuerda1, Cuerda2 )
//      LargoBase       : Se refiere al largo X del cuerpo principal
//      AnchoBase       : Se refiere al ancho Y del cuerpo principal
//      GruesoBase      : Se refiere a la profundidad en Z de la
//                        base, sin cuerda ni soporte
//      LargoBrazo      : Se refiere al largo del brazo con el mango
//      FactorBrazo     : Dato guia del ancho del brazo, en realidad
//                        un poco mayor
//      Madera1         : Textura de la madera aplicada
//                        en las laterales de la guitarra
//      Madera2         : Textura de la madera aplicada en
//                        los planos frontal y posterior de la guitarra
//      Madera3         : Textura de la madera aplicada en
//                        el interior de la guitarra
//      DecoradoBorde   : Textura del decorado de lineas blancas
//      DecoradoLinea   : Textura del decorado de lineas negras
//      TexturaPlaca    : Se refiere a las placas negras,
//                        que sirven de soporte a las cuerdas
//      TexturaMetal    : Textura para zonas metalizadas,
//                        como tornillos y similar
//      TexturaPlastico : Textura de las manijas
//                        de los tornillos y algunos soportes
//      Cuerda1         : Textura de las tres cuerdas mas gruesas
//      Cuerda2         : Textura de las tres cuerdas mas delgadas
//
// Estas son variables predefinidas que no deberian modificarse
// Si quiere modificarlas, recurra a los modificadores
// #declare GSCA_Madera1                = texture { ... }
//      Textura de la madera aplicada en los laterales de la guitarra
// #declare GSCA_Madera2                = texture { ... }
//      Textura de la madera aplicada en
//      los planos frontal y posterior de la guitarra
// #declare GSCA_Madera3                = texture { ... }
//      Textura de la madera aplicada en
//      el interior de la guitarra
// #declare GSCA_DecoradoBorde          = texture { ... }
//      Textura del decorado de lineas blancas
// #declare GSCA_DecoradoLinea          = texture { ... }
//      Textura del decorado de lineas negras
// #declare GSCA_TexturaPlaca           = texture { ... }
//      Se refiere a las placas negras, 
//      que sirven de soporte a las cuerdas
// #declare GSCA_TexturaMetal           = texture { ... }
//      Textura para zonas metalizadas, como tornillos y similar
// #declare GSCA_TexturaPlastico        = texture { ... }
//      Textura de las manijas de los tornillos y algunos soportes
// #declare GSCA_Cuerda1                = texture { ... }
//      Textura de las tres cuerdas mas gruesas
// #declare GSCA_Cuerda2                = texture { ... }
//      Textura de las tres cuerdas mas delgadas
//
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)
// #declare GSCA_POV3_1                 = off;
//      Valor on activa modo de compatibilidad con POVRay 3.1.
//      En algunas versiones se activara automaticamente.
//      En esta version no tiene ningun efecto.
// #macro GSCA_EstructuraBase( Largo, Ancho, Profundidad, BanderaSturm )
//      Permite cambiar la estructura de la base, con la idea
//      de respetar las dimensiones (Largo,Ancho,Profundidad)
//      BanderaSturm se conserva por compatibilidad con
//      la macro default.
//      Simplemente la base, por ejemplo un tipo prism sera suficiente.
//      Deberia definirse antes de la declaracion #include "GSCA.inc"
// #macro GSCA_EstructuraMango( Largo, Ancho, Profundidad, FactorProf,
//                LargoBrazo, AnchoBrazo, BanderaSturm )
//      Permite cambiar la estructura del mango final, lo cual
//      no se recomienda, pues la macro GSCA_GuitarraSeisCuerdasAfinada
//      agrega los tornillos y cuerdas, sin tomar en cuenta
//      el resultado de esta macro.
//      La base de la guitarra tiene dimensiones (Largo,Ancho,Profundidad)
//      LargoBrazo incluye el brazo total con el mango, y
//      AnchoBrazo se refiere a una estimacion superior del
//      ancho del mismo.
//      BanderaSturm se conserva por compatibilidad con la version default.
//      Permite modificar la textura final de las patas del anteojo.
//      Deberia definirse antes de la declaracion include "GSCA.inc"
// #declare GSCA_DefaultMadera1         = texture { ... }
//      Permite modificar la textura de la madera aplicada en
//      las laterales de la guitarra
// #declare GSCA_DefaultMadera2         = texture { ... }
//      Permite modificar la textura de la madera aplicada en
//      los planos frontal y posterior de la guitarra
// #declare GSCA_DefaultMadera3         = texture { ... }
//      Permite modificar la textura de la madera aplicada en
//      el interior de la guitarra
// #declare GSCA_DefaultDecoradoBorde   = texture { ... }
//      Textura que permite sustituir el decorado de lineas blancas
// #declare GSCA_DefaultDecoradoLinea   = texture { ... }
//      Textura que permite sustituir el decorado de lineas negras
// #declare GSCA_DefaultTexturaPlaca    = texture { ... }
//      Se refiere a las placas negras, que sirven de soporte a las cuerdas
// #declare GSCA_DefaultTexturaMetal    = texture { ... }
//      Para aplicar en zonas metalizadas, como tornillos y similar
// #declare GSCA_DefaultTexturaPlastico = texture { ... }
//      Para aplicar en las manijas de los tornillos y algunos soportes
// #declare GSCA_DefaultCuerda1         = texture { ... }
//      Textura para las tres cuerdas mas gruesas
// #declare GSCA_DefaultCuerda2         = texture { ... }
//      Textura para las tres cuerdas mas delgadas
//
// Para colocarlo simplemente
// #include "GSCA.inc"
// object { GSCA_Guitarra( ) }
//
// Otro ejemplo con modificador
// #include "GSCA.inc"
// #declare GSCA_DefaultTexturaPlaca            = texture       {
//   PinkAlabaster
// }
// #declare FSCA_DefaultMadera1                 = texture       {
//   average
//   texture_map        {
//     [ 0.5 APUD_Madera1 ]
//     [ 0.5 Rust         ]
//   }
// }
// object       { GSCA_Guitarra( ) }
//
// Y un ejemplo con la macro larga...
//
// #include "GSCA.inc"
// object       {
//   GSCA_GuitarraSeisCuerdasAfinada( 0.320, 0.240, 0.058, 0.348, 0.041,
//                PinkAlabaster, PinkAlabaster, PinkAlabaster,
//                PinkAlabaster, PinkAlabaster,
//                PinkAlabaster, PinkAlabaster,
//                PinkAlabaster, PinkAlabaster, PinkAlabaster )
// }
//

#include "woods.inc"

#if ( version < 3.2 )
  #ifndef( LRAV_POV3_1 )
    #declare LRAV_POV3_1        = on;
  #end
#else
  #ifndef( LRAV_POV3_1 )
    #declare LRAV_POV3_1        = off;
  #end
#end

#declare GSCA_L                 = 0.001;
#declare GSCA_S                 = seed( 1023 );

#declare GSCA_Madera1           = texture       {
  T_Wood20
}

#declare GSCA_Madera2           = texture       {
  T_Wood35
  translate     2
  scale         20
}

#declare GSCA_Madera3           = texture       {
  T_Wood5
}

#declare GSCA_TexturaPlastico   = texture       {
  pigment       {
    White
  }
}

#declare GSCA_DecoradoBorde     = texture       {
  pigment       {
    White
  }
}

#declare GSCA_DecoradoLinea     = texture       {
  pigment       {
    Black
  }
}

#declare GSCA_TexturaPlaca      = texture       {
  pigment       {               
    Black
  }
}

#declare GSCA_TexturaMetal      = texture       {
  pigment       {
    Silver
  }
}

#declare GSCA_Cuerda1           = texture       {
  pigment       {
    White
  }
}

#declare GSCA_Cuerda2           = texture       {
  pigment       {
    Gray80
  }
}

#declare GSCA_DefaultMadera1    = texture       {
  GSCA_Madera1
}

#declare GSCA_DefaultMadera2    = texture       {
  GSCA_Madera2
}

#declare GSCA_DefaultMadera3    = texture       {
  GSCA_Madera3
}

#declare GSCA_DefaultDecoradoBorde      = texture       {
  GSCA_DecoradoBorde
}

#declare GSCA_DefaultDecoradoLinea      = texture       {
  GSCA_DecoradoLinea
}

#declare GSCA_DefaultTexturaPlaca       = texture       {
  GSCA_TexturaPlaca
}

#declare GSCA_DefaultTexturaMetal       = texture       {
  GSCA_TexturaMetal
}

#declare GSCA_DefaultTexturaPlastico    = texture       {
  GSCA_TexturaPlastico
}

#declare GSCA_DefaultCuerda1            = texture       {
  GSCA_Cuerda1
}

#declare GSCA_DefaultCuerda2            = texture       {
  GSCA_Cuerda2
}

#ifndef ( GSCA_EstructuraBase )
#macro GSCA_EstructuraBase( Largo, Ancho, Profundidad, BanderaSturm )
  prism                 {
    #local Guia         = < Largo, Ancho/2 >;
    cubic_spline
    linear_sweep
    0                   ,
    Profundidad         ,
    11                  ,
    <  0.2              , -0.804        >*Guia,
    <  0                ,  0            >*Guia,
    <  0.2              ,  0.804        >*Guia,
    <  0.403            ,  0.516        >*Guia,
    <  0.778            ,  1.0          >*Guia,
    <  1.0              ,  0            >*Guia,
    <  0.778            , -1.0          >*Guia,
    <  0.403            , -0.516        >*Guia,
    <  0.2              , -0.804        >*Guia,
    <  0                ,  0            >*Guia,
    <  0.2              ,  0.804        >*Guia
    #if ( BanderaSturm )
      sturm
    #end
  }
#end
#end

#ifndef ( GSCA_EstructuraMango )
#macro GSCA_EstructuraMango( Largo, Ancho, Profundidad, FactorProf,
                LargoBrazo, AnchoBrazo, BanderaSturm )
  difference          {
    prism                 {
      #local Guia         = < 18/49*LargoBrazo, AnchoBrazo/2 >;
      cubic_spline
      linear_sweep
      -FactorProf*Profundidad*0.2     ,
      0                   ,
      11                  ,
      <  0.15             , -0.804        >*Guia,
      <  0                ,  0            >*Guia,
      <  0.15             ,  0.804        >*Guia,
      <  0.403            ,  1.516        >*Guia,
      <  0.878            ,  1.0          >*Guia,
      <  1.0              ,  0            >*Guia,
      <  0.878            , -1.0          >*Guia,
      <  0.403            , -1.516        >*Guia,
      <  0.15             , -0.804        >*Guia,
      <  0                ,  0            >*Guia,
      <  0.15             ,  0.804        >*Guia
      #if ( BanderaSturm )
        sturm
      #end
      translate           -LargoBrazo*x
    }
    plane             {
      x               , 0
      translate       -LargoBrazo*x-18/49*LargoBrazo*x
    }
    plane             {
      -z              , 0
      rotate          +5.00*y
    }
    cylinder          {
      -Profundidad*y  , +Profundidad*y        ,
      0.10*FactorBrazo
      translate       -LargoBrazo*x+ 5/49*LargoBrazo*x
      rotate          +3.00*y
    }
    cylinder          {
      -Profundidad*y  , +Profundidad*y        ,
      0.10*FactorBrazo
      translate       -LargoBrazo*x+13/49*LargoBrazo*x
      rotate          +3.00*y
    }
    box               {
      -Profundidad*y-0.10*FactorBrazo*z-LargoBrazo*x+ 5/49*LargoBrazo*x,
      +Profundidad*y+0.10*FactorBrazo*z-LargoBrazo*x+13/49*LargoBrazo*x
      rotate          +3.00*y
    }
    cylinder          {
      -Profundidad*y  , +Profundidad*y        ,
      0.10*FactorBrazo
      translate       -LargoBrazo*x+ 5/49*LargoBrazo*x
      rotate          -3.00*y
    }
    cylinder          {
      -Profundidad*y  , +Profundidad*y        ,
      0.10*FactorBrazo
      translate       -LargoBrazo*x+13/49*LargoBrazo*x
      rotate          -3.00*y
    }
    box               {
      -Profundidad*y-0.10*FactorBrazo*z-LargoBrazo*x+ 5/49*LargoBrazo*x,
      +Profundidad*y+0.10*FactorBrazo*z-LargoBrazo*x+13/49*LargoBrazo*x
      rotate          -3.00*y
    }
    plane             {
      z               , 0
      rotate          -5.00*y
    }
  }
#end
#end

#macro GSCA_GuitarraSeisCuerdasAfinada( LargoBase, AnchoBase, GruesoBase,
                LargoBrazo, FactorBrazo,
                Madera1, Madera2, Madera3, DecoradoBorde, DecoradoLinea,
                TexturaPlaca, TexturaMetal,
                TexturaPlastico, Cuerda1, Cuerda2 )
  union               {
    difference        {
      object          {
        GSCA_EstructuraBase( LargoBase, AnchoBase, 2*GruesoBase, off )
        translate     -0.5*GruesoBase*y
      }
      plane           {
        -y            , -GruesoBase
        texture       {
          Madera2
        }
      }
      plane           {
        y             , 0
        texture       {
          Madera2
        }
      }
      object          {
        GSCA_EstructuraBase( LargoBase, AnchoBase, GruesoBase, off )
        scale         0.95
        translate     GruesoBase*0.025*y+0.025*LargoBase*x
        texture       {
          Madera3
        }
      }
      cylinder        {
        0                     ,
        2*GruesoBase*y        ,
        0.095*LargoBase
        translate     GruesoBase*0.025*y+0.32*LargoBase*x
      }
      texture         {
        Madera1
      }
    }
    difference        {
      union           {
        object          {
          GSCA_EstructuraBase
                ( LargoBase, AnchoBase, 0.05*GruesoBase, off )
          scale         1.001
          translate     +0.95*GruesoBase*y-0.0005*LargoBase*x
        }
        object          {
          GSCA_EstructuraBase
                ( LargoBase, AnchoBase, 0.05*GruesoBase, off )
          scale         1.01
          translate     -0.01*GruesoBase*y-0.005*LargoBase*x
        }
      }
      object          {
        GSCA_EstructuraBase( LargoBase, AnchoBase, 2*GruesoBase, off )
        scale         0.97
        translate     0.015*x*LargoBase-0.2*GruesoBase*y
      }
      texture         {
        DecoradoBorde
      }
    }
    difference        {
      object          {
        GSCA_EstructuraBase( LargoBase, AnchoBase, 0.05*GruesoBase, off )
        scale         0.90
        translate     +0.98*GruesoBase*y+0.05*LargoBase*x
      }
      object          {
        GSCA_EstructuraBase( LargoBase, AnchoBase, 2*GruesoBase, off )
        scale         0.85
        translate     0.075*x*LargoBase
      }
      texture         {
        DecoradoLinea
      }
    }
    difference        {
      cylinder        {
        0             , 0.05*GruesoBase*y     ,
        0.11*LargoBase
        translate     +0.32*LargoBase*x+0.97*GruesoBase*y
      }
      cylinder        {
        0                     ,
        0.5*GruesoBase*y      ,
        0.105*LargoBase
        translate     GruesoBase*0.75*y+0.32*LargoBase*x
      }
      texture       {
        DecoradoLinea
      }
    }
    difference        {
      cylinder        {
        0             , 0.05*GruesoBase*y     ,
        0.125*LargoBase
        translate     +0.32*LargoBase*x+0.97*GruesoBase*y
      }
      cylinder        {
        0                     ,
        0.5*GruesoBase*y      ,
        0.12*LargoBase
        translate     GruesoBase*0.75*y+0.32*LargoBase*x
      }
      texture       {
        DecoradoLinea
      }
    }
    difference        {
      union           {
        #local LargoBaseCuerda        = 0.0625*LargoBase;
        #local AnchoBaseCuerda        = 0.50*AnchoBase;
        #local GruesoBaseCuerda       = 0.128*GruesoBase;
        box           {
          <  0        , 0     , -AnchoBaseCuerda/2    >,
          <  LargoBaseCuerda, GruesoBaseCuerda, AnchoBaseCuerda/2 >
        }
        cylinder      {
          0           , 1.05*GruesoBaseCuerda*y,
          1/4*GruesoBaseCuerda
          translate   3/4*LargoBaseCuerda*x-1/6*AnchoBaseCuerda*z
          texture     {
            DecoradoBorde
          }
        }
        cylinder      {
          0           , 1.05*GruesoBaseCuerda*y,
          1/4*GruesoBaseCuerda
          translate   3/4*LargoBaseCuerda*x+1/6*AnchoBaseCuerda*z
          texture     {
            DecoradoBorde
          }
        }
        cylinder      {
          0           , LargoBaseCuerda*x     ,
          1/3*GruesoBaseCuerda
          translate   +AnchoBaseCuerda/2*z
        }
        cylinder      {
          0           , LargoBaseCuerda*x     ,
          1/3*GruesoBaseCuerda
          translate   -AnchoBaseCuerda/2*z
        }
      }
      cylinder        {
        -0.1*LargoBaseCuerda*x, 1.1*LargoBaseCuerda*x     , 1
        scale       <1,3/3*GruesoBaseCuerda,1/3*AnchoBaseCuerda>
        translate   +AnchoBaseCuerda/2*z+4/3*GruesoBaseCuerda*y
      }
      cylinder        {
        -0.1*LargoBaseCuerda*x, 1.1*LargoBaseCuerda*x     , 1
        scale       <1,2/3*GruesoBaseCuerda,1/3*AnchoBaseCuerda>
        translate   -AnchoBaseCuerda/2*z+GruesoBaseCuerda*y
      }
      cylinder        {
        -AnchoBaseCuerda*z    , +AnchoBaseCuerda*z    ,
        1/3*GruesoBaseCuerda
        translate     +GruesoBaseCuerda*y+LargoBaseCuerda/2*x
      }
      translate       2/3*LargoBase*x+GruesoBase*y
      texture         {
        TexturaPlaca
      }
    }
    difference        {
      blob            {
        cylinder      {
          +0.35*LargoBase*x+GruesoBase*y      ,
          -31/49*LargoBrazo*x+GruesoBase*y    ,
          FactorBrazo/2
          strength    1.0
        }
        sphere        {
          0                   , FactorBrazo/2
          strength    0.40
          scale       <0.4,1,0.4>
        }
        sphere        {
          GruesoBase/8*y      , FactorBrazo/2
          strength    0.50
          scale       <0.5,1,0.5>
        }
        sphere        {
          GruesoBase/4*y      , FactorBrazo/2
          strength    0.60
          scale       <0.6,1,0.6>
        }
        sphere        {
          3*GruesoBase/8*y    , FactorBrazo/2
          strength    0.70
          scale       <0.7,1,0.7>
        }
        sphere        {
          GruesoBase/2*y      , FactorBrazo/2
          strength    0.80
          scale       <0.8,1,0.8>
        }
        sphere        {
          5*GruesoBase/8*y    , FactorBrazo/2
          strength    0.90
          scale       <1.20,1,0.9>
        }
        sphere        {
          GruesoBase/4*y*3    , FactorBrazo/2
          strength    1.0
          scale       <1.40,1,1>
        }
        threshold     0.1
        translate     -GruesoBase*y
        rotate        -1*z
        translate     +GruesoBase*y
      }
      plane           {
        -y            , -0.999*GruesoBase
      }
      plane           {
        y             , 0.001
      }
      cylinder        {
        0                     ,
        GruesoBase*y          ,
        0.12*LargoBase
        translate     GruesoBase*0.10*y+0.32*LargoBase*x
      }
      texture         {
        Madera1
      }
    }
    difference        {
      prism             {
        linear_spline
        linear_sweep
        0,
        GruesoBase*0.05,
        5,
        < +0.32*LargoBase       , -FactorBrazo*0.44     >,
        < +0.32*LargoBase       , +FactorBrazo*0.44     >,
        < -31/49*LargoBrazo     , +FactorBrazo*0.40     >,
        < -31/49*LargoBrazo     , -FactorBrazo*0.40     >,
        < +0.32*LargoBase       , -FactorBrazo*0.44     >
        translate       +GruesoBase*y
        texture         {
          TexturaPlaca
        }
      }
      cylinder        {
        0                     ,
        GruesoBase*y          ,
        0.10*LargoBase
        translate     GruesoBase*0.10*y+0.32*LargoBase*x
      }
    }
    intersection      {
      union           {
        #local CuentaBarrita  = 20;
        #local LargoTotal     = 0.22*LargoBase+31/49*LargoBrazo;
        #local CuentaInicial  = 10;
        #local FactorBarrita  = 30*31/2-9*10/2+3;
        #local C              = CuentaInicial;
        #local BaseDesplazado = LargoTotal/FactorBarrita;
        #local PosActual      =
              +0.22*LargoBase*x-BaseDesplazado*C*x+GruesoBase*1.05*y;
        #while ( C < ( CuentaBarrita+CuentaInicial+1 ) )
          cylinder            {
            -FactorBrazo/2*z  , FactorBrazo/2*z       ,
            0.05*FactorBrazo
            translate         PosActual
          }
          #switch ( C-CuentaInicial )
            #case(  6 )
            #case(  9 )
            #case( 11 )
            #case( 13 )
              cylinder      {
                0           , 0.02*GruesoBase*y,
                1/4*GruesoBaseCuerda
                translate   PosActual-C/2*BaseDesplazado*x
                texture     {
                  DecoradoBorde
                }
              }
            #break
          #end
          #local C            = C+1;
          #local PosActual            = -BaseDesplazado*C*x+PosActual;
        #end
      }
      prism             {
        linear_spline
        linear_sweep
        0,
        GruesoBase*0.2,
        5,
        < +0.32*LargoBase       , -FactorBrazo*0.44     >,
        < +0.32*LargoBase       , +FactorBrazo*0.44     >,
        < -31/49*LargoBrazo     , +FactorBrazo*0.40     >,
        < -31/49*LargoBrazo     , -FactorBrazo*0.40     >,
        < +0.32*LargoBase       , -FactorBrazo*0.44     >
        translate       +GruesoBase*1.05*y
      }
      texture         {
        TexturaMetal
      }
    }
    box               {
      < -0.05*FactorBrazo     , 0     , -FactorBrazo*0.37     >,
      < 0     , 0.15*GruesoBase       , +FactorBrazo*0.37     >
      translate       -31/49*LargoBrazo*x+GruesoBase*y
      texture         {
        TexturaPlastico
      }
    }
    #local C          = 0;
    #local FactorCuerda               = 0.8*FactorBrazo/6;
    #while ( C < 6 )
      cylinder        {
        ( C-2.5 )*FactorCuerda*z+( 1.15*GruesoBase )*y-31/49*LargoBrazo*x,
        ( C-2.5 )*FactorBrazo/6*z
        +( 1.10*GruesoBase )*y+2/3*LargoBase*x+0.8*LargoBaseCuerda*x,
        #switch ( C )
          #case ( 0 )
            0.006*GruesoBase
            texture           {
              Cuerda2
            }
          #break
          #case ( 1 )
            0.006*GruesoBase
            texture           {
              Cuerda2
            }
          #break
          #case ( 2 )
            0.007*GruesoBase
            texture           {
              Cuerda2
            }
          #break
          #case ( 3 )
            0.010*GruesoBase
            texture           {
              Cuerda1
            }
          #break
          #case ( 4 )
            0.008*GruesoBase
            texture           {
              Cuerda1
            }
          #break
          #case ( 5 )
            0.008*GruesoBase
            texture           {
              Cuerda1
            }
          #break
        #end
      }
      #if ( C < 3 )
        cylinder        {
          ( C-2.5 )*FactorCuerda*z+
          ( 1.15*GruesoBase )*y-31/49*LargoBrazo*x,
          LargoBrazo*cos( radians( -2-rand( GSCA_S ) ) )*x*
          (-1+9/49+(C-0.75)*3/49 )+0.9*GruesoBase*y+
          ( C-2 )*0.15*GruesoBase*y+
          LargoBrazo*sin( radians( -2-rand( GSCA_S ) ) )*z,
          0.01*GruesoBase
          texture     {
            Cuerda2
          }
        }
      #else
        cylinder        {
          ( C-2.5 )*FactorCuerda*z+
          ( 1.15*GruesoBase )*y-31/49*LargoBrazo*x,
          LargoBrazo*cos( radians(  2+rand( GSCA_S ) ) )*x*
          (-1+9/49+(C-3.75)*3/49 )+0.9*GruesoBase*y+
          ( C-5 )*0.15*GruesoBase*y+
          LargoBrazo*sin( radians(  2+rand( GSCA_S ) ) )*z,
          0.01*GruesoBase
          texture     {
            Cuerda1
          }
        }
      #end
      #local C        = C+1;
    #end
    union             {
      object            {
        GSCA_EstructuraMango( LargoBase, AnchoBase, GruesoBase, 1.0,
                        LargoBrazo, FactorBrazo, off )
        texture         {
          Madera2
        }
      }
      difference        {
        object            {
          GSCA_EstructuraMango( LargoBase, AnchoBase, GruesoBase,
                        0.05, LargoBrazo, FactorBrazo, off )
          translate             +LargoBrazo*x
          scale                 1.001
          translate           +0.005*GruesoBase*y
        }
        object            {
          GSCA_EstructuraMango( LargoBase, AnchoBase, GruesoBase,
                        1.0, LargoBrazo, FactorBrazo, off )
          translate             +LargoBrazo*x
          scale                 0.90
          translate
                0.05*LargoBrazo*18/49*x+0.1*GruesoBase*y
        }
        plane                 {
          -x                  , 0
          translate           16/49*LargoBrazo*x
        }
        translate               -LargoBrazo*x
        texture               {
          DecoradoBorde
        }
      }
      union                   {
        box                     {
          #local LargoMetal     = 8/49*LargoBrazo;
          < -LargoMetal/2       , -0.2*GruesoBase       ,
            0.04*GruesoBase     >,
          < +LargoMetal/2       , 0                     ,
           -0.04*GruesoBase     >
          translate         -LargoBrazo*x+9/49*LargoBrazo*x
          rotate                +5.00*y
          texture             {
            TexturaMetal
            normal    {
              hexagon
              rotate  90*x
              scale   0.001
            }
          }
        }
        box                     {
          #local LargoMetal     = 8/49*LargoBrazo;
          < -LargoMetal/2       , -0.2*GruesoBase       ,
            0.04*GruesoBase     >,
          < +LargoMetal/2       , 0                     ,
           -0.04*GruesoBase     >
          translate         -LargoBrazo*x+9/49*LargoBrazo*x
          rotate                -5.00*y
          texture     {
            TexturaMetal
            normal    {
              hexagon
              rotate  90*x
              scale   0.001
            }
          }
        }
        difference            {
          union               {
            #local C          = 0;
            #while ( C < 3 )
              cylinder          {
                -FactorBrazo*z    , +FactorBrazo*z        ,
                0.02*GruesoBase
                translate           -LargoBrazo*x+9/49*LargoBrazo*x
                                -0.1*GruesoBase*y
                translate       ( C-0.75 )*3/49*LargoBrazo*x
                texture       {
                  TexturaMetal
                  normal      {
                    gradient y
                    sine_wave
                    rotate    5*y
                    scale       0.001
                  }
                }
              }
              cylinder          {
                0               , -0.4*GruesoBase*y
                0.03*GruesoBase
                translate           -LargoBrazo*x+8/49*LargoBrazo*x
                translate       ( C-0.75 )*3/49*LargoBrazo*x
                rotate  -5.50*y
                texture       {
                  TexturaMetal
                  normal      {
                    gradient y
                    rotate    5*x
                    scale       0.001
                  }
                }
              }
              cylinder          {
                0               , -0.4*GruesoBase*y
                0.02*GruesoBase
                translate           -LargoBrazo*x+8/49*LargoBrazo*x
                translate       ( C-0.75 )*3/49*LargoBrazo*x
                rotate  +5.50*y
                texture       {
                  TexturaMetal
                  normal      {
                    gradient y
                    rotate    -5*x
                    scale       0.001
                  }
                }
              }
              #local C        = C+1;
            #end
          }
          plane               {
            +z        , 0
            rotate    -6.00*y
          }
          plane               {
            -z        , 0
            rotate    +6.00*y
          }
        }
        texture         {
          TexturaMetal
        }
      }
      union           {
        #local C      = 0;
        #while ( C < 3 )
          superellipsoid      {
            <0.7,0.5>
            scale     <0.1,0.07,0.03>*GruesoBase
            texture       {
              TexturaPlastico
            }
            rotate    rand( GSCA_S )*360*y
            translate -LargoBrazo*x+8/49*LargoBrazo*x-0.35*GruesoBase*y
            translate       ( C-0.75 )*3/49*LargoBrazo*x
            rotate    -5.50*y
          }
          superellipsoid      {
            <0.7,0.5>
            scale     <0.1,0.07,0.03>*GruesoBase
            texture       {
              TexturaPlastico
            }
            rotate    rand( GSCA_S )*360*y
            translate -LargoBrazo*x+8/49*LargoBrazo*x-0.35*GruesoBase*y
            translate       ( C-0.75 )*3/49*LargoBrazo*x
            rotate    +5.50*y
          }
          superellipsoid      {
            <1.0,0.3>
            scale     <0.06,0.06,0.03>*GruesoBase
            texture       {
              TexturaPlastico
              normal          {
                radial
                frequency     20
                rotate        90*x
              }
            }
            translate -LargoBrazo*x+8/49*LargoBrazo*x-0.10*GruesoBase*y
            translate       ( C-0.75 )*3/49*LargoBrazo*x
            rotate    -5.50*y
          }
          superellipsoid      {
            <1.0,0.3>
            scale     <0.06,0.06,0.03>*GruesoBase
            texture       {
              TexturaPlastico
              normal          {
                radial
                frequency     20
                rotate        90*x
              }
            }
            translate -LargoBrazo*x+8/49*LargoBrazo*x-0.10*GruesoBase*y
            translate       ( C-0.75 )*3/49*LargoBrazo*x
            rotate    +5.50*y
          }
          #local C            = C+1;
        #end
      }
      translate           +LargoBrazo*x-18/49*LargoBrazo*x
      rotate              +10*z
      translate
              -LargoBrazo*x+1.00*GruesoBase*y+18/49*LargoBrazo*x
    }
    pigment             {
      Green
    }
    rotate      -90*x
  }
#end

#macro GSCA_Guitarra()
  #local L                      = GSCA_L;
  #local LargoBase              = 320*L;
  #local AnchoBase              = 240*L;
  #local GruesoBase             = 58*L;
  #local LargoBrazo             = 220*L*49/31;
  #local FactorBrazo            = 41*L;
  object                {
    GSCA_GuitarraSeisCuerdasAfinada( LargoBase, AnchoBase, GruesoBase,
      LargoBrazo, FactorBrazo,
      GSCA_DefaultMadera1, GSCA_DefaultMadera2, GSCA_Madera3,
      GSCA_DefaultDecoradoBorde, GSCA_DefaultDecoradoLinea,
      GSCA_DefaultTexturaPlaca, GSCA_DefaultTexturaMetal,
      GSCA_DefaultTexturaPlastico, GSCA_DefaultCuerda1, GSCA_DefaultCuerda2
    )
  }
#end


