// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 24 octubre 2011
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY 
//
// GSCA GuitarraSeisCuerdasAfinada
// El archivo dibuja una guitarra en posicion default con la macro
// #macro GSCA_Guitarra()
// Las caracteristicas serian
//      Largo base en X         : 320*L
//      Largo total en X        : 650*L 
//      Ancho base en Y         : 240*L
//      Profundidad base en Z   : 58*L (sin cuerda y soporte)
// La guitarra descansa sobre el plano XY, y sobresale hacia Z-.
// La union entre la base y el brazo se proyecta al origen de coordenadas.
//
// #macro GSCA_GuitarraSeisCuerdasAfinada( LargoBase, AnchoBase, 
//                GruesoBase, LargoBrazo, FactorBrazo,
//                Madera1, Madera2, Madera3, DecoradoBorde, DecoradoLinea,
//                TexturaPlaca, TexturaMetal,
//                TexturaPlastico, Cuerda1, Cuerda2 )
//      LargoBase       : Se refiere al largo X del cuerpo principal
//      AnchoBase       : Se refiere al ancho Y del cuerpo principal
//      GruesoBase      : Se refiere a la profundidad en Z de la
//                        base, sin cuerda ni soporte
//      LargoBrazo      : Se refiere al largo del brazo con el mango
//      FactorBrazo     : Dato guia del ancho del brazo, en realidad
//                        un poco mayor
//      Madera1         : Textura de la madera aplicada
//                        en las laterales de la guitarra
//      Madera2         : Textura de la madera aplicada en
//                        los planos frontal y posterior de la guitarra
//      Madera3         : Textura de la madera aplicada en
//                        el interior de la guitarra
//      DecoradoBorde   : Textura del decorado de lineas blancas
//      DecoradoLinea   : Textura del decorado de lineas negras
//      TexturaPlaca    : Se refiere a las placas negras,
//                        que sirven de soporte a las cuerdas
//      TexturaMetal    : Textura para zonas metalizadas,
//                        como tornillos y similar
//      TexturaPlastico : Textura de las manijas
//                        de los tornillos y algunos soportes
//      Cuerda1         : Textura de las tres cuerdas mas gruesas
//      Cuerda2         : Textura de las tres cuerdas mas delgadas
//
// Estas son variables predefinidas que no deberian modificarse
// Si quiere modificarlas, recurra a los modificadores
// #declare GSCA_Madera1                = texture { ... }
//      Textura de la madera aplicada en los laterales de la guitarra
// #declare GSCA_Madera2                = texture { ... }
//      Textura de la madera aplicada en
//      los planos frontal y posterior de la guitarra
// #declare GSCA_Madera3                = texture { ... }
//      Textura de la madera aplicada en
//      el interior de la guitarra
// #declare GSCA_DecoradoBorde          = texture { ... }
//      Textura del decorado de lineas blancas
// #declare GSCA_DecoradoLinea          = texture { ... }
//      Textura del decorado de lineas negras
// #declare GSCA_TexturaPlaca           = texture { ... }
//      Se refiere a las placas negras, 
//      que sirven de soporte a las cuerdas
// #declare GSCA_TexturaMetal           = texture { ... }
//      Textura para zonas metalizadas, como tornillos y similar
// #declare GSCA_TexturaPlastico        = texture { ... }
//      Textura de las manijas de los tornillos y algunos soportes
// #declare GSCA_Cuerda1                = texture { ... }
//      Textura de las tres cuerdas mas gruesas
// #declare GSCA_Cuerda2                = texture { ... }
//      Textura de las tres cuerdas mas delgadas
//
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)
// #declare GSCA_POV3_1                 = off;
//      Valor on activa modo de compatibilidad con POVRay 3.1.
//      En algunas versiones se activara automaticamente.
//      En esta version no tiene ningun efecto.
// #macro GSCA_EstructuraBase( Largo, Ancho, Profundidad, BanderaSturm )
//      Permite cambiar la estructura de la base, con la idea
//      de respetar las dimensiones (Largo,Ancho,Profundidad)
//      BanderaSturm se conserva por compatibilidad con
//      la macro default.
//      Simplemente la base, por ejemplo un tipo prism sera suficiente.
//      Deberia definirse antes de la declaracion #include "GSCA.inc"
// #macro GSCA_EstructuraMango( Largo, Ancho, Profundidad, FactorProf,
//                LargoBrazo, AnchoBrazo, BanderaSturm )
//      Permite cambiar la estructura del mango final, lo cual
//      no se recomienda, pues la macro GSCA_GuitarraSeisCuerdasAfinada
//      agrega los tornillos y cuerdas, sin tomar en cuenta
//      el resultado de esta macro.
//      La base de la guitarra tiene dimensiones (Largo,Ancho,Profundidad)
//      LargoBrazo incluye el brazo total con el mango, y
//      AnchoBrazo se refiere a una estimacion superior del
//      ancho del mismo.
//      BanderaSturm se conserva por compatibilidad con la version default.
//      Permite modificar la textura final de las patas del anteojo.
//      Deberia definirse antes de la declaracion include "GSCA.inc"
// #declare GSCA_DefaultMadera1         = texture { ... }
//      Permite modificar la textura de la madera aplicada en
//      las laterales de la guitarra
// #declare GSCA_DefaultMadera2         = texture { ... }
//      Permite modificar la textura de la madera aplicada en
//      los planos frontal y posterior de la guitarra
// #declare GSCA_DefaultMadera3         = texture { ... }
//      Permite modificar la textura de la madera aplicada en
//      el interior de la guitarra
// #declare GSCA_DefaultDecoradoBorde   = texture { ... }
//      Textura que permite sustituir el decorado de lineas blancas
// #declare GSCA_DefaultDecoradoLinea   = texture { ... }
//      Textura que permite sustituir el decorado de lineas negras
// #declare GSCA_DefaultTexturaPlaca    = texture { ... }
//      Se refiere a las placas negras, que sirven de soporte a las cuerdas
// #declare GSCA_DefaultTexturaMetal    = texture { ... }
//      Para aplicar en zonas metalizadas, como tornillos y similar
// #declare GSCA_DefaultTexturaPlastico = texture { ... }
//      Para aplicar en las manijas de los tornillos y algunos soportes
// #declare GSCA_DefaultCuerda1         = texture { ... }
//      Textura para las tres cuerdas mas gruesas
// #declare GSCA_DefaultCuerda2         = texture { ... }
//      Textura para las tres cuerdas mas delgadas
//
// Para colocarlo simplemente
// #include "GSCA.inc"
// object { GSCA_Guitarra( ) }
//
// Otro ejemplo con modificador
// #include "GSCA.inc"
// #declare GSCA_DefaultTexturaPlaca            = texture       {
//   PinkAlabaster
// }
// #declare FSCA_DefaultMadera1                 = texture       {
//   average
//   texture_map        {
//     [ 0.5 APUD_Madera1 ]
//     [ 0.5 Rust         ]
//   }
// }
// object       { GSCA_Guitarra( ) }
//
// Y un ejemplo con la macro larga...
//
// #include "GSCA.inc"
// object       {
//   GSCA_GuitarraSeisCuerdasAfinada( 0.320, 0.240, 0.058, 0.348, 0.041,
//                PinkAlabaster, PinkAlabaster, PinkAlabaster,
//                PinkAlabaster, PinkAlabaster,
//                PinkAlabaster, PinkAlabaster,
//                PinkAlabaster, PinkAlabaster, PinkAlabaster )
// }
//

#include "colors.inc"

#local   OjoAbsoluto            = 256;
#local   VecesCentroAbsoluto    = 10;
#local   L                      = 0.001;
camera {
        location  <   0,  0, -( VecesCentroAbsoluto+1 )*OjoAbsoluto >*L
        direction z
        sky       y
        angle     38.74
//        look_at  <   0,  0, -VecesCentroAbsoluto*OjoAbsoluto >*L
}         
light_source    {
         < 500  , 500   , -3000 >*L
         White
}
background      {
         Gray50
}    

#include "GSCA.inc"

#local FactorAcercamiento       = 2.2;

object          {
  GSCA_Guitarra()    
  translate       -( VecesCentroAbsoluto+1 )
         *( FactorAcercamiento-1 )/( FactorAcercamiento )*OjoAbsoluto*L*z       
}

