// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 6 julio 2011
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY 
//
// LARN LapiceroAzulRojoNegro
// El archivo dibuja un lapicero sencillo.
// La forma mas simple es utilizar la siguiente macro.
// #macro LARN_Lapicero( ColorLapicero, BanderaEscritura )
//      ColorLapicero           : Vector de colorRGB, para la tapa
//              Se recomienda utilizar los colores predefinidos
//              LARN_Rojo, LARN_Azul y LARN_Negro
//      BanderaEscritura        : Si true dibuja el lapicero
//              con la tapa en posicion de escritura.
//              Si false esta cerrado ( Ver modificadores ).
// Las caracteristicas del lapicero son las siguientes.
// Cuando el lapicero esta cerrado, descansa en el eje y+.
// La base inferior en el origen centrado ( la estructura sin tapa ).
// LargoLapicero                : 105*L
// LargoLapicero con Tapa       : 114*L
// DiametroLapicero             : 6*L
// Grueso con Tapa              : 8*L (exceso en x+)
//
// Un poco mas flexible es la siguiente macro
// #macro LARN_LapiceroAzulRojoNegro
//       ( TexturaTapa, TexturaPrincipal, TexturaPlastica2,
//         TexturaTinta, TexturaPunta, TexturaPuntaFinal, BanderaEscritura )
//      TexturaTapa             : define la textura de la tapa.
//              La macro anterior utiliza texture { pigment { LARN_Rojo } },
//              o el color que se indique.
//      TexturaPrincipal        : se aplica en el tronco plastico.
//      TexturaPlastica2        : se aplica al tubito contenedor de tinta.
//      TexturaTinta            : se aplica a la tinta del lapicero.
//      TexturaPunta            : se aplica a la punta metalica
//      TexturaPuntaFinal       : se aplica a la punta fina, en el extremo.
//      BanderaEscritura        : si true el lapicero se encuentra
//              con la tapa en posicion de escritura, si false
//              el lapicero se encuentra cerrado.
//
// La tapa puede generarse independiente con la siguiente
// macro.  Aparece orientada hacia y+.  Su soporte principal
// en el origen, aunque con la agarradera curva prolongada hacia y-.
// Dicha agarradera esta en x+.
// Puede combinarse con el modificador LARN_TapaVisible en off.
// para animacion de la Tapa.
// #macro   LARN_TapaLapicero
//              ( DiametroLapicero, LargoLapicero, TexturaTapa )
//      DiametroLapicero        : Diametro principal del lapicero.
//              Default es LARN_DiametroLapicero
//      LargoLapicero           : Largo del tronco principal
//              del lapicero.  Utilizado como referencia
//              en el modelado de la tapa.
//              Default es LARN_LargoLapicero.
//      TexturaTapa             : Textura del objeto.
//              Default es texture { pigment { color LARN_Rojo } },
//              o el color que se aplique
//
// Las siguientes variables no deberian modificarse
// LARN_PosTapa
//      Vector 3D generado con el llamado a la macro.
//      Indica la colocacion de la tapa.
//      Se genera inclusive cuando no se dibuja la tapa;
//      Lo cual es util en animacion.
// LARN_DiametroLapicero
//      Define el diametro del tronco principal del lapicero.
// LARN_LargoLapicero
//      Define el largo del lapicero, sin la pata inferior.
// LARN_Rojo
//      Define el vector de color de tapa a aplicar en el lapicero Rojo.
// LARN_Azul
//      Define el vector de color de tapa a aplicar en el lapicero Azul.
// LARN_Negro
//      Define el vector de color de tapa a aplicar en el lapicero Negro.
// LARN_TexturaClaraPrincipal
//      Define la textura principal translucida del tronco.
// LARN_TexturaSegundaria
//      Define la textura plastica semitransparente del tubito de tinta.
// LARN_TexturaTinta
//      Define la textura de la tinta.
// LARN_TexturaPunta
//      Define la textura de la punta metalica
// LARN_TexturaPuntaFinal
//      Define la textura del extremo de la punta metalica,
//      algo mas brillante que la anterior.
//
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)
// #declare LARN_POV3_1         = off;
//      Valor on activa modo de compatibilidad con POVRay 3.1.
//      En algunas versiones se activara automaticamente.
// #declare LARN_TapaVisible    = on;
//      En estado off no dibuja la tapa.  Util en animacion.
// #declare LARN_DefaultTexturaClaraPrincipal   = texture ...
//      Define una textura principal del tronco translucido.
// #declare LARN_DefaultTexturaClaraSegundaria  = texture ...
//      Textura default a aplicar en la barrita semitransparente con tinta.
// #declare LARN_DefaultTexturaTinta            = texture ...
//      Textura default para la tinta.
// #declare LARN_DefaultTexturaPunta            = texture ...
//      Define una textura default para la punta del lapicero.
// #declare LARN_DefaultTexturaPuntaFinal       = texture ...
//      Otra textura default para el extremo final de la punta.
//
// Para colocarlo simplemente
// #include "LARN.inc"
// object { LARN_Lapicero( LARN_Negro, false ) }
//
// Otro ejemplo con modificador
// #include "LARN.inc"
// #declare "LARN_DefaultTexturaPuntaFinal       = texture       {
//   average
//   texture_map        {
//     [ 0.8 RCPS_Rust                          ]
//     [ 0.2 LARN_TexturaPuntaFinal             ]
//   }
// }
// #declare LARN_TapaVisible    = off;
// object       { LARN_Lapicero( LARN_Rojo, true ) }
// object       {
//   LARN_TapaLapicero( LARN_DiametroLapicero, LARN_LargoLapicero,
//                texture { pigment { LARN_Rojo } } )
//   scale      <1,-1,1>
//   translate  LARN_PosTapa-0.1*clock*y
// }
//


// LapiceroAzulRojoNegro
#if ( version < 3.2 )
  #ifndef( MFVS_POV3_1 )
    #declare MFVS_POV3_1        = on;
  #end
#else
  #ifndef( MFVS_POV3_1 )
    #declare MFVS_POV3_1        = off;
  #end
#end

#ifndef ( LARN_TapaVisible )
  #declare LARN_TapaVisible     = on;
#end

#declare LARN_Rojo              = <1.0,0.3,0.2>;

#declare LARN_Azul              = <0.2,0.3,1.0>;

#declare LARN_Negro             = <0.3,0.2,0.4>;

#declare LARN_L         = 0.001;

#declare LARN_DiametroLapicero  = 6*LARN_L;

#declare LARN_LargoLapicero     = 104*LARN_L;

#macro   LARN_TapaLapicero( DiametroLapicero, LargoLapicero, TexturaTapa )
  union               {
    difference        {
      union           {
        difference    {
          superellipsoid    {
            <       1       , 0.8   >
            rotate          90*x
            scale           < 0.6, 3*1.75, 0.6 >*DiametroLapicero
          }
          plane               {
            y , 0
          }
        }
        difference            {
          superellipsoid    {
            <       1       , 0.9   >
            rotate          90*x
            scale           < 0.9, 3*1.2, 0.3 >*DiametroLapicero
          }
          plane               {
            x         , 0
          }
          cylinder            {
            0         , -LargoLapicero*y      ,
            1.05*DiametroLapicero/2
          }
        }
      }
      plane           {
        -y    , -3*1.65*DiametroLapicero
      }
      superellipsoid    {
        <       1       , 0.8   >
        rotate          90*x
        scale           0.9*< 0.6, 3*1.75, 0.6 >*DiametroLapicero
      }
    }
    texture             {
      TexturaTapa
    }
  }
#end

#declare LARN_TexturaClaraPrincipal             = texture       {
  pigment       {
    rgbt        <0.9,0.8,1,0.8>
  }
}

#declare LARN_DefaultTexturaClaraPrincipal      = texture       {
  LARN_TexturaClaraPrincipal
}

#declare LARN_TexturaClaraSegundaria            = texture       {
  pigment       {
    rgbt        <0.9,0.8,1,0.75>
  }
}

#declare LARN_DefaultTexturaClaraSegundaria     = texture       {
  LARN_TexturaClaraSegundaria
}

#declare LARN_TexturaTinta                      = texture       {
  pigment       {
    rgb         <0.4,0.3,0.6>
  }
}

#declare LARN_DefaultTexturaTinta               = texture       {
  LARN_TexturaTinta
}

#declare LARN_TexturaPunta                      = texture       {
  pigment       {
    rgb         <0.9,0.8,0.2>
  }
}

#declare LARN_DefaultTexturaPunta               = texture       {
  LARN_TexturaPunta
}

#declare LARN_TexturaPuntaFinal                 = texture       {
  pigment       {
    rgb         <1.0,0.9,0.3>
  }
  finish        {
    metallic
  }
}

#declare LARN_DefaultTexturaPuntaFinal          = texture       {
  LARN_TexturaPuntaFinal
}

#macro LARN_LapiceroAzulRojoNegro
        ( TexturaTapa, TexturaPrincipal, TexturaPlastica2,
          TexturaTinta, TexturaPunta, TexturaPuntaFinal, BanderaEscritura )
  #local LargoLapicero          = LARN_LargoLapicero;
  #local DiametroLapicero       = LARN_DiametroLapicero;
  #local FraccionInterior       = 0.65;
  #local FraccionTranslatePunta = 0.93;
  union         {
    // Tronco Principal Hexagonal
    #local FraccionHexagonal    = 0.86;
    union               {
      difference          {
        union           {
          prism             {
            linear_sweep
            linear_spline
            0,
            FraccionHexagonal*LargoLapicero,
            7,
            #local C                  = 0;
            #while ( C < 7 )
              < DiametroLapicero/2*cos( radians( 60*C ) ),
                DiametroLapicero/2*sin( radians( 60*C ) ) >
              #local C                = C+1;
            #end
          }
          cone          {
            FraccionHexagonal*LargoLapicero*y           ,
            DiametroLapicero/2    ,
            FraccionTranslatePunta*LargoLapicero*y      ,
            ( 2*FraccionInterior+1 )/3*DiametroLapicero/2
          }
        }
        cylinder  {
          -LargoLapicero*y,
          +LargoLapicero*y,
          FraccionInterior*DiametroLapicero/2
        }
      }
      texture             {
        TexturaPrincipal
      }
    }
    // Tubo Tinta
    union               {
      #local FraccionTinta              = 1/2;
      #local FraccionInicioTinta        = 0.07;
      #local FraccionRellena            = 0.5;
      #local FraccionInicioRelleno      = 0.2;
      difference        {
        cylinder          {
          FraccionInicioTinta*LargoLapicero*y     ,
          0.95*LargoLapicero*y                         ,
          FraccionTinta*DiametroLapicero/2
        }
        cylinder          {
          0                     ,
          1.1*LargoLapicero*y   ,
          FraccionRellena*FraccionTinta*DiametroLapicero/2
        }
        texture         {
          TexturaPlastica2
        }
      }
      cylinder          {
        FraccionInicioRelleno*LargoLapicero*y   ,
        0.95*LargoLapicero*y                    ,
        0.99*FraccionRellena*FraccionTinta*DiametroLapicero/2
        texture         {
          TexturaTinta
        }
      }
    }
    // Tapita Inferior
    union               {
      #local FraccionInferior   = 0.04;
      #local RadioFinalInferior =
        sqrt( DiametroLapicero*DiametroLapicero
        +FraccionInferior*FraccionInferior*LargoLapicero*LargoLapicero )/2;
      #local ExcesoInferior     =
                RadioFinalInferior-FraccionInferior*LargoLapicero/2;
      cylinder          {
        0       , FraccionInferior*LargoLapicero*y      ,
        0.99*FraccionInterior*DiametroLapicero/2
      }
      difference        {
        sphere          {
          FraccionInferior*LargoLapicero/2*y,
          RadioFinalInferior
        }
        plane           {
          -y    , 0
        }
      }
      texture           {
        TexturaTapa
      }
    }
    // Punta Tinta
    union               {
      #local FraccionAnteriorPunta      = 0.07;
      cylinder          {
        0       , -FraccionAnteriorPunta*LargoLapicero*y      ,
        0.9*FraccionInterior*DiametroLapicero/2
      }
      cylinder          {
        0       , 0.2*( 1-FraccionTranslatePunta )*LargoLapicero*y      ,
        1.1*FraccionInterior*DiametroLapicero/2
      }
      cone              {
        0.2*( 1-FraccionTranslatePunta )*LargoLapicero*y        ,
        1.1*FraccionInterior*DiametroLapicero/2                 ,
        0.60*( 1-FraccionTranslatePunta )*LargoLapicero*y       ,
        0.75*FraccionInterior*DiametroLapicero/2
      }
      cone              {
        0.60*( 1-FraccionTranslatePunta )*LargoLapicero*y       ,
        0.65*FraccionInterior*DiametroLapicero/2                 ,
        0.90*( 1-FraccionTranslatePunta )*LargoLapicero*y       ,
        0.07*( 1-FraccionTranslatePunta )*LargoLapicero
        texture         {
          TexturaPuntaFinal
        }
      }
      sphere            {
        0.90*( 1-FraccionTranslatePunta )*LargoLapicero*y       ,
        0.07*( 1-FraccionTranslatePunta )*LargoLapicero
        texture         {
          TexturaTinta
        }
      }
      translate         FraccionTranslatePunta*LargoLapicero*y
      texture           {
        TexturaPunta
      }
    }
    // Tapa
    #if ( BanderaEscritura )
      #declare LARN_PosTapa   = FraccionInicioTinta*LargoLapicero*y;
    #else
      #declare LARN_PosTapa   = 0.85*FraccionTranslatePunta*LargoLapicero*y;
    #end
    #if ( LARN_TapaVisible )
      object              {
        LARN_TapaLapicero( DiametroLapicero, LargoLapicero, TexturaTapa )
        #if ( BanderaEscritura )
          scale           <1,-1,1>
          translate       LARN_PosTapa
        #else
          translate       LARN_PosTapa
        #end
      }
    #end
    translate           ExcesoInferior*y
    texture             {
      TexturaPrincipal
    }
  }
#end

#macro LARN_Lapicero( ColorLapicero, BanderaEscritura )
  #local TexturaTapa    = texture       {
    pigment     {
      color ColorLapicero
    }
  }
  object        {
    LARN_LapiceroAzulRojoNegro(
        TexturaTapa,
        LARN_DefaultTexturaClaraPrincipal,
        LARN_DefaultTexturaClaraSegundaria,
        LARN_DefaultTexturaTinta,
        LARN_DefaultTexturaPunta,
        LARN_DefaultTexturaPuntaFinal,
        BanderaEscritura )
  }
#end
