// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 10 junio 2011
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY 
//
// Las macro LRAV_LagartijaReptilAnimalVivo()
// crea el dibujo de una Lagartija en estilo 3D
// con el centro del tronco en el origen y la
// cabeza orientada hacia z+
// LargoTotal           : 1350*L (+400*L -950*L)*z
// ProfundidadTotal     : 180*L  (+ 90*L - 90*L)*y
// Ancho Sin Patas      : 240*L
// Ancho Con Patas      : 550*L
//
// La lagartija puede curvarse mediante una macro
// algo mas flexibe
// #macro LRAV_Lagartija( MyArreglo )
//
// #declare MyArreglo   = array [ GirosSolicitados ][ 4/5 ]
//      GirosSolicitados        : indica el total de giros a solicitar
//         El numero es libre, con un maximo de 55,
//         El giro tiene el siguiente formato
//        { IdentificadorGiro, RotarX, RotarY, RotarZ }
//         o bien este otro
//        { IdentificadorGiro, RotarX, RotarY, RotarZ, on/off }
//         la bandera off desactiva el giro, lo que podria ser util
//         al disenar.
//         Utiliza rotacion acumulada.
//         Cada tipo de giro solo debe encontarse una unica vez
//         en cualquier orden.
// IdentificadorGiro    : Numero o etiqueta clave que identifica el giro
// RotarX               : Indica la rotacion en grados respecto eje X*,
//        este es el eje X, luego de aplicar rotacion en
//        en otros puntos de control
//        LRAV_LagartijaReptilAnimalVivo() dibuja en la posicion base.
// RotarY               : Indica rotacion acumulada respecto eje Y*,
//        este es el eje Y luego de aplicar RotarX
// RotarZ               : Indica rotacion acumulada respecto eje Z*,
//        este es el eje Z luego de aplicar RotarX y RotarY
// on/off               : variable optativa,
//        si off no se gira, util en diseo y animacion.
//
// La siguiente es la lista de IdentificadorGiro admisibles:
//   Ejes en el tronco, en total 15 (atras es z- hacia cola y delante es z+)
// LRAV_EjeCentral        = Ubicado al centro del tronco
// LRAV_EjeCentralI01     = Ubicado atras de LRAV_EjeCentral
// LRAV_EjeCentralI02     = Ubicado atras de LRAV_EjeCentralI01
// LRAV_EjeCentralI03     = Ubicado atras de LRAV_EjeCentralI02
// LRAV_EjeCentralI04     = Ubicado atras de LRAV_EjeCentralI03
// LRAV_EjeCentralI05     = Ubicado atras de LRAV_EjeCentralI04
// LRAV_EjeCentralI06     = Ubicado atras de LRAV_EjeCentralI05
// LRAV_EjeCentralI07     = Ubicado atras de LRAV_EjeCentralI06
// LRAV_EjeCentralD01     = Ubicado delante de LRAV_EjeCentral
// LRAV_EjeCentralD02     = Ubicado delante de LRAV_EjeCentralD01
// LRAV_EjeCentralD03     = Ubicado delante de LRAV_EjeCentralD02
// LRAV_EjeCentralD04     = Ubicado delante de LRAV_EjeCentralD03
// LRAV_EjeCentralD05     = Ubicado delante de LRAV_EjeCentralD04
// LRAV_EjeCentralD06     = Ubicado delante de LRAV_EjeCentralD05
// LRAV_EjeCentralD07     = Ubicado delante de LRAV_EjeCentralD06
//   Ejes en la cola desde el tronco hacia atras ( en total 10 )
// LRAV_EjeCola01         = Ubicado atras del tronco
// LRAV_EjeCola02         = Ubicado atras de LRAV_EjeCola01
// LRAV_EjeCola03         = Ubicado atras de LRAV_EjeCola02
// LRAV_EjeCola04         = Ubicado atras de LRAV_EjeCola03
// LRAV_EjeCola05         = Ubicado atras de LRAV_EjeCola04
// LRAV_EjeCola06         = Ubicado atras de LRAV_EjeCola05
// LRAV_EjeCola07         = Ubicado atras de LRAV_EjeCola06
// LRAV_EjeCola08         = Ubicado atras de LRAV_EjeCola07
// LRAV_EjeCola09         = Ubicado atras de LRAV_EjeCola08
// LRAV_EjeCola10         = Ubicado atras de LRAV_EjeCola09
//   Ejes en la cabeza de detras hacia adelante
// LRAV_EjeCabeza01       = Ubicado en el cuello
// LRAV_EjeCabeza02       = Ubicado delante de LRAV_EjeCabeza01
//   Ejes en pata delantera izquierda (z+,x+)
// LRAV_EjeAntePataDI     = Ubicado a la salida de la pierna en tronco
// LRAV_EjePataDI         = Ubicado en la union pierna antepierna
// LRAV_EjeDedoExteriorDI = Ubicado en punto de union del dedo exterior
// LRAV_EjeDedoInteriorDI = Ubicado en punto de union del dedo interior
// LRAV_EjeDedoCentroExteriorDI   = Ubicado en punto de union
//              del dedo a la par exterior del dedo central
// LRAV_EjeDedoCentroInteriorDI   = Ubicado en punto de union
//              del dedo a la par interior del dedo central
// LRAV_EjeDedoMedioDI    = Ubicado en punto de union del dedo medio
//   Ejes en pata delantera derecha (z+,x-)
// LRAV_EjeAntePataDD     = Ubicado a la salida de la pierna en tronco
// LRAV_EjePataDD         = Ubicado en la union pierna antepierna
// LRAV_EjeDedoExteriorDD = Ubicado en punto de union del dedo exterior
// LRAV_EjeDedoInteriorDD = Ubicado en punto de union del dedo interior
// LRAV_EjeDedoCentroExteriorDD   = Ubicado en punto de union
//              del dedo a la par exterior del dedo central
// LRAV_EjeDedoCentroInteriorDD   = Ubicado en punto de union
//              del dedo a la par interior del dedo central
// LRAV_EjeDedoMedioDD    = Ubicado en punto de union del dedo medio
//   Ejes en pata trasera izquierda (z-,x+)
// LRAV_EjeAntePataTI     = Ubicado a la salida de la pierna en tronco
// LRAV_EjePataTI         = Ubicado en la union pierna antepierna
// LRAV_EjeDedoExteriorTI = Ubicado en punto de union del dedo exterior
// LRAV_EjeDedoInteriorTI = Ubicado en punto de union del dedo interior
// LRAV_EjeDedoCentroExteriorTI   = Ubicado en punto de union
//              del dedo a la par exterior del dedo central
// LRAV_EjeDedoCentroInteriorTI   = Ubicado en punto de union
//              del dedo a la par interior del dedo central
// LRAV_EjeDedoMedioTI    = Ubicado en punto de union del dedo medio
//   Ejes en pata trasera derecha (z-,x-)
// LRAV_EjeAntePataTD     = Ubicado a la salida de la pierna en tronco
// LRAV_EjePataTD         = Ubicado en la union pierna antepierna
// LRAV_EjeDedoExteriorTD = Ubicado en punto de union del dedo exterior
// LRAV_EjeDedoInteriorTD = Ubicado en punto de union del dedo interior
// LRAV_EjeDedoCentroExteriorTD   = Ubicado en punto de union
//              del dedo a la par exterior del dedo central
// LRAV_EjeDedoCentroInteriorTD   = Ubicado en punto de union
//              del dedo a la par interior del dedo central
// LRAV_EjeDedoMedioTD    = Ubicado en punto de union del dedo medio
//
// PREDEFINIDOS
// Las siguientes variables no deberian modificarse
// LRAV_TexturaDedo
//      Define la textura a aplicar en los dedos.
// LRAV_TexturaOjo
//      Define la textura del ojo.
// LRAV_TexturaCabeza
//      Define la textura a aplicar en la cabeza.
// LRAV_TexturaTronco
//      Define la textura a aplicar en el tronco.
// LRAV_TexturaCola
//      Define la textura a aplicar en la cola.
// LRAV_TexturaPata
//      Define la textura a aplicar en la pata.
// LRAV_TexturaAntePata
//      Define la textura a aplicar en la antepierna.
//
// MODIFICADORES
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)
// #declare LRAV_POV3_1         = off;
//      Valor on activa modo de compatibilidad con POVRay 3.1.
//      En algunas versiones se activara automaticamente.
// #declare LRAV_Textura2       = off;
//      Valor on aplica textura alternativa creada
//      por compatibilidad con POVRay 3.1. pero es una alternativa util.
//      Deberia declararse antes del #include para que funcione.
// #declare LRAV_BanderaBoca    = on;
//      Valor off elimina la boca.  Util si se quiere sustituir por un
//      mejor diseno.
// #declare LRAV_ColorBoca      = DarkGreen;
//      Permite cambiar el color de la boca.
// #declare LRAV_DefaultTexturaDedo                     = texture { ... }
//      Define la textura default a aplicar en los dedos.
// #declare LRAV_DefaultTexturaOjo                      = texture { ... }
//      Define la textura default del ojo.
// #declare LRAV_DefaultTexturaCabeza                   = texture { ... }
//      Define la textura default a aplicar en la cabeza.
// #declare LRAV_DefaultTexturaTronco                   = texture { ... }
//      Define la textura default a aplicar en el tronco.
// #declare LRAV_DefaultTexturaCola                     = texture { ... }
//      Define la textura default a aplicar en la cola.
// #declare LRAV_DefaultTexturaPata                     = texture { ... }
//      Define la textura default a aplicar en la pata.
// #declare LRAV_DefaultTexturaAntePata                 = texture { ... }
//      Define la textura default a aplicar en la antepierna.
//
// Para colocarlo simplemente
// #include "LRAV.inc"
// object { LRAV_LagartijaReptilAnimalVivo() }
//
// Otro ejemplo
// #include "LRAV.inc"
// #declare MFVS_DefaultTexturaDedo             = texture       {
//   average
//   texture_map        {
//     [ 0.5 Custom...                          ]
//     [ 0.5 LRAV_TexturaDedo                   ]
//   }
// }
// #declare MyArreglo   = array [ 2 ][ 4 ]
//      { { LRAV_EjeCentral, 0, 10, 0 },
//        { LRAV_EjeCola01 , 0,-10, 0 } }
// object       { LRAV_Lagartija( MyArreglo ) }
//

#include "colors.inc"

#if ( version < 3.2 )
  #ifndef( LRAV_POV3_1 )
    #declare LRAV_POV3_1        = on;
  #end
#else
  #ifndef( LRAV_POV3_1 )
    #declare LRAV_POV3_1        = off;
  #end
#end

#if ( LRAV_POV3_1 )
  #declare LRAV_Textura2        = on;
#end

#ifndef ( LRAV_Textura2 )
  #declare LRAV_Textura2        = off;
#end

#ifndef ( LRAV_BanderaBoca )   
  #declare LRAV_BanderaBoca     = on;
#end  

#ifndef ( LRAV_ColorBoca )
  #declare LRAV_ColorBoca       = DarkGreen;
#end

#declare LRAV_TexturaDedo       = texture       {
  pigment { color Sienna }
  finish  { ambient 0.3 diffuse 0.7 phong 1.0 phong_size 90 }
}

#ifndef ( LRAV_DefaultTexturaDedo )
  #declare LRAV_DefaultTexturaDedo      = texture       {
    LRAV_TexturaDedo
  }
#end  

#if ( LRAV_Textura2 )
#declare LRAV_TexturaOjo        = texture       {
  pigment       { Gray25 }
}
#else
#declare LRAV_TexturaOjo        = texture       {
  pigment     { 
      gradient x
      scale     0.4
      turbulence        0.2
      pigment_map       {
        [ 0.0 ForestGreen ]
        [ 0.45 ForestGreen ]
        [ 0.45 Black ] 
        [ 0.55 Black ]
        [ 0.55 White ]
        [ 0.80 White ]
        [ 0.80 ForestGreen ]
        [ 1.00 ForestGreen ]
      }
      
    } 
    normal      {
      agate
      scale     0.2      
    }
}
#end

#ifndef ( LRAV_DefaultTexturaOjo  )
  #declare LRAV_DefaultTexturaOjo       = texture       {
    LRAV_TexturaOjo 
  }
#end  

#declare LRAV_TexturaCabeza             = 
    texture {
      pigment {
        
        //agate scale 0.1
        #if ( LRAV_Textura2 )
          crackle turbulence 0.2 scale 0.1
        #else
          cells turbulence 0.2 scale 1.5
        #end
        pigment_map       {
          [ 0.0 DarkGreen   transmit 0.5 ]
          [ 1.0 ForestGreen transmit 0.5 ]
        }
      }
      pigment {
        
        agate 
      //  cells turbulence 0.2 scale 1.0
        pigment_map       {
          [ 0.0 DarkGreen   ]
          [ 1.0 ForestGreen ]
        }
      }
      normal    { 
        average
        #if ( LRAV_Textura2 )
          normal_map      {
            [ 0.2 agate scale        0.1  ]
            [ 0.8 crackle turbulence 0.2 scale  0.2 ]
          }
        #else
          normal_map      {
            [ 0.2 agate scale        0.1  ]
            [ 0.8 cells turbulence 0.2 scale  1.5 ]
          }
        #end
      }
      finish { ambient 0.3 diffuse 0.7 phong 0.2 phong_size 10 }
    }   


#ifndef ( LRAV_DefaultTexturaCabeza )
  #declare LRAV_DefaultTexturaCabeza    = texture       {
    LRAV_TexturaCabeza
  }
#end  

#if ( LRAV_Textura2 )
#declare LRAV_TexturaTronco     = 
    texture {
      pigment {        
        agate 
      //  cells turbulence 0.2 scale 1.0
        pigment_map       {
          [ 0.0 DarkGreen   ]
          [ 1.0 ForestGreen ]
        }
      }
      normal    {   
        agate
      }
      finish { ambient 0.3 diffuse 0.7 phong 0.2 phong_size 20 }
    }
#else
#declare LRAV_TexturaTronco     = 
    texture {
      pigment {        
        agate 
      //  cells turbulence 0.2 scale 1.0
        pigment_map       {
          [ 0.0 DarkGreen   ]
          [ 1.0 ForestGreen ]
        }
      }
      normal    {   
        agate
      }
      finish { ambient 0.3 diffuse 0.7 phong 0.2 phong_size 20 }
    }
    texture {
      pigment {
        //agate
        cells turbulence 0.3 scale 1.0
        pigment_map       {
          [ 0.0 DarkGreen   transmit 0.3 ]
          [ 1.0 ForestGreen transmit 0.3 ]
        }
      }
      normal    {   
        cells turbulence 0.3 scale 1.0
      }
      finish { ambient 0.3 diffuse 0.7 phong 0.2 phong_size 20 }
    }
#end

#ifndef ( LRAV_DefaultTexturaTronco )
  #declare LRAV_DefaultTexturaTronco    = texture       {
    LRAV_TexturaTronco
  }
#end  
     
#if ( LRAV_Textura2 )
#declare LRAV_TexturaCola       = 
    texture {
      pigment {        
        agate 
      //  cells turbulence 0.2 scale 1.0
        pigment_map       {
          [ 0.0 DarkGreen   ]
          [ 1.0 ForestGreen ]
        }
      }
      normal    {   
        agate
      }
      finish { ambient 0.3 diffuse 0.7 phong 0.2 phong_size 10 }
    }
#else
#declare LRAV_TexturaCola       = 
    texture {
      pigment {        
        agate 
      //  cells turbulence 0.2 scale 1.0
        pigment_map       {
          [ 0.0 DarkGreen   ]
          [ 1.0 ForestGreen ]
        }
      }
      normal    {   
        agate
      }
      finish { ambient 0.3 diffuse 0.7 phong 0.2 phong_size 10 }
    }
    texture {
      pigment {
        cells turbulence 0.3 scale 0.5

        pigment_map       {
          [ 0.0 DarkGreen   transmit 0.3 ]
          [ 1.0 ForestGreen transmit 0.3 ]
        }
      }
      normal    {   
        cells turbulence 0.3 scale 0.5

      }
      finish { ambient 0.3 diffuse 0.7 phong 0.2 phong_size 10 }
    }
#end

#ifndef ( LRAV_DefaultTexturaCola )
  #declare LRAV_DefaultTexturaCola      = texture       {
    LRAV_TexturaCola
  }
#end  
              
#if ( LRAV_Textura2 )
#declare LRAV_TexturaPata               = 
    texture {
      pigment {        
        agate 
      //  cells turbulence 0.2 scale 1.0
        pigment_map       {
          [ 0.0 DarkGreen   ]
          [ 1.0 ForestGreen ]
        }
      }
      normal    {   
        agate
      }
      finish { ambient 0.3 diffuse 0.7 phong 0.2 phong_size 10 }
    }
#else
#declare LRAV_TexturaPata               = 
    texture {
      pigment {        
        agate 
      //  cells turbulence 0.2 scale 1.0
        pigment_map       {
          [ 0.0 DarkGreen   ]
          [ 1.0 ForestGreen ]
        }
      }
      normal    {   
        agate
      }
      finish { ambient 0.3 diffuse 0.7 phong 0.2 phong_size 10 }
    }
    texture {
      pigment {
        cells turbulence 0.3 scale 1.0

        pigment_map       {
          [ 0.0 DarkGreen   transmit 0.3 ]
          [ 1.0 ForestGreen transmit 0.3 ]
        }
      }
      normal    {
        cells turbulence 0.3 scale 1.0

      }
      finish { ambient 0.3 diffuse 0.7 phong 0.2 phong_size 10 }
    }
#end

#ifndef ( LRAV_DefaultTexturaPata )
  #declare LRAV_DefaultTexturaPata      = texture       {
    LRAV_TexturaPata
  }
#end  

#declare LRAV_TexturaAntePata           = 
    texture {
      pigment {
        
        //agate scale 0.1
        #if ( LRAV_Textura2 )
          crackle turbulence 0.2 scale 0.1
        #else
          cells turbulence 0.2 scale 1.5
        #end
        pigment_map       {
          [ 0.0 DarkGreen   transmit 0.5 ]
          [ 1.0 ForestGreen transmit 0.5 ]
        }
      }
      pigment {
        
        agate 
      //  cells turbulence 0.2 scale 1.0
        pigment_map       {
          [ 0.0 DarkGreen   ]
          [ 1.0 ForestGreen ]
        }
      }
      normal    { 
        average
        #if ( LRAV_Textura2 )
          normal_map      {
            [ 0.2 agate scale        0.1  ]
            [ 0.8 crackle turbulence 0.2 scale  0.2 ]
          }
        #else
          normal_map      {
            [ 0.2 agate scale        0.1  ]
            [ 0.8 cells turbulence 0.2 scale  1.5 ]
          }
        #end
      }
      finish { ambient 0.3 diffuse 0.7 phong 0.2 phong_size 10 }
    }

#ifndef ( LRAV_DefaultTexturaAntePata )
  #declare LRAV_DefaultTexturaAntePata  = texture       {
    LRAV_TexturaAntePata
  }
#end  


#declare LRAV_IndiceTotal       = 8;
#declare LRAV_MovimientoTotal   = 56;

#declare LRAV_IndiceActual      = 0;                       
#declare LRAV_IndicePadre       = 1;                       
#declare LRAV_IndiceX           = 2;
#declare LRAV_IndiceY           = 3;
#declare LRAV_IndiceZ           = 4;
#declare LRAV_IndiceRotX        = 5;
#declare LRAV_IndiceRotY        = 6;
#declare LRAV_IndiceRotZ        = 7;


#declare LRAV_EjeBase           = 0; 
#declare LRAV_EjeCentral        = 1; 
#declare LRAV_EjeCentralI01     = 2;
#declare LRAV_EjeCentralI02     = LRAV_EjeCentralI01+1;
#declare LRAV_EjeCentralI03     = LRAV_EjeCentralI01+2;
#declare LRAV_EjeCentralI04     = LRAV_EjeCentralI01+3;
//
#declare LRAV_EjeCentralI05     = LRAV_EjeCentralI01+4;
#declare LRAV_EjeCentralI06     = LRAV_EjeCentralI01+5;
#declare LRAV_EjeCentralI07     = LRAV_EjeCentralI01+6;
#declare LRAV_EjeCentralD01     = 9;
#declare LRAV_EjeCentralD02     = LRAV_EjeCentralD01+1;
//
#declare LRAV_EjeCentralD03     = LRAV_EjeCentralD01+2;
#declare LRAV_EjeCentralD04     = LRAV_EjeCentralD01+3;
#declare LRAV_EjeCentralD05     = LRAV_EjeCentralD01+4;
#declare LRAV_EjeCentralD06     = LRAV_EjeCentralD01+5;
#declare LRAV_EjeCentralD07     = LRAV_EjeCentralD01+6;
//   
#declare LRAV_EjeCola01         = 16;
#declare LRAV_EjeCola02         = LRAV_EjeCola01+1;
#declare LRAV_EjeCola03         = LRAV_EjeCola01+2;
#declare LRAV_EjeCola04         = LRAV_EjeCola01+3;
#declare LRAV_EjeCola05         = LRAV_EjeCola01+4;
//
#declare LRAV_EjeCola06         = LRAV_EjeCola01+5;
#declare LRAV_EjeCola07         = LRAV_EjeCola01+6;
#declare LRAV_EjeCola08         = LRAV_EjeCola01+7;
#declare LRAV_EjeCola09         = LRAV_EjeCola01+8;
#declare LRAV_EjeCola10         = LRAV_EjeCola01+9; 
//
#declare LRAV_EjeCabeza01       = 26;
#declare LRAV_EjeCabeza02       = LRAV_EjeCabeza01+1;
#declare LRAV_EjeAntePataDI     = 28;  
#declare LRAV_EjePataDI         = LRAV_EjeAntePataDI+1;
#declare LRAV_EjeDedoExteriorDI = LRAV_EjeAntePataDI+2;
#declare LRAV_EjeDedoInteriorDI = LRAV_EjeAntePataDI+3;
#declare LRAV_EjeDedoCentroExteriorDI   = LRAV_EjeAntePataDI+4;
#declare LRAV_EjeDedoCentroInteriorDI   = LRAV_EjeAntePataDI+5;   
#declare LRAV_EjeDedoMedioDI    = LRAV_EjeAntePataDI+6;
#declare LRAV_EjeAntePataDD     = 35;
#declare LRAV_EjePataDD         = LRAV_EjeAntePataDD+1;
#declare LRAV_EjeDedoExteriorDD = LRAV_EjeAntePataDD+2;
#declare LRAV_EjeDedoInteriorDD = LRAV_EjeAntePataDD+3;
#declare LRAV_EjeDedoCentroExteriorDD   = LRAV_EjeAntePataDD+4;
#declare LRAV_EjeDedoCentroInteriorDD   = LRAV_EjeAntePataDD+5;   
#declare LRAV_EjeDedoMedioDD    = LRAV_EjeAntePataDD+6;
#declare LRAV_EjeAntePataTI     = 42;
#declare LRAV_EjePataTI         = LRAV_EjeAntePataTI+1;
#declare LRAV_EjeDedoExteriorTI = LRAV_EjeAntePataTI+2;
#declare LRAV_EjeDedoInteriorTI = LRAV_EjeAntePataTI+3;
#declare LRAV_EjeDedoCentroExteriorTI   = LRAV_EjeAntePataTI+4;
#declare LRAV_EjeDedoCentroInteriorTI   = LRAV_EjeAntePataTI+5;   
#declare LRAV_EjeDedoMedioTI    = LRAV_EjeAntePataTI+6;
#declare LRAV_EjeAntePataTD     = 49;
#declare LRAV_EjePataTD         = LRAV_EjeAntePataTD+1;  
#declare LRAV_EjeDedoExteriorTD = LRAV_EjeAntePataTD+2;
#declare LRAV_EjeDedoInteriorTD = LRAV_EjeAntePataTD+3;
#declare LRAV_EjeDedoCentroExteriorTD   = LRAV_EjeAntePataTD+4;
#declare LRAV_EjeDedoCentroInteriorTD   = LRAV_EjeAntePataTD+5;   
#declare LRAV_EjeDedoMedioTD    = LRAV_EjeAntePataTD+6;
           
// CUIDADO!!!
// Aparte de varios ajustes con simetria esferica
// el tronco, la cola y la cabeza
// tienen una correccion de escala <1,0.75,1>
// Las rotaciones sin embargo, se calculan
// ANTES de aplicar esta correccion.
// Lo siento...           
#declare LRAV_Movimiento        = 
        array [ LRAV_MovimientoTotal ][ LRAV_IndiceTotal ]     
  {
    { LRAV_EjeBase            , LRAV_EjeBase                  ,
                0             , 0             , 0             ,       
                0             , 0             , 0             },
    { LRAV_EjeCentral         , LRAV_EjeBase                  ,
                0             , 0             , 0             ,
                0             , 0             , 0             },           
    { LRAV_EjeCentralI01      , LRAV_EjeCentral               ,
                0             , 0             , 0.4           ,
                0             , 0             , 0             },           
    { LRAV_EjeCentralI02      , LRAV_EjeCentralI01            ,
                0             , 0             , 0.8           ,
                0             , 0             , 0             },           
    { LRAV_EjeCentralI03      , LRAV_EjeCentralI02            ,
                0             , 0             , 1.2           ,
                0             , 0             , 0             },           
    { LRAV_EjeCentralI04      , LRAV_EjeCentralI03            ,
                0             , 0             , 1.6           ,
                0             , 0             , 0             },           
    { LRAV_EjeCentralI05      , LRAV_EjeCentralI04            ,
                0             , 0             , 2.4           ,
                0             , 0             , 0             },           
    { LRAV_EjeCentralI06      , LRAV_EjeCentralI05            ,
                0             , 0             , 2.8           ,
                0             , 0             , 0             },           
    { LRAV_EjeCentralI07      , LRAV_EjeCentralI06            ,
                0             , 0             , 3.2           ,
                0             , 0             , 0             },           
    { LRAV_EjeCentralD01      , LRAV_EjeCentral               ,
                0             , 0             ,-0.4           ,
                0             , 0             , 0             },           
    { LRAV_EjeCentralD02      , LRAV_EjeCentralD01            ,
                0             , 0             ,-0.8           ,
                0             , 0             , 0             },           
    { LRAV_EjeCentralD03      , LRAV_EjeCentralD02            ,
                0             , 0             ,-1.2           ,
                0             , 0             , 0             },           
    { LRAV_EjeCentralD04      , LRAV_EjeCentralD03            ,
                0             , 0             ,-1.6           ,
                0             , 0             , 0             },           
    { LRAV_EjeCentralD05      , LRAV_EjeCentralD04            ,
                0             , 0             ,-2.4           ,
                0             , 0             , 0             },           
    { LRAV_EjeCentralD06      , LRAV_EjeCentralD05            ,
                0             , 0             ,-2.8           ,
                0             , 0             , 0             },           
    { LRAV_EjeCentralD07      , LRAV_EjeCentralD06            ,
                0             , 0             ,-3.2           ,
                0             , 0             , 0             },
    { LRAV_EjeCola01          , LRAV_EjeCentralD07            ,
                0             ,-0.2           ,-3.5           ,
                0             , 0             , 0             },           
    { LRAV_EjeCola02          , LRAV_EjeCola01                ,
                0             ,-0.3           ,-4.5           ,
                0             , 0             , 0             },           
    { LRAV_EjeCola03          , LRAV_EjeCola02                ,
                0             ,-0.5           ,-5.5           ,
                0             , 0             , 0             },           
    { LRAV_EjeCola04          , LRAV_EjeCola03                ,
                0             ,-0.5           ,-6.5           ,
                0             , 0             , 0             },           
    { LRAV_EjeCola05          , LRAV_EjeCola04                ,
                0             ,-0.65          ,-7.5           ,
                0             , 0             , 0             },           
    { LRAV_EjeCola06          , LRAV_EjeCola05                ,
                0             ,-0.75          ,-8.5           ,
                0             , 0             , 0             },           
    { LRAV_EjeCola07          , LRAV_EjeCola06                ,
                0             ,-0.80          ,-9.5           ,
                0             , 0             , 0             },           
    { LRAV_EjeCola08          , LRAV_EjeCola07                ,
                0             ,-0.85          ,-10.5          ,
                0             , 0             , 0             },           
    { LRAV_EjeCola09          , LRAV_EjeCola08                ,
                0             ,-1.00          ,-11.5          ,
                0             , 0             , 0             },           
    { LRAV_EjeCola10          , LRAV_EjeCola09                ,
                0             ,-1.25          ,-12.5          ,
                0             , 0             , 0             },
    { LRAV_EjeCabeza01        , LRAV_EjeCentralI07            ,
                0             , 0             , 3.6           ,
                0             , 0             , 0             },           
    { LRAV_EjeCabeza02        , LRAV_EjeCabeza01              ,
                0             , 0             , 4.1           ,
                0             , 0             , 0             },
    { LRAV_EjeAntePataDI      , LRAV_EjeCentralI05            ,
                0.82          ,-0.36          , 2.2           ,
                0             , 0             , 0             },
    { LRAV_EjePataDI          , LRAV_EjeAntePataDI            ,
                1.91          ,-0.81          , 2.32          ,
                0             , 0             , 0             }, 
    { LRAV_EjeDedoExteriorDI  , LRAV_EjePataDI                ,
                3.2           ,-0.9           , 4.0           ,
                0             , 0             , 0             },
    { LRAV_EjeDedoInteriorDI  , LRAV_EjePataDI                ,
                2.6           ,-0.9           , 4.2           ,
                0             , 0             , 0             },
    { LRAV_EjeDedoCentroExteriorDI      , LRAV_EjePataDI       ,
                3.2           ,-0.9           , 4.3           ,
                0             , 0             , 0             },
    { LRAV_EjeDedoCentroInteriorDI      , LRAV_EjePataDI      ,
                2.7           ,-0.9           , 4.4           ,
                0             , 0             , 0             }, 
    { LRAV_EjeDedoMedioDI     , LRAV_EjePataDI                ,
                3.0           ,-1.0           , 4.6           ,
                0             , 0             , 0             },
    { LRAV_EjeAntePataDD      , LRAV_EjeCentralI05            ,
               -0.82          ,-0.36          , 2.2           ,
                0             , 0             , 0             },
    { LRAV_EjePataDD          , LRAV_EjeAntePataDD            ,
               -1.91          ,-0.81          , 2.32          ,
                0             , 0             , 0             },
    { LRAV_EjeDedoExteriorDD  , LRAV_EjePataDD                ,
               -3.2           ,-0.9           , 4.0           ,
                0             , 0             , 0             },
    { LRAV_EjeDedoInteriorDD  , LRAV_EjePataDD                ,
               -2.6           ,-0.9           , 4.2           ,
                0             , 0             , 0             },
    { LRAV_EjeDedoCentroExteriorDD      , LRAV_EjePataDD       ,
               -3.2           ,-0.9           , 4.3           ,
                0             , 0             , 0             },
    { LRAV_EjeDedoCentroInteriorDD      , LRAV_EjePataDD      ,
               -2.7           ,-0.9           , 4.4           ,
                0             , 0             , 0             }, 
    { LRAV_EjeDedoMedioDD     , LRAV_EjePataDD                ,
               -3.0           ,-1.0           , 4.6           ,
                0             , 0             , 0             },
    { LRAV_EjeAntePataTI      , LRAV_EjeCentralD05            ,
               +0.82          ,-0.36          ,-1.8           ,
                0             , 0             , 0             },
    { LRAV_EjePataTI          , LRAV_EjeAntePataTI            ,
                1.91          ,-0.81          ,-2.32          ,
                0             , 0             , 0             },
    { LRAV_EjeDedoExteriorTI  , LRAV_EjePataTI                ,
                3.2           ,-0.9           ,-4.0           ,
                0             , 0             , 0             },
    { LRAV_EjeDedoInteriorTI  , LRAV_EjePataTI                ,
                2.6           ,-0.9           ,-4.2           ,
                0             , 0             , 0             },
    { LRAV_EjeDedoCentroExteriorTI      , LRAV_EjePataTI       ,
                3.2           ,-0.9           ,-4.3           ,
                0             , 0             , 0             },
    { LRAV_EjeDedoCentroInteriorTI      , LRAV_EjePataTI      ,
                2.7           ,-0.9           ,-4.4           ,
                0             , 0             , 0             }, 
    { LRAV_EjeDedoMedioTI     , LRAV_EjePataTI                ,
                3.0           ,-1.0           ,-4.6           ,
                0             , 0             , 0             },
    { LRAV_EjeAntePataTD      , LRAV_EjeCentralD05            ,
               -0.82          ,-0.36          ,-1.8           ,
                0             , 0             , 0             },
    { LRAV_EjePataTD          , LRAV_EjeAntePataTD            ,
               -1.91          ,-0.81          ,-2.32          ,
                0             , 0             , 0             },
    { LRAV_EjeDedoExteriorTD  , LRAV_EjePataTD                ,
               -3.2           ,-0.9           ,-4.0           ,
                0             , 0             , 0             },
    { LRAV_EjeDedoInteriorTD  , LRAV_EjePataTD                ,
               -2.6           ,-0.9           ,-4.2           ,
                0             , 0             , 0             },
    { LRAV_EjeDedoCentroExteriorTD      , LRAV_EjePataTD       ,
               -3.2           ,-0.9           ,-4.3           ,
                0             , 0             , 0             },
    { LRAV_EjeDedoCentroInteriorTD      , LRAV_EjePataTD      ,
               -2.7           ,-0.9           ,-4.4           ,
                0             , 0             , 0             }, 
    { LRAV_EjeDedoMedioTD     , LRAV_EjePataTD                ,
               -3.0           ,-1.0           ,-4.6           ,
                0             , 0             , 0             }
 }    
 
#macro LRAV_KeyMovimiento ( Identificador )
  #local A              = 0;
  #while ( !( LRAV_Movimiento[ A ][ LRAV_IndiceActual ] = 
                        Identificador ) )
    #local A            = A+1;
    // Es un ciclo infinito si error...
    // Se utilizo 0 en vez de LRAV_IndiceActual por velocidad.
  #end
  #local Identificador  = A;
#end
  
#macro LRAV_MoverBlob ( Eje, MiPunto )
  #local NuevoEje               = Eje; 
  LRAV_KeyMovimiento( NuevoEje )
  #while ( !( NuevoEje = LRAV_EjeBase ) )
    #local Pivote               = MiPunto-
                < LRAV_Movimiento[ NuevoEje ][ LRAV_IndiceX ],
                  LRAV_Movimiento[ NuevoEje ][ LRAV_IndiceY ],
                  LRAV_Movimiento[ NuevoEje ][ LRAV_IndiceZ ] >;
    #local Pivote               = vaxis_rotate
        ( Pivote, x, LRAV_Movimiento[ NuevoEje ][ LRAV_IndiceRotX ] );
    #local PivoteEje            = vaxis_rotate
 ( y, x, LRAV_Movimiento[ NuevoEje ][ LRAV_IndiceRotX ] );        
    #local PivoteEje2           = vaxis_rotate
 ( z, x, LRAV_Movimiento[ NuevoEje ][ LRAV_IndiceRotX ] );        
    #local Pivote               = vaxis_rotate
 ( Pivote, PivoteEje, LRAV_Movimiento[ NuevoEje ][ LRAV_IndiceRotY ] );
    #local PivoteEje2           = vaxis_rotate
        ( PivoteEje2, PivoteEje, 
                LRAV_Movimiento[ NuevoEje ][ LRAV_IndiceRotY ] );        
    #local Pivote           = vaxis_rotate
 ( Pivote, PivoteEje2, LRAV_Movimiento[ NuevoEje ][ LRAV_IndiceRotZ ] );
    #local MiPunto              = Pivote+
                < LRAV_Movimiento[ NuevoEje ][ LRAV_IndiceX ],
                  LRAV_Movimiento[ NuevoEje ][ LRAV_IndiceY ],
                  LRAV_Movimiento[ NuevoEje ][ LRAV_IndiceZ ] >;
    #local NuevoEje             = 
                LRAV_Movimiento[ NuevoEje ][ LRAV_IndicePadre ];
    LRAV_KeyMovimiento( NuevoEje )
  #end
#end


#macro LRAV_BlobTronco()  
  blob {
    threshold 0.6
    component 1.000000, 2.230360, 
    #local PuntoPivote  = <0.000000, 0.000000, 0.000000>;
    LRAV_MoverBlob( LRAV_EjeCentral, PuntoPivote )
    PuntoPivote
    component 1.000000, 1.503290, 
    #local PuntoPivote  = <0.400000, 0.000000, 0.000000>;  
    LRAV_MoverBlob( LRAV_EjeCentral, PuntoPivote )
    PuntoPivote
    component 1.000000, 1.890710, 
    #local PuntoPivote  = <-0.400000, 0.000000, 0.000000>;
    LRAV_MoverBlob( LRAV_EjeCentral, PuntoPivote )
    PuntoPivote
    component 1.000000, 2.106376, 
    #local PuntoPivote  = <0.000000, 0.000000, 0.400000>;
    LRAV_MoverBlob( LRAV_EjeCentralI01, PuntoPivote )
    PuntoPivote
    component 1.000000, 1.767437, 
    #local PuntoPivote  = <0.400000, 0.000000, 0.400000>;
    LRAV_MoverBlob( LRAV_EjeCentralI01, PuntoPivote )
    PuntoPivote
    component 1.000000, 1.979010, 
    #local PuntoPivote  = <-0.400000, 0.000000, 0.400000>;
    LRAV_MoverBlob( LRAV_EjeCentralI01, PuntoPivote )
    PuntoPivote
    component 1.000000, 1.979363, 
    #local PuntoPivote  = <0.400000, 0.000000, -0.400000>;
    LRAV_MoverBlob( LRAV_EjeCentralD01, PuntoPivote )
    PuntoPivote
    component 1.000000, 1.753447, 
    #local PuntoPivote  = <0.000000, 0.000000, -0.400000>;
    LRAV_MoverBlob( LRAV_EjeCentralD01, PuntoPivote )
    PuntoPivote
    component 1.000000, 1.919804, 
    #local PuntoPivote  = <-0.400000, 0.000000, -0.400000>;
    LRAV_MoverBlob( LRAV_EjeCentralD01, PuntoPivote )
    PuntoPivote
    component 1.000000, 2.271915, 
    #local PuntoPivote  = <0.000000, 0.000000, 0.800000>;
    LRAV_MoverBlob( LRAV_EjeCentralI02, PuntoPivote )
    PuntoPivote
    component 1.000000, 1.727301, 
    #local PuntoPivote  = <0.400000, 0.000000, 0.800000>;
    LRAV_MoverBlob( LRAV_EjeCentralI02, PuntoPivote )
    PuntoPivote
    component 1.000000, 1.685868, 
    #local PuntoPivote  = <-0.400000, 0.000000, 0.800000>;
    LRAV_MoverBlob( LRAV_EjeCentralI02, PuntoPivote )
    PuntoPivote
    component 1.000000, 2.158684, 
    #local PuntoPivote  = <0.000000, 0.000000, -0.800000>;
    LRAV_MoverBlob( LRAV_EjeCentralD02, PuntoPivote )
    PuntoPivote
    component 1.000000, 1.951406, 
    #local PuntoPivote  = <0.400000, 0.000000, -0.800000>;
    LRAV_MoverBlob( LRAV_EjeCentralD02, PuntoPivote )
    PuntoPivote
    component 1.000000, 1.978902, 
    #local PuntoPivote  = <-0.400000, 0.000000, -0.800000>;
    LRAV_MoverBlob( LRAV_EjeCentralD02, PuntoPivote )
    PuntoPivote
    component 1.000000, 2.320871, 
    #local PuntoPivote  = <0.000000, 0.000000, 1.200000>;
    LRAV_MoverBlob( LRAV_EjeCentralI03, PuntoPivote )
    PuntoPivote
    component 1.000000, 1.616967, 
    #local PuntoPivote  = <0.400000, 0.000000, 1.200000>;
    LRAV_MoverBlob( LRAV_EjeCentralI03, PuntoPivote )
    PuntoPivote
    component 1.000000, 1.752586, 
    #local PuntoPivote  = <-0.400000, 0.000000, 1.200000>;
    LRAV_MoverBlob( LRAV_EjeCentralI03, PuntoPivote )
    PuntoPivote
    component 1.000000, 1.989397, 
    #local PuntoPivote  = <0.000000, 0.000000, -1.200000>;
    LRAV_MoverBlob( LRAV_EjeCentralD03, PuntoPivote )
    PuntoPivote
    component 1.000000, 1.945554, 
    #local PuntoPivote  = <0.400000, 0.000000, -1.200000>;
    LRAV_MoverBlob( LRAV_EjeCentralD03, PuntoPivote )
    PuntoPivote
    component 1.000000, 1.926174, 
    #local PuntoPivote  = <-0.400000, 0.000000, -1.200000>;
    LRAV_MoverBlob( LRAV_EjeCentralD03, PuntoPivote )
    PuntoPivote
    component 1.000000, 2.081459, 
    #local PuntoPivote  = <0.000000, 0.000000, 1.600000>;
    LRAV_MoverBlob( LRAV_EjeCentralI04, PuntoPivote )
    PuntoPivote
    component 1.000000, 1.709817, 
    #local PuntoPivote  = <0.400000, 0.000000, 1.600000>;
    LRAV_MoverBlob( LRAV_EjeCentralI04, PuntoPivote )
    PuntoPivote
    component 1.000000, 1.667185, 
    #local PuntoPivote  = <-0.400000, 0.000000, 1.600000>;
    LRAV_MoverBlob( LRAV_EjeCentralI04, PuntoPivote )
    PuntoPivote
    component 1.000000, 1.613109, 
    #local PuntoPivote  = <0.000000, 0.000000, -1.600000>;
    LRAV_MoverBlob( LRAV_EjeCentralD04, PuntoPivote )
    PuntoPivote
    component 1.000000, 1.923449, 
    #local PuntoPivote  = <0.400000, 0.000000, -1.600000>;
    LRAV_MoverBlob( LRAV_EjeCentralD04, PuntoPivote )
    PuntoPivote
    component 1.000000, 1.796214, 
    #local PuntoPivote  = <-0.400000, 0.000000, -1.600000>;
    LRAV_MoverBlob( LRAV_EjeCentralD04, PuntoPivote )
    PuntoPivote
    component 1.000000, 1.677144, 
    #local PuntoPivote  = <0.000000, 0.000000, 2.400000>;
    LRAV_MoverBlob( LRAV_EjeCentralI05, PuntoPivote )
    PuntoPivote
    component 1.000000, 1.845989, 
    #local PuntoPivote  = <0.283286, 0.000000, 2.395051>;
    LRAV_MoverBlob( LRAV_EjeCentralI05, PuntoPivote )
    PuntoPivote
    component 1.000000, 1.817915, 
    #local PuntoPivote  = <-0.400000, 0.000000, 2.400000>;
    LRAV_MoverBlob( LRAV_EjeCentralI05, PuntoPivote )
    PuntoPivote
    component 1.000000, 1.973110, 
    #local PuntoPivote  = <0.000000, 0.000000, -2.400000>;
    LRAV_MoverBlob( LRAV_EjeCentralD05, PuntoPivote )
    PuntoPivote
    component 1.000000, 1.712666, 
    #local PuntoPivote  = <0.386298, 0.000000, -2.343544>;
    LRAV_MoverBlob( LRAV_EjeCentralD05, PuntoPivote )
    PuntoPivote
    component 1.000000, 1.548052, 
    #local PuntoPivote  = <-0.400000, 0.000000, -2.400000>;
    LRAV_MoverBlob( LRAV_EjeCentralD05, PuntoPivote )
    PuntoPivote
    component 1.000000, 1.685039, 
    #local PuntoPivote  = <0.000000, 0.000000, 2.800000>;
    LRAV_MoverBlob( LRAV_EjeCentralI06, PuntoPivote )
    PuntoPivote
    component 1.000000, 1.213247, 
    #local PuntoPivote  = <0.400000, 0.000000, 2.800000>;
    LRAV_MoverBlob( LRAV_EjeCentralI06, PuntoPivote )
    PuntoPivote
    component 1.000000, 1.362101, 
    #local PuntoPivote  = <-0.400000, 0.000000, 2.800000>;
    LRAV_MoverBlob( LRAV_EjeCentralI06, PuntoPivote )
    PuntoPivote
    component 1.000000, 1.700486, 
    #local PuntoPivote  = <0.000000, 0.000000, -2.800000>;
    LRAV_MoverBlob( LRAV_EjeCentralD06, PuntoPivote )
    PuntoPivote
    component 1.000000, 1.661602, 
    #local PuntoPivote  = <0.334792, 0.000000, -2.807102>;
    LRAV_MoverBlob( LRAV_EjeCentralD06, PuntoPivote )
    PuntoPivote
    component 1.000000, 1.447816, 
    #local PuntoPivote  = <-0.283286, 0.000000, -2.961622>;
    LRAV_MoverBlob( LRAV_EjeCentralD06, PuntoPivote )
    PuntoPivote
    component 1.000000, 1.574365, 
    #local PuntoPivote  = <0.000000, 0.000000, 3.200000>;
    LRAV_MoverBlob( LRAV_EjeCentralI07, PuntoPivote )
    PuntoPivote
    component 1.000000, 1.987311, 
    #local PuntoPivote  = <0.000000, 0.000000, -3.200000>;
    LRAV_MoverBlob( LRAV_EjeCentralD07, PuntoPivote )
    PuntoPivote
    component 1.000000, 1.390640, 
    #local PuntoPivote  = <0.000000, 0.000000, 3.600000>;
    LRAV_MoverBlob( LRAV_EjeCentralI07, PuntoPivote )
    PuntoPivote
    component 1.000000, 1.636581, 
    #local PuntoPivote  = <0.000000, 0.000000, -3.600000>;
    LRAV_MoverBlob( LRAV_EjeCentralD07, PuntoPivote )
    PuntoPivote
        
    texture             {
      LRAV_DefaultTexturaTronco
    }    
  }
#end    

#macro LRAV_MoverBlobAntePata( NumeralBase, MiPunto ) 
  #switch ( NumeralBase )
    #case ( LRAV_EjeAntePataDD )
      #local MiPunto    = MiPunto*<-1,1,1>;
    #break
    #case ( LRAV_EjeAntePataTI )
      #local MiPunto    = MiPunto*<1,1,-1>;
    #break
    #case ( LRAV_EjeAntePataTD )
      #local MiPunto    = MiPunto*<-1,1,-1>;
    #break
  #end
  LRAV_MoverBlob( NumeralBase, MiPunto )
#end

#macro LRAV_AntePata( NumeralBase )
  blob {
    threshold 0.6
    component 2.000000, 0.613700, 
    #local PuntoPivote  = <0.852321, -0.362869, 2.137518>;
    LRAV_MoverBlobAntePata( NumeralBase, PuntoPivote )
    PuntoPivote
    component 2.000000, 0.632588, 
    #local PuntoPivote  = <0.798350, -0.362869, 2.395051>;
    LRAV_MoverBlobAntePata( NumeralBase, PuntoPivote )
    PuntoPivote
    component 2.000000, 0.553182, 
    #local PuntoPivote  = <2.122066, -0.691983, 2.534118>;
    LRAV_MoverBlobAntePata( NumeralBase, PuntoPivote )
    PuntoPivote
    component 2.000000, 0.553182, 
    #local PuntoPivote  = <2.245682, -0.691983, 2.163272>;
    LRAV_MoverBlobAntePata( NumeralBase, PuntoPivote )
    PuntoPivote
    component 2.000000, 0.542440, 
    #local PuntoPivote  = <1.421578, -0.573840, 2.492913>;
    LRAV_MoverBlobAntePata( NumeralBase, PuntoPivote )
    PuntoPivote
    component 2.000000, 0.632588, 
    #local PuntoPivote  = <1.462784, -0.565401, 2.039656>;
    LRAV_MoverBlobAntePata( NumeralBase, PuntoPivote )
    PuntoPivote
    component 2.000000, 0.632588, 
    #local PuntoPivote  = <1.004376, -0.489451, 1.982999>;
    LRAV_MoverBlobAntePata( NumeralBase, PuntoPivote )
    PuntoPivote
    component 2.000000, 0.584226, 
    #local PuntoPivote  = <1.107389, -0.489451, 2.446557>;
    LRAV_MoverBlobAntePata( NumeralBase, PuntoPivote )
    PuntoPivote
    component 2.000000, 0.632588, 
    #local PuntoPivote  = <1.174347, -0.489451, 1.998451>;
    LRAV_MoverBlobAntePata( NumeralBase, PuntoPivote )
    PuntoPivote
    component 2.000000, 0.584226, 
    #local PuntoPivote  = <1.313415, -0.489451, 2.395051>;
    LRAV_MoverBlobAntePata( NumeralBase, PuntoPivote )
    PuntoPivote
    component 2.000000, 0.553182, 
    #local PuntoPivote  = <1.916041, -0.691983, 2.451708>;
    LRAV_MoverBlobAntePata( NumeralBase, PuntoPivote )
    PuntoPivote
    component 2.000000, 0.553182, 
    #local PuntoPivote  = <1.998451, -0.691983, 2.122066>;
    LRAV_MoverBlobAntePata( NumeralBase, PuntoPivote )
    PuntoPivote
    component 2.000000, 0.553182, 
    #local PuntoPivote  = <1.710015, -0.691983, 2.080861>;
    LRAV_MoverBlobAntePata( NumeralBase, PuntoPivote )
    PuntoPivote
    component 2.000000, 0.553182, 
    #local PuntoPivote  = <1.668810, -0.691983, 2.451708>;
    LRAV_MoverBlobAntePata( NumeralBase, PuntoPivote )
    PuntoPivote        
    
    texture             {
      LRAV_DefaultTexturaAntePata
    }
  }
#end

#macro LRAV_BlobCola()
  blob {
    threshold 0.6
    component 1.000000, 1.620319, 
    #local PuntoPivote  = <0.295359, -0.177215, -3.578059>;  
    LRAV_MoverBlob( LRAV_EjeCola01, PuntoPivote )
    PuntoPivote
    component 1.000000, 1.604308, 
    #local PuntoPivote  = <-0.261603, -0.160338, -3.510549>;
    LRAV_MoverBlob( LRAV_EjeCola01, PuntoPivote )
    PuntoPivote
    component 1.000000, 1.415334, 
    #local PuntoPivote  = <0.261603, -0.227848, -4.151059>;
    LRAV_MoverBlob( LRAV_EjeCola01, PuntoPivote )
    PuntoPivote
    component 1.000000, 1.335771, 
    #local PuntoPivote  = <-0.329114, -0.227848, -4.089549>;
    LRAV_MoverBlob( LRAV_EjeCola01, PuntoPivote )
    PuntoPivote
    component 1.000000, 1.346040, 
    #local PuntoPivote  = <0.244726, -0.312236, -4.725059>;
    LRAV_MoverBlob( LRAV_EjeCola02, PuntoPivote )
    PuntoPivote
    component 1.000000, 1.168547, 
    #local PuntoPivote  = <-0.329114, -0.345992, -4.669549>;
    LRAV_MoverBlob( LRAV_EjeCola02, PuntoPivote )
    PuntoPivote
    component 1.000000, 1.190735, 
    #local PuntoPivote  = <0.244726, -0.396624, -5.299059>;
    LRAV_MoverBlob( LRAV_EjeCola02, PuntoPivote )
    PuntoPivote
    component 1.000000, 1.203390, 
    #local PuntoPivote  = <-0.312236, -0.447257, -5.248549>;
    LRAV_MoverBlob( LRAV_EjeCola02, PuntoPivote )
    PuntoPivote
    component 1.000000, 1.197822, 
    #local PuntoPivote  = <0.210970, -0.481013, -5.873059>;
    LRAV_MoverBlob( LRAV_EjeCola03, PuntoPivote )
    PuntoPivote
    component 1.000000, 1.045781, 
    #local PuntoPivote  = <-0.312236, -0.531646, -5.828549>;
    LRAV_MoverBlob( LRAV_EjeCola03, PuntoPivote )
    PuntoPivote
    component 1.000000, 1.124419, 
    #local PuntoPivote  = <0.222287, -0.575014, -6.447059>;
    LRAV_MoverBlob( LRAV_EjeCola03, PuntoPivote )
    PuntoPivote
    component 1.000000, 1.181475, 
    #local PuntoPivote  = <-0.201481, -0.606092, -6.407049>;
    LRAV_MoverBlob( LRAV_EjeCola03, PuntoPivote )
    PuntoPivote
    component 1.000000, 1.144777, 
    #local PuntoPivote  = <0.219409, -0.624473, -7.021097>;
    LRAV_MoverBlob( LRAV_EjeCola04, PuntoPivote )
    PuntoPivote
    component 1.000000, 1.186517, 
    #local PuntoPivote  = <-0.185654, -0.658228, -6.987342>;
    LRAV_MoverBlob( LRAV_EjeCola04, PuntoPivote )
    PuntoPivote
    component 1.000000, 1.123282, 
    #local PuntoPivote  = <0.202509, -0.662473, -7.511097>;
    LRAV_MoverBlob( LRAV_EjeCola05, PuntoPivote )
    PuntoPivote
    component 1.000000, 1.120192, 
    #local PuntoPivote  = <-0.181054, -0.687028, -7.472042>;
    LRAV_MoverBlob( LRAV_EjeCola05, PuntoPivote )
    PuntoPivote
    component 1.000000, 1.085755, 
    #local PuntoPivote  = <0.185609, -0.700473, -7.999097>;
    LRAV_MoverBlob( LRAV_EjeCola05, PuntoPivote )
    PuntoPivote
    component 1.000000, 1.018648, 
    #local PuntoPivote  = <-0.177054, -0.717028, -7.957042>;
    LRAV_MoverBlob( LRAV_EjeCola05, PuntoPivote )
    PuntoPivote
    component 1.000000, 0.979243, 
    #local PuntoPivote  = <0.168709, -0.738073, -8.489097>;
    LRAV_MoverBlob( LRAV_EjeCola06, PuntoPivote )
    PuntoPivote
    component 1.000000, 0.971069, 
    #local PuntoPivote  = <-0.172054, -0.746028, -8.443042>;
    LRAV_MoverBlob( LRAV_EjeCola06, PuntoPivote )
    PuntoPivote
    component 1.000000, 0.978709, 
    #local PuntoPivote  = <0.151809, -0.776073, -8.978097>;
    LRAV_MoverBlob( LRAV_EjeCola06, PuntoPivote )
    PuntoPivote
    component 1.000000, 0.979281, 
    #local PuntoPivote  = <-0.168054, -0.776028, -8.928042>;
    LRAV_MoverBlob( LRAV_EjeCola06, PuntoPivote )
    PuntoPivote
    component 1.000000, 0.885455, 
    #local PuntoPivote  = <0.135009, -0.814073, -9.468097>;
    LRAV_MoverBlob( LRAV_EjeCola07, PuntoPivote )
    PuntoPivote
    component 1.000000, 0.830921, 
    #local PuntoPivote  = <-0.164004, -0.805028, -9.413042>;
    LRAV_MoverBlob( LRAV_EjeCola07, PuntoPivote )
    PuntoPivote
    component 1.000000, 0.823837, 
    #local PuntoPivote  = <0.118109, -0.852073, -9.957097>;
    LRAV_MoverBlob( LRAV_EjeCola07, PuntoPivote )
    PuntoPivote
    component 1.000000, 0.786038, 
    #local PuntoPivote  = <-0.160054, -0.835028, -9.898042>;
    LRAV_MoverBlob( LRAV_EjeCola07, PuntoPivote )
    PuntoPivote
    component 1.000000, 0.826946, 
    #local PuntoPivote  = <0.101209, -0.890073, -10.440970>;
    LRAV_MoverBlob( LRAV_EjeCola07, PuntoPivote )
    PuntoPivote
    component 1.000000, 0.863411, 
    #local PuntoPivote  = <-0.156054, -0.864028, -10.383420>;
    LRAV_MoverBlob( LRAV_EjeCola07, PuntoPivote )
    PuntoPivote
    component 1.000000, 0.711875, 
    #local PuntoPivote  = <0.084388, -0.928270, -10.936710>;
    LRAV_MoverBlob( LRAV_EjeCola08, PuntoPivote )
    PuntoPivote
    component 1.000000, 0.810649, 
    #local PuntoPivote  = <-0.151899, -0.894515, -10.869200>;
    LRAV_MoverBlob( LRAV_EjeCola08, PuntoPivote )
    PuntoPivote
    component 1.000000, 0.742504, 
    #local PuntoPivote  = <-0.143460, -0.987342, -11.274263>;
    LRAV_MoverBlob( LRAV_EjeCola08, PuntoPivote )
    PuntoPivote
    component 1.000000, 0.707646, 
    #local PuntoPivote  = <0.075949, -1.021097, -11.291142>;
    LRAV_MoverBlob( LRAV_EjeCola08, PuntoPivote )
    PuntoPivote
    component 1.000000, 0.637165, 
    #local PuntoPivote  = <0.075949, -1.071730, -11.628695>;
    LRAV_MoverBlob( LRAV_EjeCola09, PuntoPivote )
    PuntoPivote
    component 1.000000, 0.640876, 
    #local PuntoPivote  = <-0.168776, -1.071730, -11.679327>;
    LRAV_MoverBlob( LRAV_EjeCola09, PuntoPivote )
    PuntoPivote
    component 1.000000, 0.561239, 
    #local PuntoPivote  = <0.059072, -1.156118, -11.983125>;
    LRAV_MoverBlob( LRAV_EjeCola09, PuntoPivote )
    PuntoPivote
    component 1.000000, 0.515466, 
    #local PuntoPivote  = <-0.210970, -1.139241, -12.050635>;
    LRAV_MoverBlob( LRAV_EjeCola09, PuntoPivote )
    PuntoPivote
    component 1.000000, 0.533240, 
    #local PuntoPivote  = <-0.202532, -1.139241, -12.320676>;
    LRAV_MoverBlob( LRAV_EjeCola09, PuntoPivote )
    PuntoPivote
    component 1.000000, 0.497691, 
    #local PuntoPivote  = <0.067511, -1.156118, -12.320676>;
    LRAV_MoverBlob( LRAV_EjeCola09, PuntoPivote )
    PuntoPivote
    component 1.000000, 0.485152, 
    #local PuntoPivote  = <-0.202532, -1.223629, -12.607595>;
    LRAV_MoverBlob( LRAV_EjeCola10, PuntoPivote )
    PuntoPivote
    component 1.000000, 0.511773, 
    #local PuntoPivote  = <0.059072, -1.274262, -12.590720>;
    LRAV_MoverBlob( LRAV_EjeCola10, PuntoPivote )
    PuntoPivote
    component 1.000000, 0.534719, 
    #local PuntoPivote  = <0.025316, -1.240506, -12.843884>;
    LRAV_MoverBlob( LRAV_EjeCola10, PuntoPivote )
    PuntoPivote
    component 1.000000, 0.545250, 
    #local PuntoPivote  = <-0.185654, -1.206751, -12.827005>;
    LRAV_MoverBlob( LRAV_EjeCola10, PuntoPivote )
    PuntoPivote
    component 1.000000, 0.512700, 
    #local PuntoPivote  = <0.033755, -1.240506, -13.147680>;
    LRAV_MoverBlob( LRAV_EjeCola10, PuntoPivote )
    PuntoPivote
    component 1.000000, 0.502744, 
    #local PuntoPivote  = <-0.151899, -1.257384, -13.130802>;
    LRAV_MoverBlob( LRAV_EjeCola10, PuntoPivote )
    PuntoPivote
    component 1.000000, 0.455254, 
    #local PuntoPivote  = <0.016878, -1.308017, -13.654011>;
    LRAV_MoverBlob( LRAV_EjeCola10, PuntoPivote )
    PuntoPivote
    component 1.000000, 0.463506, 
    #local PuntoPivote  = <-0.126582, -1.308017, -13.654011>;
    LRAV_MoverBlob( LRAV_EjeCola10, PuntoPivote )
    PuntoPivote
    component 1.000000, 0.414955, 
    #local PuntoPivote  = <0.042194, -1.291139, -13.417725>;
    LRAV_MoverBlob( LRAV_EjeCola10, PuntoPivote )
    PuntoPivote
    component 1.000000, 0.450019, 
    #local PuntoPivote  = <-0.143460, -1.257384, -13.400846>;
    LRAV_MoverBlob( LRAV_EjeCola10, PuntoPivote )
    PuntoPivote
    component 1.000000, 0.392657, 
    #local PuntoPivote  = <-0.008439, -1.308017, -13.856543>;
    LRAV_MoverBlob( LRAV_EjeCola10, PuntoPivote )
    PuntoPivote
    component 1.000000, 0.397454, 
    #local PuntoPivote  = <-0.143460, -1.341772, -13.873421>;
    LRAV_MoverBlob( LRAV_EjeCola10, PuntoPivote )
    PuntoPivote
    component 1.000000, 0.370806, 
    #local PuntoPivote  = <-0.067511, -1.232067, -14.042195>;
    LRAV_MoverBlob( LRAV_EjeCola10, PuntoPivote )
    PuntoPivote
    component 1.000000, 0.395094, 
    #local PuntoPivote  = <-0.008439, -1.240506, -14.055699>;
    LRAV_MoverBlob( LRAV_EjeCola10, PuntoPivote )
    PuntoPivote 
    
    texture             {
      LRAV_DefaultTexturaCola
    }
  }
#end  

#macro LRAV_BlobCabeza()   
  union {
    blob {
      threshold 0.6
      component 1.000000, 0.667911, 
      #local PuntoPivote  = <-0.109705, 0.000000, 5.797469>;
      LRAV_MoverBlob( LRAV_EjeCabeza02, PuntoPivote )
      PuntoPivote
      component 1.000000, 0.661255, 
      #local PuntoPivote  = <0.160338, 0.000000, 5.780591>;
      LRAV_MoverBlob( LRAV_EjeCabeza02, PuntoPivote )
      PuntoPivote
      component 1.000000, 1.274333, 
      #local PuntoPivote  = <0.582278, 0.000000, 4.751055>;
      LRAV_MoverBlob( LRAV_EjeCabeza02, PuntoPivote )
      PuntoPivote
      component 1.000000, 1.225808, 
      #local PuntoPivote  = <-0.599156, 0.000000, 4.751055>;
      LRAV_MoverBlob( LRAV_EjeCabeza02, PuntoPivote )
      PuntoPivote
      component 1.000000, 1.597744, 
      #local PuntoPivote  = <-0.008439, 0.000000, 4.734178>;
      LRAV_MoverBlob( LRAV_EjeCabeza02, PuntoPivote )
      PuntoPivote
      component 1.000000, 1.098008, 
      #local PuntoPivote  = <0.042194, 0.000000, 3.620254>;
      LRAV_MoverBlob( LRAV_EjeCabeza01, PuntoPivote )
      PuntoPivote
      component 1.000000, 0.956535, 
      #local PuntoPivote  = <0.464135, 0.000000, 3.603376>;
      LRAV_MoverBlob( LRAV_EjeCabeza01, PuntoPivote )
      PuntoPivote
      component 1.000000, 0.911201, 
      #local PuntoPivote  = <-0.396624, 0.000000, 3.603376>;
      LRAV_MoverBlob( LRAV_EjeCabeza01, PuntoPivote )
      PuntoPivote
      component 1.000000, 1.151381, 
      #local PuntoPivote  = <0.008439, 0.000000, 4.109705>;
      LRAV_MoverBlob( LRAV_EjeCabeza02, PuntoPivote )
      PuntoPivote
      component 1.000000, 1.151381, 
      #local PuntoPivote  = <0.531646, 0.000000, 4.143460>;
      LRAV_MoverBlob( LRAV_EjeCabeza02, PuntoPivote )
      PuntoPivote
      component 1.000000, 1.157948, 
      #local PuntoPivote  = <-0.565401, 0.000000, 4.160338>;
      LRAV_MoverBlob( LRAV_EjeCabeza02, PuntoPivote )
      PuntoPivote
      component 1.000000, 1.131452, 
      #local PuntoPivote  = <0.295359, 0.000000, 5.308017>;
      LRAV_MoverBlob( LRAV_EjeCabeza02, PuntoPivote )
      PuntoPivote
      component 1.000000, 1.157948, 
      #local PuntoPivote  = <-0.227848, 0.000000, 5.308017>;
      LRAV_MoverBlob( LRAV_EjeCabeza02, PuntoPivote )
      PuntoPivote    
    
      texture             {
        LRAV_DefaultTexturaCabeza
      }
      #if ( LRAV_POV3_1 )
        #declare LRAV_BanderaBoca       = off;
      #end
      #if ( LRAV_BanderaBoca )
        #local MyBox        = 
          box       {    
            #local PuntoPivote  = <-2.30, -0.5, 4.75>;
            LRAV_MoverBlob( LRAV_EjeCabeza02, PuntoPivote )
            PuntoPivote,
            #local PuntoPivote  = < 2.30, -0.4, 8.75>;
            LRAV_MoverBlob( LRAV_EjeCabeza02, PuntoPivote )
            PuntoPivote
          }
          
        texture     {
          pigment     {
            object    {
              MyBox
              rgbt    1
              color   LRAV_ColorBoca
            }
            turbulence        0.3
          }
        }
      #end
    }
    sphere        {
      #local PuntoPivote  = < 1.10, 0.50, 4.751055>;
      LRAV_MoverBlob( LRAV_EjeCabeza02, PuntoPivote )
      PuntoPivote, 0.2
      texture     {
        LRAV_DefaultTexturaOjo
        rotate    -25*z
        rotate    10*y 
        scale     <-1,1,1>
        translate PuntoPivote       
      }
    }
    
    sphere        {
      #local PuntoPivote  = <-1.10, 0.50, 4.751055>;
      LRAV_MoverBlob( LRAV_EjeCabeza02, PuntoPivote )
      PuntoPivote, 0.2   
      texture     {
        LRAV_DefaultTexturaOjo
        rotate    -25*z
        rotate    10*y 
        translate PuntoPivote       
      }
    }
  }
#end 

#macro LRAV_MoverBlobPata( NumeralBase, MiPunto ) 
  #switch ( NumeralBase )
    #case ( LRAV_EjePataDD )
      #local MiPunto    = MiPunto*<-1,1,1>;
    #break
    #case ( LRAV_EjePataTI )
      #local MiPunto    = MiPunto*<1,1,-1>;
    #break
    #case ( LRAV_EjePataTD )
      #local MiPunto    = MiPunto*<-1,1,-1>;
    #break
  #end
  LRAV_MoverBlob( NumeralBase, MiPunto )
#end

#macro LRAV_Pata( NumeralBase )
  blob {
    threshold 0.6
    component 2.000000, 0.429907, 
    #local PuntoPivote  = <2.599156, -0.810127, 4.043257>;
    LRAV_MoverBlobPata( NumeralBase, PuntoPivote )
    PuntoPivote
    component 2.000000, 0.390105, 
    #local PuntoPivote  = <2.852321, -0.827004, 3.940244>;
    LRAV_MoverBlobPata( NumeralBase, PuntoPivote )
    PuntoPivote
    component 2.000000, 0.420847, 
    #local PuntoPivote  = <3.122363, -0.793249, 3.837232>;
    LRAV_MoverBlobPata( NumeralBase, PuntoPivote )
    PuntoPivote
    component 2.000000, 0.391159, 
    #local PuntoPivote  = <2.549570, -0.810127, 3.785725>;
    LRAV_MoverBlobPata( NumeralBase, PuntoPivote )
    PuntoPivote
    component 2.000000, 0.613700, 
    #local PuntoPivote  = <2.807102, -0.827004, 3.682712>;
    LRAV_MoverBlobPata( NumeralBase, PuntoPivote )
    PuntoPivote
    component 2.000000, 0.391159, 
    #local PuntoPivote  = <3.064635, -0.793249, 3.528193>;
    LRAV_MoverBlobPata( NumeralBase, PuntoPivote )
    PuntoPivote
    component 2.000000, 0.485173, 
    #local PuntoPivote  = <2.498064, -0.810127, 3.425180>;
    LRAV_MoverBlobPata( NumeralBase, PuntoPivote )
    PuntoPivote
    component 2.000000, 0.451236, 
    #local PuntoPivote  = <2.704089, -0.827004, 3.322167>;
    LRAV_MoverBlobPata( NumeralBase, PuntoPivote )
    PuntoPivote
    component 2.000000, 0.343069, 
    #local PuntoPivote  = <3.013128, -0.793249, 3.219154>;
    LRAV_MoverBlobPata( NumeralBase, PuntoPivote )
    PuntoPivote
    component 2.000000, 0.447307, 
    #local PuntoPivote  = <2.863760, -0.793249, 2.987375>;
    LRAV_MoverBlobPata( NumeralBase, PuntoPivote )
    PuntoPivote
    component 2.000000, 0.506070, 
    #local PuntoPivote  = <2.575323, -0.827004, 3.069785>;
    LRAV_MoverBlobPata( NumeralBase, PuntoPivote )
    PuntoPivote
    component 2.000000, 0.447307, 
    #local PuntoPivote  = <2.286887, -0.810127, 3.152196>;
    LRAV_MoverBlobPata( NumeralBase, PuntoPivote )
    PuntoPivote
    component 2.000000, 0.542440, 
    #local PuntoPivote  = <2.740144, -0.793249, 2.740144>;
    LRAV_MoverBlobPata( NumeralBase, PuntoPivote )
    PuntoPivote
    component 2.000000, 0.582208, 
    #local PuntoPivote  = <2.492913, -0.827004, 2.863760>;
    LRAV_MoverBlobPata( NumeralBase, PuntoPivote )
    PuntoPivote
    component 2.000000, 0.433952, 
    #local PuntoPivote  = <2.163272, -0.810127, 2.863760>;
    LRAV_MoverBlobPata( NumeralBase, PuntoPivote )
    PuntoPivote
    component 2.000000, 0.584226, 
    #local PuntoPivote  = <2.492913, -0.793249, 2.451708>;
    LRAV_MoverBlobPata( NumeralBase, PuntoPivote )
    PuntoPivote
    component 2.000000, 0.433952, 
    #local PuntoPivote  = <2.369298, -0.827004, 2.575323>;
    LRAV_MoverBlobPata( NumeralBase, PuntoPivote )
    PuntoPivote
    component 2.000000, 0.391159, 
    #local PuntoPivote  = <1.998451, -0.810127, 2.534118>;
    LRAV_MoverBlobPata( NumeralBase, PuntoPivote )
    PuntoPivote
    component 2.000000, 0.555730, 
    #local PuntoPivote  = <2.163272, -0.827004, 2.286887>;
    LRAV_MoverBlobPata( NumeralBase, PuntoPivote )
    PuntoPivote
    component 2.000000, 0.460275, 
    #local PuntoPivote  = <2.369298, -0.793249, 2.204477>;
    LRAV_MoverBlobPata( NumeralBase, PuntoPivote )
    PuntoPivote
    component 2.000000, 0.343069, 
    #local PuntoPivote  = <1.916041, -0.810127, 2.328092>;
    LRAV_MoverBlobPata( NumeralBase, PuntoPivote )
    PuntoPivote
    component 2.000000, 0.613700, 
    #local PuntoPivote  = <2.807102, -0.827004, 4.300790>;
    LRAV_MoverBlobPata( NumeralBase, PuntoPivote )
    PuntoPivote
    component 2.000000, 0.613700, 
    #local PuntoPivote  = <3.064635, -0.827004, 4.197777>;
    LRAV_MoverBlobPata( NumeralBase, PuntoPivote )
    PuntoPivote 
    
    texture             {
      LRAV_DefaultTexturaPata
    }
  }
#end

#macro LRAV_MoverBlobDedoExterior( NumeralBase, MiPunto ) 
  #switch ( NumeralBase )
    #case ( LRAV_EjeDedoExteriorDD )
      #local MiPunto    = MiPunto*<-1,1,1>;
    #break
    #case ( LRAV_EjeDedoExteriorTI )
      #local MiPunto    = MiPunto*<1,1,-1>;
    #break
    #case ( LRAV_EjeDedoExteriorTD )
      #local MiPunto    = MiPunto*<-1,1,-1>;
    #break
  #end
  LRAV_MoverBlob( NumeralBase, MiPunto )
#end

#macro LRAV_DedoExterior( NumeralBase )
  blob {
    threshold 0.6
    component 1.000000, 0.433952, 
    #local PuntoPivote  = <3.708465, -0.919831, 3.965998>;
    LRAV_MoverBlobDedoExterior( NumeralBase, PuntoPivote )
    PuntoPivote
    component 1.000000, 0.306851, 
    #local PuntoPivote  = <3.940928, -0.970464, 3.965998>;
    LRAV_MoverBlobDedoExterior( NumeralBase, PuntoPivote )
    PuntoPivote
    component 1.000000, 0.306851, 
    #local PuntoPivote  = <3.451477, -0.919831, 3.965998>;
    LRAV_MoverBlobDedoExterior( NumeralBase, PuntoPivote )
    PuntoPivote
    component 1.000000, 0.306851, 
    #local PuntoPivote  = <3.586498, -0.936709, 3.965998>;
    LRAV_MoverBlobDedoExterior( NumeralBase, PuntoPivote )
    PuntoPivote
    component 1.000000, 0.306851, 
    #local PuntoPivote  = <3.282700, -0.886076, 3.965998>;
    LRAV_MoverBlobDedoExterior( NumeralBase, PuntoPivote )
    PuntoPivote
    component 1.000000, 0.306851, 
    #local PuntoPivote  = <3.164557, -0.886076, 3.965998>;
    LRAV_MoverBlobDedoExterior( NumeralBase, PuntoPivote )
    PuntoPivote

    texture {    
      LRAV_DefaultTexturaDedo
    }
  }  
#end

#macro LRAV_MoverBlobDedoInterior( NumeralBase, MiPunto ) 
  #switch ( NumeralBase )
    #case ( LRAV_EjeDedoInteriorDD )
      #local MiPunto    = MiPunto*<-1,1,1>;
    #break
    #case ( LRAV_EjeDedoInteriorTI )
      #local MiPunto    = MiPunto*<1,1,-1>;
    #break
    #case ( LRAV_EjeDedoInteriorTD )
      #local MiPunto    = MiPunto*<-1,1,-1>;
    #break
  #end
  LRAV_MoverBlob( NumeralBase, MiPunto )
#end

#macro LRAV_DedoInterior( NumeralBase )
  blob {
    threshold 0.6
    component 1.000000, 0.416094, 
    #local PuntoPivote  = <1.983122, -0.936709, 4.326543>;
    LRAV_MoverBlobDedoInterior( NumeralBase, PuntoPivote )
    PuntoPivote
    component 1.000000, 0.270736, 
    #local PuntoPivote  = <1.831224, -1.021097, 4.378049>;
    LRAV_MoverBlobDedoInterior( NumeralBase, PuntoPivote )
    PuntoPivote
    component 1.000000, 0.270736, 
    #local PuntoPivote  = <2.317791, -0.919831, 4.275036>;
    LRAV_MoverBlobDedoInterior( NumeralBase, PuntoPivote )
    PuntoPivote
    component 1.000000, 0.270736, 
    #local PuntoPivote  = <2.168776, -0.919831, 4.275036>;
    LRAV_MoverBlobDedoInterior( NumeralBase, PuntoPivote )
    PuntoPivote
    component 1.000000, 0.270736, 
    #local PuntoPivote  = <2.438818, -0.902954, 4.275036>;
    LRAV_MoverBlobDedoInterior( NumeralBase, PuntoPivote )
    PuntoPivote
    component 1.000000, 0.270736, 
    #local PuntoPivote  = <2.556962, -0.886076, 4.275036>;
    LRAV_MoverBlobDedoInterior( NumeralBase, PuntoPivote )
    PuntoPivote

    texture {  
      LRAV_DefaultTexturaDedo
    }
  }
#end

#macro LRAV_MoverBlobDedoCentroExterior( NumeralBase, MiPunto ) 
  #switch ( NumeralBase )
    #case ( LRAV_EjeDedoCentroExteriorDD )
      #local MiPunto    = MiPunto*<-1,1,1>;
    #break
    #case ( LRAV_EjeDedoCentroExteriorTI )
      #local MiPunto    = MiPunto*<1,1,-1>;
    #break
    #case ( LRAV_EjeDedoCentroExteriorTD )
      #local MiPunto    = MiPunto*<-1,1,-1>;
    #break
  #end
  LRAV_MoverBlob( NumeralBase, MiPunto )
#end

#macro LRAV_DedoCentroExterior( NumeralBase )
  blob {
    threshold 0.6
    component 1.000000, 0.391043, 
    #local PuntoPivote  = <3.656959, -0.936709, 4.790101>;
    LRAV_MoverBlobDedoCentroExterior( NumeralBase, PuntoPivote )
    PuntoPivote
    component 1.000000, 0.301646, 
    #local PuntoPivote  = <3.759972, -1.021097, 4.893114>;
    LRAV_MoverBlobDedoCentroExterior( NumeralBase, PuntoPivote )
    PuntoPivote
    component 1.000000, 0.301646, 
    #local PuntoPivote  = <3.399427, -0.902954, 4.584075>;
    LRAV_MoverBlobDedoCentroExterior( NumeralBase, PuntoPivote )
    PuntoPivote
    component 1.000000, 0.301646, 
    #local PuntoPivote  = <3.502439, -0.936709, 4.635581>;
    LRAV_MoverBlobDedoCentroExterior( NumeralBase, PuntoPivote )
    PuntoPivote
    component 1.000000, 0.301646, 
    #local PuntoPivote  = <3.296414, -0.886076, 4.481062>;
    LRAV_MoverBlobDedoCentroExterior( NumeralBase, PuntoPivote )
    PuntoPivote
    component 1.000000, 0.301646, 
    #local PuntoPivote  = <3.193401, -0.886076, 4.326543>;
    LRAV_MoverBlobDedoCentroExterior( NumeralBase, PuntoPivote )
    PuntoPivote

    texture {   
      LRAV_DefaultTexturaDedo
    }
  }
#end
    
#macro LRAV_MoverBlobDedoCentroInterior( NumeralBase, MiPunto ) 
  #switch ( NumeralBase )
    #case ( LRAV_EjeDedoCentroInteriorDD )
      #local MiPunto    = MiPunto*<-1,1,1>;
    #break
    #case ( LRAV_EjeDedoCentroInteriorTI )
      #local MiPunto    = MiPunto*<1,1,-1>;
    #break
    #case ( LRAV_EjeDedoCentroInteriorTD )
      #local MiPunto    = MiPunto*<-1,1,-1>;
    #break
  #end
  LRAV_MoverBlob( NumeralBase, MiPunto )
#end

#macro LRAV_DedoCentroInterior( NumeralBase )
  blob {
    threshold 0.6
    component 1.000000, 0.414573, 
    #local PuntoPivote  = <2.421941, -0.953587, 4.944621>;
    LRAV_MoverBlobDedoCentroInterior( NumeralBase, PuntoPivote )
    PuntoPivote
    component 1.000000, 0.286608, 
    #local PuntoPivote  = <2.317791, -1.054852, 5.150646>;
    LRAV_MoverBlobDedoCentroInterior( NumeralBase, PuntoPivote )
    PuntoPivote
    component 1.000000, 0.286608, 
    #local PuntoPivote  = <2.590717, -0.902954, 4.584075>;
    LRAV_MoverBlobDedoCentroInterior( NumeralBase, PuntoPivote )
    PuntoPivote
    component 1.000000, 0.286608, 
    #local PuntoPivote  = <2.472310, -0.953587, 4.790101>;
    LRAV_MoverBlobDedoCentroInterior( NumeralBase, PuntoPivote )
    PuntoPivote
    component 1.000000, 0.286608, 
    #local PuntoPivote  = <2.742616, -0.886076, 4.429556>;
    LRAV_MoverBlobDedoCentroInterior( NumeralBase, PuntoPivote )
    PuntoPivote

    texture {    
      LRAV_DefaultTexturaDedo
    }
  }
#end

#macro LRAV_MoverBlobDedoMedio( NumeralBase, MiPunto ) 
  #switch ( NumeralBase )
    #case ( LRAV_EjeDedoMedioDD )
      #local MiPunto    = MiPunto*<-1,1,1>;
    #break
    #case ( LRAV_EjeDedoMedioTI )
      #local MiPunto    = MiPunto*<1,1,-1>;
    #break
    #case ( LRAV_EjeDedoMedioTD )
      #local MiPunto    = MiPunto*<-1,1,-1>;
    #break
  #end
  LRAV_MoverBlob( NumeralBase, MiPunto )
#end

#macro LRAV_DedoMedio( NumeralBase )
  blob {
    threshold 0.6
    component 1.000000, 0.382878, 
    #local PuntoPivote  = <3.029536, -1.021097, 5.099140>;
    LRAV_MoverBlobDedoMedio( NumeralBase, PuntoPivote )
    PuntoPivote
    component 1.000000, 0.284395, 
    #local PuntoPivote  = <3.038881, -1.105485, 5.305166>;
    LRAV_MoverBlobDedoMedio( NumeralBase, PuntoPivote )
    PuntoPivote
    component 1.000000, 0.284395, 
    #local PuntoPivote  = <3.029536, -0.987342, 4.790101>;
    LRAV_MoverBlobDedoMedio( NumeralBase, PuntoPivote )
    PuntoPivote
    component 1.000000, 0.284395, 
    #local PuntoPivote  = <2.987375, -0.987342, 4.635581>;
    LRAV_MoverBlobDedoMedio( NumeralBase, PuntoPivote )
    PuntoPivote
    component 1.000000, 0.284395, 
    #local PuntoPivote  = <2.987375, -0.987342, 4.944621>;
    LRAV_MoverBlobDedoMedio( NumeralBase, PuntoPivote )
    PuntoPivote

    texture {         
      LRAV_DefaultTexturaDedo
    }
 }
#end

#macro LRAV_LagartijaReptilAnimalVivo()    
  union         {
    object      {
      LRAV_BlobTronco()  
      scale     <1,0.75,1>
    }  
    object      {
      LRAV_BlobCola() 
      scale     <1,0.75,1>
    }
    object      {
      LRAV_BlobCabeza()
      scale     <0.90,0.75,1>
    }                
    object      {
      LRAV_AntePata( LRAV_EjeAntePataDI )
    }
    object      {
      LRAV_AntePata( LRAV_EjeAntePataDD )
    }
    object      {
      LRAV_AntePata( LRAV_EjeAntePataTI )
    }
    object      {
      LRAV_AntePata( LRAV_EjeAntePataTD )
    }  
    object      {
      LRAV_Pata( LRAV_EjePataDI )
    }
    object      {
      LRAV_Pata( LRAV_EjePataDD )
    }
    object      {
      LRAV_Pata( LRAV_EjePataTI )
    }
    object      {
      LRAV_Pata( LRAV_EjePataTD )
    }  
    object      {
      LRAV_DedoExterior( LRAV_EjeDedoExteriorDI )
    }
    object      {
      LRAV_DedoInterior( LRAV_EjeDedoInteriorDI )
    }
    object      {
      LRAV_DedoCentroExterior( LRAV_EjeDedoCentroExteriorDI )
    }
    object      {
      LRAV_DedoCentroInterior( LRAV_EjeDedoCentroInteriorDI )
    }
    object      {
      LRAV_DedoMedio( LRAV_EjeDedoMedioDI )
    }
    object      {
      LRAV_DedoExterior( LRAV_EjeDedoExteriorDD )
    }
    object      {
      LRAV_DedoInterior( LRAV_EjeDedoInteriorDD )
    }
    object      {
      LRAV_DedoCentroExterior( LRAV_EjeDedoCentroExteriorDD )
    }
    object      {
      LRAV_DedoCentroInterior( LRAV_EjeDedoCentroInteriorDD )
    }
    object      {
      LRAV_DedoMedio( LRAV_EjeDedoMedioDD )
    }
    object      {
      LRAV_DedoExterior( LRAV_EjeDedoExteriorTI )
    }
    object      {
      LRAV_DedoInterior( LRAV_EjeDedoInteriorTI )
    }
    object      {
      LRAV_DedoCentroExterior( LRAV_EjeDedoCentroExteriorTI )
    }
    object      {
      LRAV_DedoCentroInterior( LRAV_EjeDedoCentroInteriorTI )
    }
    object      {
      LRAV_DedoMedio( LRAV_EjeDedoMedioTI )
    }
    object      {
      LRAV_DedoExterior( LRAV_EjeDedoExteriorTD )
    }
    object      {
      LRAV_DedoInterior( LRAV_EjeDedoInteriorTD )
    }
    object      {
      LRAV_DedoCentroExterior( LRAV_EjeDedoCentroExteriorTD )
    }
    object      {
      LRAV_DedoCentroInterior( LRAV_EjeDedoCentroInteriorTD )
    }
    object      {
      LRAV_DedoMedio( LRAV_EjeDedoMedioTD )
    }
    scale       0.0065
  }
#end
 
#macro LRAV_Lagartija( MyArreglo )
  #local C      = 0;      
  #local TotalMyArreglo         = dimension_size( MyArreglo, 1 );
  #local BanderaActivo          = 
                ( dimension_size( MyArreglo, 2 ) <= 4 );
  #local BanderaExtra           = true;
  #while ( C < TotalMyArreglo )
    #if ( !( BanderaActivo ) )
      #local BanderaExtra       = MyArreglo[ C ][ 4 ];
    #end
    #if ( ( BanderaActivo ) | ( BanderaExtra ) )
      #local Eje  = MyArreglo[ C ][ 0 ];
      LRAV_KeyMovimiento( Eje )
      #declare LRAV_Movimiento[ Eje ][ LRAV_IndiceRotX ]  =
                                                MyArreglo[ C ][ 1 ];
      #declare LRAV_Movimiento[ Eje ][ LRAV_IndiceRotY ]  =
                                                MyArreglo[ C ][ 2 ];
      #declare LRAV_Movimiento[ Eje ][ LRAV_IndiceRotZ ]  =
                                                MyArreglo[ C ][ 3 ];
    #end
  #local C      = C+1;
  #end
  object        {
    LRAV_LagartijaReptilAnimalVivo()
  }
#end