// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 9 mayo 2011
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY 
//
// Las macros MFVS_Molinete1(), MFVS_Molinete2(), y MFVS_Molinete3()
// crean figuras muy similares, con variaciones en la textura
// La extructura que gira sobresale en direccion z-,
// la base del giro principal descansa en el origen.
// Radio Giro           : 57*L
// Grueso Giro          : 30*L (desde 0 hasta -30*L*z)
// Profundidad Palito   : 18*L*z
// Largo Palito         : 300*L (27*L*y hasta -273*L*y)
// Diametro Palito      : 5*L
//
// El objeto puede generarse via una macro principal de texturas
// #macro MFVS_MolineteFeriaVientoSoplo( Semilla, AnguloGiro,
//                Colorido1, Colorido2, Colorido3, Metalica )
//      Semilla                 : para aleatoriedad, misma semilla,
//                misma estructura de molinete.
//      AnguloGiro              : angulo de giro del molinete
//                cuando es cero, una hoja apunta hacia y+.
//      Colorido1               : una textura de las hojas del molinete.
//      Colorido2               : otra textura de las hojas del molinete.
//      Colorido3               : textura del palito.
//      Metalica                : textura del alambrito soporte.
//
// Las siguientes variables no deberian modificarse
// MFVS_TexturaColores1A
//      Define una textura de las hojas del molinete1.
// MFVS_TexturaColores1B
//      Otra textura de las hojas del molinete1.
// MFVS_TexturaColores1C
//      Textura del palito del molinete1.
// MFVS_TexturaColores2A
//      Define una textura de las hojas del molinete2.
// MFVS_TexturaColores2B
//      Otra textura de las hojas del molinete2.
// MFVS_TexturaColores2C
//      Textura del palito del molinete2.
// MFVS_TexturaColores3A
//      Define una textura de las hojas del molinete3.
// MFVS_TexturaColores3B
//      Otra textura de las hojas del molinete3.
// MFVS_TexturaColores3C
//      Textura del palito del molinete3.
// RBSA_TexturaMetalica
//      Define la textura del alambrito soporte.
//
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)
// #declare RBSA_POV3_1         = off;
//      Valor on activa modo de compatibilidad con POVRay 3.1.
//      En algunas versiones se activara automaticamente.
// #declare MFVS_DefaultTexturaColores1A        = texture ...
//      Define una textura default de las hojas del molinete1.
// #declare MFVS_DefaultTexturaColores1B        = texture ...
//      Otra textura default de las hojas del molinete1.
// #declare MFVS_DefaultTexturaColores1C        = texture ...
//      Textura default del palito del molinete1.
// #declare MFVS_DefaultTexturaColores2A        = texture ...
//      Define una textura default de las hojas del molinete2.
// #declare MFVS_DefaultTexturaColores2B        = texture ...
//      Otra textura default de las hojas del molinete2.
// #declare MFVS_DefaultTexturaColores2C        = texture ...
//      Textura del palito default del molinete2.
// #declare MFVS_DefaultTexturaColores3A        = texture ...
//      Define una textura default de las hojas del molinete3.
// #declare MFVS_DefaultTexturaColores3B        = texture ...
//      Otra textura default de las hojas del molinete3.
// #declare MFVS_DefaultTexturaColores3C        = texture ...
//      Textura default del palito del molinete3.
// #declare RBSA_DefaultTexturaMetalica         = texture ...
//      Define la textura default del alambrito soporte.
//
// Para colocarlo simplemente
// #include "MFVS.inc"
// object { MFVS_Molinete1() }
//
// Otro ejemplo con modificador
// #include "MFVS.inc"
// #declare MFVS_DefaultTexturaMetalica         = texture       {
//   average
//   texture_map        {
//     [ 0.5 MFVS_Rust                          ]
//     [ 0.5 MFVS_TexturaMetalica               ]
//   }
// }
// object       { MFVS_Molinete1() }
//    

#include "colors.inc"  
#include "textures.inc"
#include "MFVS_AUX.inc"
#include "metals.inc"

#if ( version < 3.2 )
  #ifndef( MFVS_POV3_1 )
    #declare MFVS_POV3_1        = on;
  #end
#else
  #ifndef( MFVS_POV3_1 )
    #declare MFVS_POV3_1        = off;
  #end
#end

#declare MFVS_L                 = 0.001;

#declare MFVS_TexturaColores1A          = texture       {
  pigment       {
    Candy_Cane
  }
}

#declare MFVS_TexturaColores2A          = texture       {
  #if ( MFVS_POV3_1 )
    Lightening1   
  #else
    Lightning1
  #end
}

#declare MFVS_TexturaColores3A          =
texture         {
  Cork
}
texture       {
  pigment       {
    Peel
  }
}

#declare MFVS_DefaultTexturaColores1A   = texture       {
  MFVS_TexturaColores1A
}

#declare MFVS_DefaultTexturaColores2A   = texture       {
  MFVS_TexturaColores2A
}

#declare MFVS_DefaultTexturaColores3A   = texture       {
  MFVS_TexturaColores3A
}

#declare MFVS_TexturaColores1B          = texture       {
  pigment       {
    radial
    frequency   10
  }
}

#declare MFVS_TexturaColores2B          = texture       {
  pigment       {
    Peel
  }
}

#declare MFVS_TexturaColores3B          = texture       {
  pigment       {
    Candy_Cane
  }
}

#declare MFVS_DefaultTexturaColores1B   = texture       {
  MFVS_TexturaColores1B
}

#declare MFVS_DefaultTexturaColores2B   = texture       {
  MFVS_TexturaColores2B
}

#declare MFVS_DefaultTexturaColores3B   = texture       {
  MFVS_TexturaColores3B
}

#declare MFVS_TexturaColores1C          = texture       {
  pigment       {
    hexagon
  }
}

#declare MFVS_TexturaColores2C          = texture       {
  pigment       {
    Candy_Cane
  }
}

#declare MFVS_TexturaColores3C          =
texture         {
  Cork
}
texture       {
  pigment       {
    Peel
  }
}

#declare MFVS_DefaultTexturaColores1C   = texture       {
  MFVS_TexturaColores1C
}

#declare MFVS_DefaultTexturaColores2C   = texture       {
  MFVS_TexturaColores2C
}

#declare MFVS_DefaultTexturaColores3C   = texture       {
  MFVS_TexturaColores3C
}

#declare MFVS_TexturaMetalica           = texture       {
  T_Chrome_3C
}

#declare MFVS_DefaultTexturaMetalica    = texture       {
  MFVS_TexturaMetalica
}

#macro MFVS_MolineteFeriaVientoSoplo( Semilla, AnguloGiro,
                Colorido1, Colorido2, Colorido3, Metalica )
  #local Aleatorio      = seed( Semilla );
  #local L              = MFVS_L;
  #local TotalAspas     = 8;
  #local AltoMolinete   = 57*L;
  #local GruesoMolinete = 28*L;
  #local PuntoMolinete  = < AltoMolinete, 0, -GruesoMolinete >;
  union                 {
    // Aspas
    #local PuntoNulo    = <0,0,0>;
    #local PuntoGuia1   = PuntoMolinete*<1.0,0.0,0.1>;
    #local PuntoAlto1   = PuntoMolinete*<0.5,0,1>;
    #local PuntoAlto    = PuntoMolinete*<0,0,1>+0.2*GruesoMolinete;
    #local PuntoFondo   = PuntoMolinete*<0.5,0,0.025>+0.2*GruesoMolinete*y;
    #local C            = 0;
    #local AspaSimple   = union                 {
        object          {
          MFVS_TrianguloEsfericoTriplePunto
               ( PuntoNulo, PuntoFondo, PuntoGuia1, 2*AltoMolinete,
                       0.01*GruesoMolinete, false )
        }
        object          {
          MFVS_PuenteTrianguloEsfericoTriplePunto
              ( PuntoFondo, PuntoGuia1, PuntoNulo, PuntoAlto1,
            2*AltoMolinete, 0.7*AltoMolinete, 0.01*GruesoMolinete, true )
        }
        object          {
          MFVS_TrianguloEsfericoTriplePunto
               ( PuntoNulo, PuntoGuia1, PuntoAlto1, 0.7*AltoMolinete,
                       0.01*GruesoMolinete, false )
        }
        object          {
          MFVS_TrianguloEsfericoTriplePunto
                ( PuntoAlto1, PuntoAlto, PuntoNulo, 0.7*AltoMolinete,
                                0.01*GruesoMolinete, false )
        }
    }
    #while ( C < TotalAspas )    
      union            {
        object          {
          AspaSimple
        }
        object          {
          AspaSimple
          rotate
                5*< rand( Aleatorio ), rand( Aleatorio ), rand( Aleatorio ) >
          texture       {
            Colorido2
            scale       0.02
          }
        }
//        scale           3*y
        rotate          -10*x
        rotate          C*360/TotalAspas*z
        rotate          AnguloGiro*z
        texture         {
          Colorido1
          scale         0.01
        }
      }
      #local C          = C+1;
    #end
    // Soporte Aspas
    cylinder            {
      +0.05*GruesoMolinete*z     , -1.01*GruesoMolinete*z
      0.1*GruesoMolinete
      texture           {
        Colorido1
        scale           0.002
      }
    }
    disc                {
      -1.0*GruesoMolinete*z      , z     ,
      0.2*GruesoMolinete
      texture           {
        Colorido3
        scale           0.01
      }
    }
    disc                {
      +0.05*GruesoMolinete*z      , z     ,
      0.2*GruesoMolinete
      texture           {
        Colorido3
        scale           0.01
      }
    }
    #local ProfundidadPalito    = 18*L;
    #local LargoPalito          = 300*L;
    #local DiametroPalito       = 5*L;
    #local DiametroAlambrito    = 0.5*L;
    // Alambrito
    union               {
      cylinder          {
        ProfundidadPalito*z+( DiametroPalito/2+DiametroAlambrito/2 )*x,
        -1.1*GruesoMolinete*z,
        DiametroAlambrito/2
      }
      #local C                  = 0;
      #local TotalTorusRollo    = 10;
      #while ( C < TotalTorusRollo )
        torus             {
          ( DiametroPalito/2+DiametroAlambrito/2 )        ,
          DiametroAlambrito/2
          translate             ProfundidadPalito*z
          translate             -C*1.3*DiametroAlambrito*y
        }
        #local C                = C+1;
      #end
      cylinder          {
        0               , -( TotalTorusRollo-1 )*1.3*DiametroAlambrito*y
            +ProfundidadPalito*z-( DiametroPalito/2+DiametroAlambrito/2 )*x
        DiametroAlambrito/2
      }
      union             {
        torus             {
          0.05*GruesoMolinete     , DiametroAlambrito/2
          rotate          90*x
          translate       0.025*GruesoMolinete*x
          rotate          1*rand( Aleatorio )
        }
        torus             {
          0.10*GruesoMolinete     , DiametroAlambrito/2
          rotate          90*x
          translate       0.050*GruesoMolinete*x
          rotate          1*rand( Aleatorio )
        }
        torus             {
          0.15*GruesoMolinete     , DiametroAlambrito/2
          rotate          90*x
          translate       0.02*GruesoMolinete*x
          rotate
            5*< rand( Aleatorio ), rand( Aleatorio ), rand( Aleatorio ) >
        }
        rotate          30*z
        rotate          5*rand( Aleatorio )
        translate       -1.1*GruesoMolinete*z
      }
      texture           {
        Metalica
      }
    }
    // Palito
    cylinder            {
      0                 , -LargoPalito*y        ,
      DiametroPalito/2
      translate         +0.09*LargoPalito*y+ProfundidadPalito*z
      texture           {
        Colorido3
        scale           0.01
      }
    }
  }
#end

#macro MFVS_Molinete1()
  object        {
    MFVS_MolineteFeriaVientoSoplo( 1020, 0,
      MFVS_DefaultTexturaColores1A,
      MFVS_DefaultTexturaColores2A,
      MFVS_DefaultTexturaColores3A,
      MFVS_DefaultTexturaMetalica )
  }
#end

#macro MFVS_Molinete2()
  object        {
    MFVS_MolineteFeriaVientoSoplo( 1100, 20,
      MFVS_DefaultTexturaColores1B,
      MFVS_DefaultTexturaColores2B,
      MFVS_DefaultTexturaColores3B,
      MFVS_DefaultTexturaMetalica )
  }
#end

#macro MFVS_Molinete3()
  object        {
    MFVS_MolineteFeriaVientoSoplo( 1300, 60,
      MFVS_DefaultTexturaColores1C,
      MFVS_DefaultTexturaColores2C,
      MFVS_DefaultTexturaColores3C,
      MFVS_DefaultTexturaMetalica )
  }
#end


