// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 15 febrero 2011
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY 
//
// Facil de usar, tan simple como
// #include "PCPD.inc"
// object       { PCPD_PeineEstiloGeneral() }
// object       { PCPD_PeineEstiloLargo()   }
// object       { PCPD_PeineEstiloPeineta() }
// object       { PCPD_CepilloPlano()       }
// Las macros anteriores generan versiones Default de los objetos
// Tambien se puede accesar a una macro principal
// #macro PCPD_PeineCorrientePlasticoDomestico
//                ( Estilo, ParametroExtra, TexturaPlastica )
//      Existen cuatro estilos predefinidos, que pueden servir como parametro
//      PCPD_EstiloGeneral
//              ParametroExtra
//                      Default 82*L
//                      Modifica el tamano del peine ( sector dentado )
//                      a lo largo
//                      El total de dientes se modifica en forma proporcional
//              TexturaPlastica
//                      Permite cambiar la textura
//                      Default PCPD_TexturaEstiloGeneralDefault
//      PCPD_EstiloLargo
//              ParametroExtra
//                      Default 64*L
//                      Modifica el tamano del peine ( sector dentado )
//                      a lo largo
//                      El total de dientes se modifica en forma proporcional
//              TexturaPlastica
//                      Permite cambiar la textura
//                      Default PCPD_TexturaEstiloLargoDefault
//      PCPD_EstiloPeineta
//              ParametroExtra
//                      Permite cambiar textura rugosa del decorado
//                      en la peineta (hundimiento del soporte)
//                      Default PCPD_TexturaPeinetaAuxiliarDefault
//              TexturaPlastica
//                      Permite modificar la textura principal de la peineta
//                      Default PCPD_TexturaEstiloPeinetaDefault
//      PCPD_EstiloCepilloPlano
//              ParametroExtra
//                      Permite cambiar la textura del pelo del cepillo
//                      Default PCPD_TexturaPeloCepilloDefault
//              TexturaPlastica
//                      Permite cambiar la textura del soporte plastico
//                      Default PCPD_TexturaCepilloPlanoDefault
//
// PCPD_EstiloGeneral
// LargoPeine           = 90*L
// AnchoPeine           = 26*L
// GruesoPeine          = 1.5*L
// Los dientes apuntan hacia x+
// Base de dientes centrada en plano zy
// PCPD_EstiloLargo
// LargoPeine           = 105*L
// LargoDentaduraSola   = 64*L
// AnchoPeine           = 19*L
// GruesoPeine          = 1.8*L
// Los dientes apuntan hacia x+
// Base inferior de dientes centrada en origen plano zy
// zona superior hacia y+, agarradera y-
// PCPD_EstiloPeineta
// LargoPeine           = 142*L
// AnchoPeine           = 30*L
// GruesoPeine          = 3.5*L
// Los dientes apuntan hacia y+
// Base inferior de dientes centrada en plano xz
// PCPD_EstiloCepilloPlano
// LargoBasePlastica    = 194*L
// AnchoBasePlastica    = 24*L
// GruesoBasePlastica   = 7*L
// AlturaPelos          = 14*L ( exceso superficie )
// Pelos apuntan hacia z-, con cabeza de cepillo hacia y+
// Origen centrado en "z" y "x" en la Base Plastica
// Respecto a "y" el origen divide la zona de pelos de la agarradera
//
// Se declaran las siguientes variables textura "default"
// que no deberian modificarse
// #declare PCPD_TexturaEstiloGeneral
//      Se refiere a la textura del Peine estilo general
// #declare PCPD_TexturaEstiloLargo
//      Se refiere a la textura del Peine estilo largo
// #declare PCPD_TexturaEstiloPeineta
//      Se refiere a la textura de la peineta
// #declare PCPD_TexturaPeinetaAuxiliar
//      Se refiere a la textura granulada de la peineta
// #declare PCPD_TexturaCepilloPlano
//      Se refiere a la textura de la base del cepillo
// #declare PCPD_TexturaPeloCepillo
//      Se refiere a la textura del "pelo" del cepillo
//
// El archivo posee los siguientes modificadores
// #declare PCPD_POV3_1                 = off;
//      Para activar modo de compatibilidad con POVRay 3.1.
//      en algunas versiones se activa automaticamente.
//      Deberia activarse antes del include      
// #declare PCPD_TexturaEstiloGeneralDefault    =
//              texture { PCPD_TexturaEstiloGeneral     }
//      Se refiere a la textura del Peine estilo general
// #declare PCPD_TexturaEstiloLargoDefault      =
//              texture { PCPD_TexturaEstiloLargo       }
//      Se refiere a la textura del Peine estilo largo
// #declare PCPD_TexturaEstiloPeinetaDefault    =
//              texture { PCPD_TexturaEstiloPeineta     }
//      Se refiere a la textura de la peineta
// #declare PCPD_TexturaPeinetaAuxiliarDefault  =
//              texture { PCPD_TexturaPeinetaAuxiliar   }
//      Se refiere a la textura granulada de la peineta
// #declare PCPD_TexturaCepilloPlanoDefault     =
//              texture { PCPD_TexturaCepilloPlano      }
//      Se refiere a la textura de la base del cepillo
// #declare PCPD_TexturaPeloCepilloDefault      =
//              texture { PCPD_TexturaPeloCepillo       }
//      Se refiere a la textura del "pelo" del cepillo
//
// #include "PCPD.inc"
// #include "textures.inc"
// #declare PCPD_TexturaEstiloGeneralDefault = texture       {
//      average
//      texture_map     {
//              [ 0.5 PCPD_TexturaEstiloGeneral ]
//              [ 0.5 RustyIron                 ]
//      }
// }
// object               {
//   STMC_PeineEstiloGeneral()
// }
//
// Aclaracion:
// Las macros STMC_Reorient_Trans y STMC_Axis_Rotate_Trans
// se transcribe casi identica a la original
// en "transforms.inc" Reorient_Trans y Axis_Rotate_Trans
// se copia por compatibilidad con POVRay 3.1.
// La macro STMC_VPerp_To_Vector
// se tomo de "math.inc" VPerp_To_Vector
// por compatibilidad con POVRay 3.1.
//


#include "colors.inc"
#include "woods.inc"
#include "PCPD_Aux.inc"

#if ( version < 3.2 )
  #ifndef( PCPD_POV3_1 )
    #declare PCPD_POV3_1        = on;
  #end
#else
  #ifndef( PCPD_POV3_1 )
    #declare PCPD_POV3_1        = off;
  #end
#end

#declare PCPD_L                 = 0.001;

#ifndef ( PCPD_HairTexture )
  #declare PCPD_HairTexture  = texture { pigment { Gray30 } }
#end


#macro PCPD_Dientes ( TotalDientes, FraccionInclinado )
  // desde -1 hasta 1 en y, apunta hacia x+, en z tambien de -1 a 1
  difference            {
    union                 {
      #local Separacion   = 1/TotalDientes;
      #local D            = 0;
      #local Base         = -1+Separacion/2;
      #while ( D < TotalDientes )
        box               {
          < 0     , Base  , -1    >,
          < 1     , Base+Separacion       , 1     >
        }
        #local Base       = Base+2*Separacion;
        #local D          = D+1;
      #end
    }
    #local AnguloPlane  = degrees( asin( FraccionInclinado/sqrt( 1+FraccionInclinado*FraccionInclinado ) ) );
    plane               {
      z         , 0
      rotate    -AnguloPlane*y
      translate -z
    }
    plane               {
      -z        , 0
      rotate    AnguloPlane*y
      translate z
    }
  }
#end

#declare PCPD_EstiloGeneral             = 1;
#declare PCPD_EstiloLargo               = 2;
#declare PCPD_EstiloPeineta             = 3;
#declare PCPD_EstiloCepilloPlano        = 4;

#declare PCPD_TexturaEstiloGeneral              = texture       {
  pigment       {
    checker
    color       NewTan
    color       VeryDarkBrown
    scale       0.02
    turbulence  0.3
  }
  normal                {
    wrinkles
    scale       0.01
  }
}

#declare PCPD_TexturaEstiloLargo                = texture       {
  pigment       { Gray30 }
  normal        { granite scale 0.1 }
}

#declare PCPD_TexturaEstiloPeineta              = texture       {
  pigment       { Blue }
}

#declare PCPD_TexturaPeinetaAuxiliar            = texture       {
  pigment       { Blue }
  normal        { granite scale 0.001 }
}

#declare PCPD_TexturaCepilloPlano               = texture       {
  T_Wood9
}

#declare PCPD_TexturaPeloCepillo                = texture       {
  pigment       { Gray30 }
}

#ifndef ( PCPD_TexturaPeloCepilloDefault )
  #declare PCPD_TexturaPeloCepilloDefault       = texture       {
    PCPD_TexturaPeloCepillo
  }
#end

#ifndef ( PCPD_TexturaCepilloPlanoDefault )
  #declare PCPD_TexturaCepilloPlanoDefault      = texture       {
    PCPD_TexturaCepilloPlano
  }
#end

#ifndef ( PCPD_TexturaEstiloGeneralDefault )
  #declare PCPD_TexturaEstiloGeneralDefault     = texture       {
    PCPD_TexturaEstiloGeneral
  }
#end

#ifndef ( PCPD_TexturaEstiloLargoDefault )
  #declare PCPD_TexturaEstiloLargoDefault       = texture       {
    PCPD_TexturaEstiloLargo
  }
#end

#ifndef ( PCPD_TexturaEstiloPeinetaDefault )
  #declare PCPD_TexturaEstiloPeinetaDefault     = texture       {
    PCPD_TexturaEstiloPeineta
  }
#end

#ifndef ( PCPD_TexturaPeinetaAuxiliarDefault )
  #declare PCPD_TexturaPeinetaAuxiliarDefault     = texture       {
    PCPD_TexturaPeinetaAuxiliar
  }
#end

#macro PCPD_PeineCorrientePlasticoDomestico
                ( Estilo, ParametroExtra, TexturaPlastica )
   #local L                     = PCPD_L;
   #switch ( Estilo )
     #case  ( PCPD_EstiloGeneral )
       #local LargoDientes      = ParametroExtra;
       #local TamanoDientes     = 14*L;
       #local AnchoDientes      = 1.5*L;
       #local FraccionDiente    = 0.5;
       #local AnchoSuperior     = 7*L;
       #local GruesoSuperior    = 3.5*L;
       union            {
         object         {
           PCPD_Dientes( 23*LargoDientes/(82*L), FraccionDiente )
           scale        < TamanoDientes, LargoDientes/4, AnchoDientes/2 >
           translate    LargoDientes/4*y
         }
         object         {
           PCPD_Dientes( 34*LargoDientes/(82*L), FraccionDiente )
           scale        < TamanoDientes, LargoDientes/4, AnchoDientes/2 >
           translate    -LargoDientes/4*y
         }
         #local Superior1       = < TamanoDientes, LargoDientes/2, 0 >;
         #local Superior2       =
              < 0, LargoDientes/2+2*GruesoSuperior/3, 0 >;
         #local Superior3       = < -AnchoSuperior, LargoDientes/2, 0 >;
         #local Superior4       = Superior1*<1,-1,1>;
         #local Superior5       = Superior2*<1,-1,1>;
         #local Superior6       = Superior3*<1,-1,1>;
         #local Medio7          = < -1.5*AnchoSuperior,0,0>;
         object       {
           PCPD_SegmentoTriplePunto
           ( Superior1, Superior2, Superior3, AnchoDientes, true, false )
         }
         object       {
           PCPD_SweepTriplePunto
           ( Superior1, Superior2, Superior3, AnchoDientes/2, false )
         }
         object         {
           PCPD_SegmentoTriplePunto
           ( Superior3, Medio7, Superior6, AnchoDientes, true, true )
         }
         object       {
           PCPD_SegmentoTriplePunto
           ( Superior4, Superior5, Superior6, AnchoDientes, true, false )
         }
         object       {
           PCPD_SweepTriplePunto
           ( Superior4, Superior5, Superior6, AnchoDientes/2, false )
         }
         box            {
           Superior6-AnchoDientes/2*z,
           Superior2*<1,0,1>+AnchoDientes/2*z+LargoDientes/2*y
         }
         texture        {
           TexturaPlastica
         }
       }
     #break
     #case  ( PCPD_EstiloLargo )
       #local LargoDientes      = ParametroExtra;
       #local TamanoDientes     = 12*L;
       #local AnchoDientes      = 1.8*L;
       #local FraccionDiente    = 0.35;
       #local AnchoSuperior     = 5*L;
       #local GruesoSuperior    = 2.5*L;
       #local LargoBase         = 75*L;
       union            {
         object         {
           PCPD_Dientes( 52, FraccionDiente )
           scale        < TamanoDientes, LargoDientes/2, AnchoDientes/2 >
         }
         #local Superior1       = < TamanoDientes, LargoDientes/2, 0 >;
         #local Superior2       =
              < 0, LargoDientes/2+2*GruesoSuperior/3, 0 >;
         #local Superior3       = < -AnchoSuperior, LargoDientes/2, 0 >;
         #local Superior4       = Superior1*<1,-1,1>;
         #local Superior5       = Superior2*<1,-1,1>;
         #local Superior6       = Superior3*<1,-1,1>;
         #local Medio7          = < -1.1*AnchoSuperior,0,0>;
         #local Base0           =
                < -2*AnchoSuperior/5, -LargoBase-LargoDientes/2, 0 >;
         object       {
           PCPD_SegmentoTriplePunto
           ( Superior1, Superior2, Superior3, AnchoDientes, true, false )
         }
         object       {
           PCPD_SweepTriplePunto
           ( Superior1, Superior2, Superior3, AnchoDientes/2, false )
         }
         object         {
           PCPD_SegmentoTriplePunto
           ( Superior3, Medio7, Superior6, AnchoDientes, true, true )
         }
         object       {
           PCPD_SegmentoTriplePunto
           ( Superior4, Superior5, Superior6, AnchoDientes, true, false )
         }
         object       {
           PCPD_SweepTriplePunto
           ( Superior4, Superior5, Superior6, AnchoDientes/2, false )
         }
         box            {
           Superior6-AnchoDientes/2*z,
           Superior2*<1,0,1>+AnchoDientes/2*z+LargoDientes/2*y
         }
         object       {
           PCPD_SegmentoTriplePunto
           ( Base0, Superior6, Superior2, AnchoDientes, true, true )
         }
         object       {
           PCPD_SegmentoTriplePunto
           ( Base0, Superior5, Superior2, AnchoDientes, true, true )
         }
         object       {
           PCPD_SweepTriplePunto
           ( Superior4, Superior5+1.5*GruesoSuperior*x,
                 1.0*Superior6-1.5*GruesoSuperior*y+0.5*GruesoSuperior*x,
                AnchoDientes/2, false )
         }
         translate      LargoDientes/2*y
         texture        {
           TexturaPlastica
         }
       }
     #break
     #case ( PCPD_EstiloPeineta )
       #local BasePeineta       = 26*L;
       #local TotalDientes      = 7;
       #local LargoDientes      = 45*L;
       #local DiametroDientes   = 3.5*L;
       #local DiametroFinal     = 1.5*L;
       #local LargoBase         = 94*L;
       #local BaseBase          = < BasePeineta/2, LargoBase, 0 >;
       #local BaseA             = < 1, 0, 0 >*BaseBase;
       #local BaseB             = < 1, 0.04, 0 >*BaseBase;
       #local BaseC             = < 0.25, 0.07, 0 >*BaseBase;
       #local BaseD             = < 0.05, 0.38, 0 >*BaseBase;
       #local BaseE             = < 0, 1, 0 >*BaseBase;
       union            {
         #local D               = 0;
         #while ( D < TotalDientes )
           cone                 {
             0                  , DiametroDientes/2,
             LargoDientes*y     , DiametroFinal/2
             translate
               ( -BasePeineta/2+D*BasePeineta/( TotalDientes-1 ) )*x
           }
           sphere                 {
             LargoDientes*y       , DiametroFinal/2
             translate   ( -BasePeineta/2+D*BasePeineta/( TotalDientes-1 ) )*x
           }
           #local D             = D+1;
         #end
         union          {
           difference           {
             prism              {
               linear_sweep
               linear_spline
               -DiametroDientes/2,
               DiametroDientes/2,
               10,
               < BaseA.x, BaseA.y >,
               < BaseB.x, BaseB.y >,
               < BaseC.x, BaseC.y >,
               < BaseD.x, BaseD.y >,
               < BaseE.x, BaseE.y >,
               <-BaseD.x, BaseD.y >,
               <-BaseC.x, BaseC.y >,
               <-BaseB.x, BaseB.y >,
               <-BaseA.x, BaseA.y >,
               < BaseA.x, BaseA.y >
               rotate   -90*x
             }
             cone       {
               BasePeineta/4*y, BasePeineta/10,
               BasePeineta*y, 0
               scale            <1,1,0.2>
               translate        DiametroDientes/2*z
               texture  { ParametroExtra }
             }
             sphere     {
               BasePeineta/4*y, BasePeineta/10
               scale            <1,1,0.2>
               translate        DiametroDientes/2*z
               texture  { ParametroExtra }
             }
             sphere     {
               BasePeineta/4*y, BasePeineta/10
               scale            <1,1,0.2>
               translate        -DiametroDientes/2*z
               texture  { ParametroExtra }
             }
             cone       {
               BasePeineta/4*y, BasePeineta/10,
               BasePeineta*y, 0
               scale            <1,1,0.2>
               translate        -DiametroDientes/2*z
               texture  { ParametroExtra }
             }
           }
           sphere       {
             BaseB, DiametroDientes/2
           }
           sphere       {
             BaseC, DiametroDientes/2
           }
           sphere       {
             BaseD, DiametroDientes/2
           }
           sphere       {
             BaseE, DiametroDientes/2
           }
           sphere       {
             BaseB, DiametroDientes/2
             scale      <-1,1,1>
           }
           sphere       {
             BaseC, DiametroDientes/2
             scale      <-1,1,1>
           }
           sphere       {
             BaseD, DiametroDientes/2
             scale      <-1,1,1>
           }
           cylinder     {
             BaseA, BaseA*<-1,1,1>, DiametroDientes/2
           }
           cylinder     {
             BaseA, BaseB, DiametroDientes/2
           }
           cylinder     {
             BaseB, BaseC, DiametroDientes/2
           }
           cylinder     {
             BaseC, BaseD, DiametroDientes/2
           }
           cylinder     {
             BaseD, BaseE, DiametroDientes/2
           }
           cylinder     {
             BaseA, BaseB, DiametroDientes/2
             scale      <-1,1,1>
           }
           cylinder     {
             BaseB, BaseC, DiametroDientes/2
             scale      <-1,1,1>
           }
           cylinder     {
             BaseC, BaseD, DiametroDientes/2
             scale      <-1,1,1>
           }
           cylinder     {
             BaseD, BaseE, DiametroDientes/2
             scale      <-1,1,1>
           }
           rotate       180*x
         }
         texture        {
           TexturaPlastica
         }
       }
     #break
     #case ( PCPD_EstiloCepilloPlano )
       #local LargoPelo         = 64*L;
       #local AnchoPelo         = 21.5*L;
       #local LargoBase         = 125*L;
       #local AnchoBase         = 7*L;
       #local GruesoCepillo     = 8.6*L;
       #local FinalExtra        = 1*L;
       #local FraccionBorde     = 1/2;
       #local BaseA             = < AnchoPelo/2, LargoPelo, 0 >;
       #local BaseB             = < AnchoPelo/2, 0, 0 >;
       #local BaseC             = < AnchoBase/2, -LargoBase, 0 >;
       #local EjeCurva          = ( BaseB+BaseC )/2;
       #local Curva             = ( ( EjeCurva+BaseB )/2 )*<0.4,1,1>;
       #local BaseA2            = BaseA*<-1,1,1>;
       #local BaseB2            = BaseB*<-1,1,1>;
       #local BaseC2            = BaseC*<-1,1,1>;
       #local EjeCurva2         = EjeCurva*<-1,1,1>;
       #local Curva2            = Curva*<-1,1,1>;

#local   PCPD_Pelos1         = union {
  #local   PCPD_S            = seed( 1235 );
  #local   PCPD_LargoPelo    = 1000*PCPD_L;
  #local   PCPD_Sita         = 0;
  #local   PCPD_Ro           = pi/30;
  #local   PCPD_DeltaRo      = PCPD_Ro/3;
  #local   PCPD_DeltaSita    = pi/5;
  #while ( PCPD_Ro > 0 )
    #local   PCPD_Sita       = PCPD_DeltaSita*rand( PCPD_S );
    #while ( PCPD_Sita < 2*pi )
      #local   PCPD_LargoActualPelo  = PCPD_LargoPelo
                        *( 1+0.1*rand( PCPD_S ) );
      cylinder    {
        0         ,
        < PCPD_LargoActualPelo*sin( PCPD_Ro )*cos( PCPD_Sita ), 
                PCPD_LargoActualPelo,
                  PCPD_LargoActualPelo*sin( PCPD_Ro )*sin( PCPD_Sita ) >, 
                  10*PCPD_L
        texture         { ParametroExtra }
        rotate          -90*x
        scale           17.5*PCPD_L/PCPD_LargoPelo
      }
      #local   PCPD_Sita     = PCPD_Sita+PCPD_DeltaSita;
    #end
    #local   PCPD_Ro         = PCPD_Ro-PCPD_DeltaRo;
  #end
}

       union            {
         difference     {
           prism        {
             linear_sweep
             linear_spline
             -GruesoCepillo/2,
             GruesoCepillo/2,
             7,
             < BaseA.x, BaseA.y>,
             < BaseB.x, BaseB.y>,
             < BaseC.x, BaseC.y>,
             <-BaseC.x, BaseC.y>,
             <-BaseB.x, BaseB.y>,
             <-BaseA.x, BaseA.y>,
             <-BaseA.x, BaseA.y>
             rotate     -90*x
           }
           object       {
             PCPD_SegmentoTriplePunto
               ( BaseB , Curva , EjeCurva , 1.1*GruesoCepillo, false, false )
           }
           object       {
             PCPD_SegmentoTriplePunto
               ( BaseB2, Curva2, EjeCurva2, 1.1*GruesoCepillo, false, false )
           }
         }
         #local Superior        = < 0, LargoPelo+FinalExtra, 0 >;
         #local Inferior        = < 0,-LargoBase-FinalExtra, 0 >;
         union          {
           object         {
             PCPD_SegmentoTriplePunto( BaseA, Superior, BaseA2,
                          GruesoCepillo*FraccionBorde, true, true )
           }
           cylinder             {
             BaseC, BaseC2, GruesoCepillo*FraccionBorde/2
           }
           cylinder             {
             BaseA, BaseB, GruesoCepillo*FraccionBorde/2
           }
           cylinder             {
             EjeCurva, BaseC, GruesoCepillo*FraccionBorde/2
           }
           cylinder             {
             BaseA2, BaseB2, GruesoCepillo*FraccionBorde/2
           }
           cylinder             {
             EjeCurva2, BaseC2, GruesoCepillo*FraccionBorde/2
           }
           sphere               {
             BaseC, GruesoCepillo*FraccionBorde/2
           }
           sphere               {
             BaseC2, GruesoCepillo*FraccionBorde/2
           }
           object         {
             PCPD_SweepTriplePunto( BaseB, Curva, EjeCurva,
                        GruesoCepillo*FraccionBorde/2, true )
           }
           object         {
             PCPD_SweepTriplePunto( BaseB2, Curva2, EjeCurva2,
                        GruesoCepillo*FraccionBorde/2, true )

           }
           scale        <1,1,1/FraccionBorde>
         }
         #local HileraPelos     = 5;
         #local ColumnaPelos    = 13;
         #local E               = 0;
         #while ( E < ColumnaPelos )
           #local D             = 0;
           #while ( D < HileraPelos )
             object         {
               PCPD_Pelos1
               translate
                   +( -AnchoPelo/2+AnchoPelo/( HileraPelos )*( 0.75+D ) )*x
               #switch ( D )
                 #case ( 0 )
                 #case ( 4 )
                   translate    +LargoPelo/( ColumnaPelos)*( 0.5+E )*y
                 #break
                 #case ( 1 )
                 #case ( 3 )
                   translate    +LargoPelo/( ColumnaPelos)*( 0.25+1.025*E )*y
                 #break
                 #case ( 2 )
                   translate    +LargoPelo/( ColumnaPelos)*( 0.00+1.05*E )*y
                 #break
               #end
             }
             #local D           = D+1;
           #end
           #local E             = E+1;
         #end
         texture        {
           TexturaPlastica
         }
       }
     #break
   #end
#end

#macro PCPD_PeineEstiloGeneral()
  #local LargoDientes      = 82*PCPD_L;
  object        {
    PCPD_PeineCorrientePlasticoDomestico
        ( PCPD_EstiloGeneral, LargoDientes, PCPD_TexturaEstiloGeneralDefault )
  }
#end

#macro PCPD_PeineEstiloLargo()
  #local LargoDientes      = 64*PCPD_L;
  object        {
    PCPD_PeineCorrientePlasticoDomestico
        ( PCPD_EstiloLargo, LargoDientes, PCPD_TexturaEstiloLargoDefault )
  }
#end

#macro PCPD_PeineEstiloPeineta()
  object        {
    PCPD_PeineCorrientePlasticoDomestico
        ( PCPD_EstiloPeineta, PCPD_TexturaPeinetaAuxiliarDefault,
                PCPD_TexturaEstiloPeinetaDefault )
  }
#end

#macro PCPD_CepilloPlano()
  object        {
    PCPD_PeineCorrientePlasticoDomestico
        ( PCPD_EstiloCepilloPlano,
          PCPD_TexturaPeloCepilloDefault, PCPD_TexturaCepilloPlanoDefault )
  }
#end

