// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 15 febrero 2011
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY 
//
// Facil de usar, tan simple como
// #include "PCPD.inc"
// object       { PCPD_PeineEstiloGeneral() }
// object       { PCPD_PeineEstiloLargo()   }
// object       { PCPD_PeineEstiloPeineta() }
// object       { PCPD_CepilloPlano()       }
// Las macros anteriores generan versiones Default de los objetos
// Tambien se puede accesar a una macro principal
// #macro PCPD_PeineCorrientePlasticoDomestico
//                ( Estilo, ParametroExtra, TexturaPlastica )
//      Existen cuatro estilos predefinidos, que pueden servir como parametro
//      PCPD_EstiloGeneral
//              ParametroExtra
//                      Default 82*L
//                      Modifica el tamano del peine ( sector dentado )
//                      a lo largo
//                      El total de dientes se modifica en forma proporcional
//              TexturaPlastica
//                      Permite cambiar la textura
//                      Default PCPD_TexturaEstiloGeneralDefault
//      PCPD_EstiloLargo
//              ParametroExtra
//                      Default 64*L
//                      Modifica el tamano del peine ( sector dentado )
//                      a lo largo
//                      El total de dientes se modifica en forma proporcional
//              TexturaPlastica
//                      Permite cambiar la textura
//                      Default PCPD_TexturaEstiloLargoDefault
//      PCPD_EstiloPeineta
//              ParametroExtra
//                      Permite cambiar textura rugosa del decorado
//                      en la peineta (hundimiento del soporte)
//                      Default PCPD_TexturaPeinetaAuxiliarDefault
//              TexturaPlastica
//                      Permite modificar la textura principal de la peineta
//                      Default PCPD_TexturaEstiloPeinetaDefault
//      PCPD_EstiloCepilloPlano
//              ParametroExtra
//                      Permite cambiar la textura del pelo del cepillo
//                      Default PCPD_TexturaPeloCepilloDefault
//              TexturaPlastica
//                      Permite cambiar la textura del soporte plastico
//                      Default PCPD_TexturaCepilloPlanoDefault
//
// PCPD_EstiloGeneral
// LargoPeine           = 90*L
// AnchoPeine           = 26*L
// GruesoPeine          = 1.5*L
// Los dientes apuntan hacia x+
// Base de dientes centrada en plano zy
// PCPD_EstiloLargo
// LargoPeine           = 105*L
// LargoDentaduraSola   = 64*L
// AnchoPeine           = 19*L
// GruesoPeine          = 1.8*L
// Los dientes apuntan hacia x+
// Base inferior de dientes centrada en origen plano zy
// zona superior hacia y+, agarradera y-
// PCPD_EstiloPeineta
// LargoPeine           = 142*L
// AnchoPeine           = 30*L
// GruesoPeine          = 3.5*L
// Los dientes apuntan hacia y+
// Base inferior de dientes centrada en plano xz
// PCPD_EstiloCepilloPlano
// LargoBasePlastica    = 194*L
// AnchoBasePlastica    = 24*L
// GruesoBasePlastica   = 7*L
// AlturaPelos          = 14*L ( exceso superficie )
// Pelos apuntan hacia z-, con cabeza de cepillo hacia y+
// Origen centrado en "z" y "x" en la Base Plastica
// Respecto a "y" el origen divide la zona de pelos de la agarradera
//
// Se declaran las siguientes variables textura "default"
// que no deberian modificarse
// #declare PCPD_TexturaEstiloGeneral
//      Se refiere a la textura del Peine estilo general
// #declare PCPD_TexturaEstiloLargo
//      Se refiere a la textura del Peine estilo largo
// #declare PCPD_TexturaEstiloPeineta
//      Se refiere a la textura de la peineta
// #declare PCPD_TexturaPeinetaAuxiliar
//      Se refiere a la textura granulada de la peineta
// #declare PCPD_TexturaCepilloPlano
//      Se refiere a la textura de la base del cepillo
// #declare PCPD_TexturaPeloCepillo
//      Se refiere a la textura del "pelo" del cepillo
//
// El archivo posee los siguientes modificadores
// #declare PCPD_POV3_1                 = off;
//      Para activar modo de compatibilidad con POVRay 3.1.
//      en algunas versiones se activa automaticamente.
//      Deberia activarse antes del include      
// #declare PCPD_TexturaEstiloGeneralDefault    =
//              texture { PCPD_TexturaEstiloGeneral     }
//      Se refiere a la textura del Peine estilo general
// #declare PCPD_TexturaEstiloLargoDefault      =
//              texture { PCPD_TexturaEstiloLargo       }
//      Se refiere a la textura del Peine estilo largo
// #declare PCPD_TexturaEstiloPeinetaDefault    =
//              texture { PCPD_TexturaEstiloPeineta     }
//      Se refiere a la textura de la peineta
// #declare PCPD_TexturaPeinetaAuxiliarDefault  =
//              texture { PCPD_TexturaPeinetaAuxiliar   }
//      Se refiere a la textura granulada de la peineta
// #declare PCPD_TexturaCepilloPlanoDefault     =
//              texture { PCPD_TexturaCepilloPlano      }
//      Se refiere a la textura de la base del cepillo
// #declare PCPD_TexturaPeloCepilloDefault      =
//              texture { PCPD_TexturaPeloCepillo       }
//      Se refiere a la textura del "pelo" del cepillo
//
// #include "PCPD.inc"
// #include "textures.inc"
// #declare PCPD_TexturaEstiloGeneralDefault = texture       {
//      average
//      texture_map     {
//              [ 0.5 PCPD_TexturaEstiloGeneral ]
//              [ 0.5 RustyIron                 ]
//      }
// }
// object               {
//   STMC_PeineEstiloGeneral()
// }
//
// Aclaracion:
// Las macros STMC_Reorient_Trans y STMC_Axis_Rotate_Trans
// se transcribe casi identica a la original
// en "transforms.inc" Reorient_Trans y Axis_Rotate_Trans
// se copia por compatibilidad con POVRay 3.1.
// La macro STMC_VPerp_To_Vector
// se tomo de "math.inc" VPerp_To_Vector
// por compatibilidad con POVRay 3.1.
//

#include "colors.inc"
#include "PCPD.inc"

#declare OjoAbsoluto            = 256;
#declare VecesCentroAbsoluto    = 10;     
#declare L                      = 0.001;
camera {
        location  <   0,  0, -( VecesCentroAbsoluto+1 )*OjoAbsoluto >*L
        direction z
        sky       y
        angle     38.74
//        look_at  <   0,  0, -VecesCentroAbsoluto*OjoAbsoluto >*L
}         
light_source    {
         < 500  , 500   , -3000 >*L
         White
}
background      {
         Gray50
}    

object  {
  PCPD_PeineEstiloGeneral( )
  translate     -0.150*x-2.26*z
}

object  {
  PCPD_PeineEstiloLargo( )
  translate     -0.050*x-2.26*z
}

object  {
  PCPD_PeineEstiloPeineta( )
  translate     +0.050*x-2.26*z
}

object  {
  PCPD_CepilloPlano( )
  translate     +0.150*x-2.26*z
}

