// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 9 mayo 2011
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY 
//
// La macro RDVM_Rosario()
// crea un Rosario catolico para decoracion de pared
// Su posicion inicial descansa en el plano XY, hacia z-;
// aproximadamente centrado en el origen.
// Sus dimensiones son ligeramente superiores a
// Ancho Frontal        = 600*L
// Alto                 = 500*L
// Profundidad          = 21*L
//
// El objeto puede generarse via una macro principal de texturas
// #macro RDVM_RosarioDevocionVirgenMaria
//          ( Semilla, Tension1, Tension2, Angulo2,
//                TexturaCuentaBasica, TexturaMetal,
//                TexturaMadera, MaterialCruz, MaterialCruzMenor,
//                TexturaMedalla )
//      Semilla                 : para aleatoriedad, misma semilla,
//              misma estructura de rosario.
//      Tension1                : default es 0.5.  Controla la tension
//              en la cadena superior del rosario.  Mayor tension,
//              eleva el centro de la cadena.  En fisica seria el valor
//              proporcional ( Tension/Densidad ).
//      Tension2                : default es 0.5.  Controla la tension
//              en la cadena inferior del rosario, sin contar el angulo.
//      Angulo2                 : default es 15 grados.  Angulo aproximado
//              que forma el triangulo de madera con la cadena.
//      TexturaCuentaBasica     : default es RDVM_DefaultTexturaCuentaBasica.
//              Textura a aplicar en las bolitas del rosario.
//      TexturaMetal            : default es RDVM_DefaultTexturaMetal.
//              Textura a aplicar en las cadenas y la decoracion de las
//              bolitas del rosario.
//      TexturaMadera           : default es RDVM_DefaultTexturaMadera.
//              Textura a aplicar en el triangulo de madera que cierra
//              el rosario.
//      MaterialCruz            : default es RDMV_DefaultMaterialCruz.
//              Material a aplicar en la cruz inferior.
//      MaterialCruzMenor       : default es RDVM_DefaultMaterialCruz2.
//              Material a aplicar en la crucecita decorativo  del triangulo.
//      TexturaMedalla          : default es RDVM_DefaultTexturaMedalla.
//              Textura a aplicar en la medallita que sirve de fondo
//              en el triangulo de madera.
//
// Las siguientes variables no deberian modificarse
// RDVM_PuntoCruz
//      Establece la posicion superior de la cruz.
//      Podria ser util ante un eventual cambio de crucifijo.
// RDVM_TexturaCuentaBasica
//      Textura a aplicar en las bolitas del rosario.
// RDVM_TexturaMetalica
//      Textura a aplicar en las cadenas y la decoracion de las
//      bolitas del rosario.
// RDVM_TexturaMadera
//      Textura a aplicar en el triangulo de madera que cierra el rosario.
// RDVM_MaterialCruz
//      Material a aplicar en la cruz principal.
// RDVM_MaterialCruz2
//      Material a aplicar en la crucecita decorativa del triangulo.
// RDVM_TexturaMedalla
//      Textura a aplicar en la medallita que sirve de fondo
//      en el triangulo de madera.
//
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)
// #declare RDVM_VisibleCruz    = on;
//      Valor off no dibuja la cruz.  La cruz original tenia
//      figura de Jesus, que se sustituyo por una mas simple.
//      Este modificador esta previsto para la sencilla
//      sustitucion del crucifijo.
//      Ver RDVM_PuntoCruz.
// #declare RDVM_POV3_1         = off;
//      Valor on activa modo de compatibilidad con POVRay 3.1.
//      En algunas versiones se activara automaticamente.
// #declare RDVM_DefaultTexturaCuentaBasica     = texture ...
//      Define una textura default para las bolitas del rosario.
// #declare RDVM_DefaultTexturaMetalica         = texture ...
//      Define una textura metalica para las cadenas y la decoracion
//      de las bolitas del rosario.
// #declare RDVM_DefaultTexturaMadera           = texture ...
//      Textura default para el triangulo que cierra el rosario.
// #declare RDVM_DefaultMaterialCruz            = material ...
//      Define un material default a aplicar en el crucifijo principal.
// #declare RDVM_DefaultMaterialCruz2           = material ...
//      Define un material default a aplicar en el crucifijo que decora
//      el triangulo de madera.
// #declare RDVM_DefaultTexturaMedalla          = texture ...
//      Define una textura default a aplicar en el circulo de fondo
//      del crucifijo en el triangulo de madera.
//
// Para colocarlo simplemente
// #include "RDVM.inc"
// object { RDVM_Rosario() }
//
// Con la macro de texturas
// #include "RDVM.inc"
// object {
//   RDVM_RosarioDevocionVirgenMaria( 5065, 1.0, 1.0, 30,
//     RDVM_DefaultTexturaCuentaBasica,
//     RDVM_DefaultTexturaMetalica,
//     RDVM_DefaultTexturaMadera,
//     RDVM_DefaultMaterialCruz,
//     RDVM_DefaultMaterialCruz2,
//     RDVM_DefaultTexturaMedalla
//   )
// }
//
// Otro ejemplo con modificador
// #include "RDVM.inc"
// #declare RDVM_DefaultTexturaMetalica         = texture       {
//   average
//   texture_map        {
//     [ 0.5 RDVM_Rust                          ]
//     [ 0.5 RDVM_TexturaMetalica               ]
//   }
// }
// object       { RDVM_Rosario() }
//

#include "colors.inc"

#declare OjoAbsoluto            = 256;
#declare VecesCentroAbsoluto    = 10;     
#declare L                      = 0.001;
camera {
        location  <   0,  0, -( VecesCentroAbsoluto+1 )*OjoAbsoluto >*L
        direction z
        sky       y
        angle     38.74
//        look_at  <   0,  0, -VecesCentroAbsoluto*OjoAbsoluto >*L
}         
light_source    {
         < 500  , 500   , -3000 >*L
         White
}
background      {
         Gray50
}    

#include "RDVM.inc"

#local   FactorAcercamiento             = 2.0;

object          {
  RDVM_Rosario()
  translate       -( VecesCentroAbsoluto+1 )
         *( FactorAcercamiento-1 )/( FactorAcercamiento )*OjoAbsoluto*L*z
}


